// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
	endif
	return this
endfunction

function A_init takes integer this returns nothing
endfunction

function construct_A takes integer this, integer i returns nothing
	call A_init(this)
endfunction

function new_A takes integer i returns integer
	local integer this = alloc_A()
	call construct_A(this, i)
	return this
endfunction

function init_test takes nothing returns nothing
	call new_A(1)
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

