// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_x
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
	endif
	return this
endfunction

function A_init takes integer this returns nothing
	set A_x[this] = 1
endfunction

function construct_A takes integer this, integer x returns nothing
	call A_init(this)
	set A_x[this] = x
endfunction

function new_A takes integer x returns integer
	local integer this = alloc_A()
	call construct_A(this, x)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer i = new_A(42)
	local integer j = new_A(43)
	if A_x[2 * i + j - j - i] == 42 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

