// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer test_x=0
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function destroyA takes integer this returns nothing
	set test_x = (test_x + 1) * 2
	if B_typeId[this] == 0 then
		call error("Double free: object of type A")
	else
		set B_nextFree[B_firstFree] = this
		set B_firstFree = B_firstFree + 1
		set B_typeId[this] = 0
	endif
endfunction

function new_X takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 3
		else
			call error("Out of memory: Could not create X.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 3
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer a
	set test_x = 2
	set a = new_X()
	if B_typeId[a] == 0 then
		if a == 0 then
			call error("Nullpointer exception when calling A.A")
		else
			call error("Called A.A on invalid object.")
		endif
	endif
	call destroyA(a)
	if test_x == 6 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

