// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer test_x=0
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function destroyA takes integer this returns nothing
	local integer obj
	set test_x = test_x + 1
	set test_x = test_x * 2
	set obj = this
	if B_typeId[obj] == 0 then
		call error("Double free: object of type A")
	else
		set B_nextFree[B_firstFree] = obj
		set B_firstFree = B_firstFree + 1
		set B_typeId[obj] = 0
	endif
endfunction

function new_A takes nothing returns integer
	local integer this
	local integer this_1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this_1 = B_maxIndex
			set B_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create A.")
			set this_1 = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this_1 = B_nextFree[B_firstFree]
		set B_typeId[this_1] = 2
	endif
	set this = this_1
	return this
endfunction

function init_test takes nothing returns nothing
	local integer a
	local integer this
	set test_x = 2
	set a = new_A()
	set this = a
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.A")
		else
			call error("Called A.A on invalid object.")
		endif
	endif
	call destroyA(this)
	if test_x == 6 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

