// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer test_x=0
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function destroyX takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set test_x = (test_x + 1) * 2
	set wurst_stack[wurst_stack_depth] = "when calling dealloc_X in ondestroy_withVar, line 12"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_typeId[this] == 0 then
		call error("Double free: object of type X", "when calling error in ondestroy_withVar, line 12")
	else
		set B_nextFree[B_firstFree] = this
		set B_firstFree = B_firstFree + 1
		set B_typeId[this] = 0
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
endfunction

function new_X takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_X in ondestroy_withVar, line 12"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 3
		else
			call error("Out of memory: Could not create X.", "when calling error in ondestroy_withVar, line 12")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer a
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set test_x = 2
	set a = new_X("when calling new_X in ondestroy_withVar, line 14")
	set wurst_stack[wurst_stack_depth] = "when calling dispatch_X_destroyX in ondestroy_withVar, line 15"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_typeId[a] == 0 then
		if a == 0 then
			call error("Nullpointer exception when calling X.X", "when calling error in ondestroy_withVar, line 12")
		else
			call error("Called X.X on invalid object.", "when calling error in ondestroy_withVar, line 12")
		endif
	endif
	call destroyX(a, "when calling destroyX in ondestroy_withVar, line 12")
	set wurst_stack_depth = wurst_stack_depth - 1
	if test_x == 6 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in ondestroy_withVar, line 1")
endfunction

function config takes nothing returns nothing
endfunction

