// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_a_0
integer array A_a_1
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function A_a_get takes integer index1, integer index2 returns integer
	local integer returnVal
	if index2 < 0 or index2 >= 2 then
		call error("Index out of Bounds")
	elseif index2 <= 0 then
		set returnVal = A_a_0[index1]
	else
		set returnVal = A_a_1[index1]
	endif
	return returnVal
endfunction

function initGlobals takes nothing returns nothing
endfunction

function A_a_set takes integer instanceId, integer arrayIndex, integer value returns nothing
	if arrayIndex < 0 or arrayIndex >= 2 then
		call error("Index out of Bounds")
	elseif arrayIndex <= 0 then
		set A_a_0[instanceId] = value
	else
		set A_a_1[instanceId] = value
	endif
endfunction

function new_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
	endif
	call A_a_set(this, 0, 1)
	call A_a_set(this, 1, 2)
	return this
endfunction

function main takes nothing returns nothing
	local integer a
	call initGlobals()
	set a = new_A()
	if A_a_get(a, 0) == 1 and A_a_get(a, 1) == 2 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

