// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer wurst_stack_depth=0
string array wurst_stack
integer array A_ints_0
integer array A_ints_1
integer array A_ints_2
integer array A_ints_3
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function A_ints_get takes integer index1, integer index2, string stackPos returns integer
	local integer returnVal
	if index2 < 0 or index2 >= 4 then
		call error("Index out of Bounds", stackPos)
	elseif index2 <= 1 then
		if index2 <= 0 then
			set returnVal = A_ints_0[index1]
		else
			set returnVal = A_ints_1[index1]
		endif
	elseif index2 <= 2 then
		set returnVal = A_ints_2[index1]
	else
		set returnVal = A_ints_3[index1]
	endif
	return returnVal
endfunction

function A_ints_set takes integer instanceId, integer arrayIndex, integer value, string stackPos returns nothing
	if arrayIndex < 0 or arrayIndex >= 4 then
		call error("Index out of Bounds", stackPos)
	elseif arrayIndex <= 1 then
		if arrayIndex <= 0 then
			set A_ints_0[instanceId] = value
		else
			set A_ints_1[instanceId] = value
		endif
	elseif arrayIndex <= 2 then
		set A_ints_2[instanceId] = value
	else
		set A_ints_3[instanceId] = value
	endif
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling new_A in arrayAttributeTest1, line 8"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_A in arrayAttributeTest1, line 5"
	set wurst_stack_depth = wurst_stack_depth + 1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
		else
			call error("Out of memory: Could not create A.", "when calling error in arrayAttributeTest1, line 5")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	call A_ints_set(this, 0, 1234, "when writing array A_ints in arrayAttributeTest1, line 9")
	if A_ints_get(this, 0, "when reading array A_ints in  in arrayAttributeTest1, line 10") == 1234 then
		call testSuccess()
	else
		call testFail("wrong value")
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in arrayAttributeTest1, line 1")
endfunction

function config takes nothing returns nothing
endfunction

