// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
integer array A_b
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_test_A_get takes integer this returns integer
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.get")
		else
			call error("Called A.get on invalid object.")
		endif
	endif
	set this = A_b[this]
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.get")
		else
			call error("Called B.get on invalid object.")
		endif
	endif
	return 1
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_B takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	return this
endfunction

function new_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 1
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 1
	endif
	set A_b[this] = new_B()
	return this
endfunction

function main takes nothing returns nothing
	call initGlobals()
	if dispatch_A_test_A_get(new_A()) == 1 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

