// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set A_firstFree = 0
	set A_maxIndex = 0
endfunction

function A_foo takes integer this returns integer
	return 7
endfunction

function B_foo takes integer this returns integer
	return 8
endfunction

function C_foo takes integer this returns integer
	return 9
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_test_A_foo takes integer this returns integer
	local integer test_A_foo_result
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo")
		else
			call error("Called A.foo on invalid object.")
		endif
	endif
	if A_typeId[this] <= 6 then
		if A_typeId[this] <= 1 then
			set test_A_foo_result = A_foo(this)
		else
			set test_A_foo_result = B_foo(this)
		endif
	else
		set test_A_foo_result = C_foo(this)
	endif
	return test_A_foo_result
endfunction

function alloc_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 1
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 1
	endif
	return this
endfunction

function A_init takes integer this returns nothing
endfunction

function construct_A takes integer this returns nothing
	call A_init(this)
endfunction

function new_A takes nothing returns integer
	local integer this = alloc_A()
	call construct_A(this)
	return this
endfunction

function alloc_B11 takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 4
		else
			call error("Out of memory: Could not create B11.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 4
	endif
	return this
endfunction

function B11_init takes integer this returns nothing
endfunction

function B1_init takes integer this returns nothing
endfunction

function B_init takes integer this returns nothing
endfunction

function construct_B takes integer this returns nothing
	call construct_A(this)
	call B_init(this)
endfunction

function construct_B1 takes integer this returns nothing
	call construct_B(this)
	call B1_init(this)
endfunction

function construct_B11 takes integer this returns nothing
	call construct_B1(this)
	call B11_init(this)
endfunction

function new_B11 takes nothing returns integer
	local integer this = alloc_B11()
	call construct_B11(this)
	return this
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 7
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 7
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call construct_A(this)
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function alloc_C11 takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 9
		else
			call error("Out of memory: Could not create C11.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 9
	endif
	return this
endfunction

function C11_init takes integer this returns nothing
endfunction

function C1_init takes integer this returns nothing
endfunction

function construct_C1 takes integer this returns nothing
	call construct_C(this)
	call C1_init(this)
endfunction

function construct_C11 takes integer this returns nothing
	call construct_C1(this)
	call C11_init(this)
endfunction

function new_C11 takes nothing returns integer
	local integer this = alloc_C11()
	call construct_C11(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer a = new_C11()
	if dispatch_A_test_A_foo(a) != 9 then
		call testFail("c11")
	endif
	set a = new_B11()
	if dispatch_A_test_A_foo(a) != 8 then
		call testFail("b11")
	endif
	set a = new_C()
	if dispatch_A_test_A_foo(a) != 9 then
		call testFail("C")
	endif
	set a = new_A()
	if dispatch_A_test_A_foo(a) != 7 then
		call testFail("A")
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

