// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_test_A_foo takes integer this returns integer
	local integer test_A_foo_result
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo")
		else
			call error("Called A.foo on invalid object.")
		endif
	endif
	if A_typeId[this] <= 1 then
		set test_A_foo_result = 7
	else
		set test_A_foo_result = 8
	endif
	return test_A_foo_result
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 3
	endif
	set this = this_1
	set this_2 = this
	return this
endfunction

function main takes nothing returns nothing
	local integer c
	call initGlobals()
	set c = new_C()
	if dispatch_A_test_A_foo(c) == 8 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

