// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_x
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set B_firstFree = 0
	set B_maxIndex = 0
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_B takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
	endif
	return this
endfunction

function B_init takes integer this returns nothing
	set B_x[this] = 5
endfunction

function construct_B takes integer this returns nothing
	call B_init(this)
endfunction

function new_B takes nothing returns integer
	local integer this = alloc_B()
	call construct_B(this)
	return this
endfunction

function A_b takes nothing returns integer
	return new_B()
endfunction

function init_test takes nothing returns nothing
	local integer a = A_b()
	if B_x[a] == 5 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

