// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_B takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	return this
endfunction

function A_M_bar takes integer this returns integer
	set this = new_B()
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.foo")
		else
			call error("Called B.foo on invalid object.")
		endif
	endif
	return 42
endfunction

function new_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 1
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 1
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer this = new_A()
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.bar")
		else
			call error("Called A.bar on invalid object.")
		endif
	endif
	set this = A_M_bar(this)
	if this == 42 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

