// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
integer array A_M_x
integer array B_parent
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_B takes integer parent returns integer
	local integer this
	local integer this_1
	local integer this_2
	local integer parent_1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this_1 = B_maxIndex
			set B_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create B.")
			set this_1 = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this_1 = B_nextFree[B_firstFree]
		set B_typeId[this_1] = 2
	endif
	set this = this_1
	set this_2 = this
	set parent_1 = parent
	set B_parent[this_2] = parent_1
	return this
endfunction

function dispatch_A_test_A_M_bar takes integer this returns integer
	local integer test_A_M_bar_result
	local integer this_1
	local integer b
	local integer this_2
	local integer test_A_M_B_foo_result
	local integer this_3
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.bar")
		else
			call error("Called A.bar on invalid object.")
		endif
	endif
	set this_1 = this
	set b = new_B(this_1)
	set this_2 = b
	if B_typeId[this_2] == 0 then
		if this_2 == 0 then
			call error("Nullpointer exception when calling B.foo")
		else
			call error("Called B.foo on invalid object.")
		endif
	endif
	set this_3 = this_2
	set test_A_M_B_foo_result = A_M_x[B_parent[this_3]]
	set test_A_M_bar_result = test_A_M_B_foo_result
	return test_A_M_bar_result
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_A takes nothing returns integer
	local integer this
	local integer this_1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create A.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 1
	endif
	set this = this_1
	return this
endfunction

function main takes nothing returns nothing
	local integer a
	call initGlobals()
	set a = new_A()
	set A_M_x[a] = a
	if dispatch_A_test_A_M_bar(a) == a then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

