// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set A_firstFree = 0
	set A_maxIndex = 0
	set B_firstFree = 0
	set B_maxIndex = 0
endfunction

function B_foo takes integer this returns integer
	return 4
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_B_test_A_B_foo takes integer this returns integer
	local integer test_A_B_foo_result
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.foo")
		else
			call error("Called B.foo on invalid object.")
		endif
	endif
	set test_A_B_foo_result = B_foo(this)
	return test_A_B_foo_result
endfunction

function alloc_B takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	return this
endfunction

function B_init takes integer this returns nothing
endfunction

function construct_B takes integer this returns nothing
	call B_init(this)
endfunction

function new_B takes nothing returns integer
	local integer this = alloc_B()
	call construct_B(this)
	return this
endfunction

function A_bar takes integer this returns integer
	local integer b = new_B()
	return dispatch_B_test_A_B_foo(b) * 10 + 2
endfunction

function dispatch_A_test_A_bar takes integer this returns integer
	local integer test_A_bar_result
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.bar")
		else
			call error("Called A.bar on invalid object.")
		endif
	endif
	set test_A_bar_result = A_bar(this)
	return test_A_bar_result
endfunction

function alloc_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 1
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 1
	endif
	return this
endfunction

function A_init takes integer this returns nothing
endfunction

function construct_A takes integer this returns nothing
	call A_init(this)
endfunction

function new_A takes nothing returns integer
	local integer this = alloc_A()
	call construct_A(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer i = dispatch_A_test_A_bar(new_A())
	if i == 42 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

