// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer wurst_stack_depth=0
string array wurst_stack
integer array A_b_i_0
integer array A_b_i_1
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function A_b_i_get takes integer index1, integer index2, string stackPos returns integer
	local integer returnVal
	if index2 < 0 or index2 >= 2 then
		call error("Index out of Bounds", stackPos)
	elseif index2 <= 0 then
		set returnVal = A_b_i_0[index1]
	else
		set returnVal = A_b_i_1[index1]
	endif
	return returnVal
endfunction

function A_b_i_set takes integer instanceId, integer arrayIndex, integer value, string stackPos returns nothing
	if arrayIndex < 0 or arrayIndex >= 2 then
		call error("Index out of Bounds", stackPos)
	elseif arrayIndex <= 0 then
		set A_b_i_0[instanceId] = value
	else
		set A_b_i_1[instanceId] = value
	endif
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling new_A in tupleArrayMember, line 7"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_A in tupleArrayMember, line 4"
	set wurst_stack_depth = wurst_stack_depth + 1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
		else
			call error("Out of memory: Could not create A.", "when calling error in tupleArrayMember, line 4")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	call A_b_i_set(this, 0, 4, "when writing array A_b_i in tupleArrayMember, line 8")
	call A_b_i_set(this, 1, 5, "when writing array A_b_i in tupleArrayMember, line 9")
	if A_b_i_get(this, 0, "when reading array A_b_i in  in tupleArrayMember, line 10") == 4 and A_b_i_get(this, 1, "when reading array A_b_i in  in tupleArrayMember, line 10") == 5 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in tupleArrayMember, line 1")
endfunction

function config takes nothing returns nothing
endfunction

