// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Blub_nextFree
integer Blub_firstFree=0
integer Blub_maxIndex=0
integer array Blub_typeId
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array A_x
integer array B_x
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_Blub_callMe_test takes nothing returns integer
	local integer this
	if Blub_firstFree == 0 then
		if Blub_maxIndex < 32768 then
			set Blub_maxIndex = Blub_maxIndex + 1
			set this = Blub_maxIndex
			set Blub_typeId[this] = 4
		else
			call error("Out of memory: Could not create Blub_callMe_test.")
			set this = 0
		endif
	else
		set Blub_firstFree = Blub_firstFree - 1
		set this = Blub_nextFree[Blub_firstFree]
		set Blub_typeId[this] = 4
	endif
	return this
endfunction

function alloc_B takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
	endif
	return this
endfunction

function B_init takes integer this returns nothing
endfunction

function construct_B takes integer this, integer x returns nothing
	call B_init(this)
	set B_x[this] = x
endfunction

function new_B takes integer x returns integer
	local integer this = alloc_B()
	call construct_B(this, x)
	return this
endfunction

function A_foo takes integer this, integer b returns integer
	return new_B(A_x[this] + B_x[b])
endfunction

function dispatch_A_test_A_foo takes integer this, integer b returns integer
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo")
		else
			call error("Called A.foo on invalid object.")
		endif
	endif
	return A_foo(this, b)
endfunction

function foo_callMe_test takes integer this, integer a, integer b returns integer
	return dispatch_A_test_A_foo(a, b)
endfunction

function dispatch_Blub_test_Blub_foo takes integer this, integer t, integer s returns integer
	if Blub_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Blub.foo")
		else
			call error("Called Blub.foo on invalid object.")
		endif
	endif
	return foo_callMe_test(this, t, s)
endfunction

function callMe takes integer t, integer s, integer b returns integer
	return dispatch_Blub_test_Blub_foo(b, t, dispatch_Blub_test_Blub_foo(b, t, s))
endfunction

function alloc_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 1
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 1
	endif
	return this
endfunction

function A_init takes integer this returns nothing
endfunction

function construct_A takes integer this, integer x returns nothing
	call A_init(this)
	set A_x[this] = x
endfunction

function new_A takes integer x returns integer
	local integer this = alloc_A()
	call construct_A(this, x)
	return this
endfunction

function init_test takes nothing returns nothing
	if B_x[callMe(new_A(3), new_B(4), alloc_Blub_callMe_test())] == 10 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

