// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_B_A takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create B_A.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	return this
endfunction

function alloc_B_bar_A takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 3
		else
			call error("Out of memory: Could not create B_bar_A.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 3
	endif
	return this
endfunction

function dealloc_B takes integer obj returns nothing
	if B_typeId[obj] == 0 then
		call error("Double free: object of type B")
	else
		set B_nextFree[B_firstFree] = obj
		set B_firstFree = B_firstFree + 1
		set B_typeId[obj] = 0
	endif
endfunction

function destroyB takes integer this returns nothing
	call dealloc_B(this)
endfunction

function dispatch_B_destroyB takes integer this returns nothing
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.B")
		else
			call error("Called B.B on invalid object.")
		endif
	endif
	call destroyB(this)
endfunction

function bar takes integer b returns nothing
	call dispatch_B_destroyB(b)
endfunction

function init_A takes nothing returns nothing
	call bar(alloc_B_bar_A())
	if alloc_B_A() == 1 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_A()
endfunction

function config takes nothing returns nothing
endfunction

