// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
endglobals
function initGlobals takes nothing returns nothing
endfunction

function C_M_set takes integer this, unit a, real b returns real
	return b
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_C_test_C_M_set takes integer this, unit a, real b returns real
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.set")
		else
			call error("Called C.set on invalid object.")
		endif
	endif
	return C_M_set(this, a, b)
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 1
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 1
	endif
	return this
endfunction

function construct_C_M takes integer this returns nothing
endfunction

function C_init takes integer this returns nothing
	call construct_C_M(this)
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function init_test takes nothing returns nothing
	call dispatch_C_test_C_M_set(new_C(), null, 1.23)
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

