// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array D_nextFree
integer D_firstFree=0
integer D_maxIndex=0
endglobals
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this_1 = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this_1 = C_nextFree[C_firstFree]
	endif
	set this = this_1
	return this
endfunction

function new_D takes nothing returns integer
	local integer this
	local integer this_1
	if D_firstFree == 0 then
		if D_maxIndex < 32768 then
			set D_maxIndex = D_maxIndex + 1
			set this_1 = D_maxIndex
		else
			call error("Out of memory: Could not create D.")
			set this_1 = 0
		endif
	else
		set D_firstFree = D_firstFree - 1
		set this_1 = D_nextFree[D_firstFree]
	endif
	set this = this_1
	return this
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call new_C()
	call new_D()
endfunction

function config takes nothing returns nothing
endfunction

