// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array F_nextFree
integer F_firstFree=0
integer F_maxIndex=0
integer array F_typeId
integer array X_t
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function init_test takes nothing returns nothing
	local integer this
	if F_firstFree == 0 then
		if F_maxIndex < 32768 then
			set F_maxIndex = F_maxIndex + 1
			set this = F_maxIndex
			set F_typeId[this] = 2
		else
			call error("Out of memory: Could not create X.")
			set this = 0
		endif
	else
		set F_firstFree = F_firstFree - 1
		set this = F_nextFree[F_firstFree]
		set F_typeId[this] = 2
	endif
	set X_t[this] = 42
	if F_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling F.get")
		else
			call error("Called F.get on invalid object.")
		endif
	endif
	if X_t[this] == 42 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

