// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array Cell_nextFree
integer Cell_firstFree=0
integer Cell_maxIndex=0
endglobals
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_B takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
	endif
	return this
endfunction

function new_Cell takes nothing returns integer
	local integer this
	if Cell_firstFree == 0 then
		if Cell_maxIndex < 32768 then
			set Cell_maxIndex = Cell_maxIndex + 1
			set this = Cell_maxIndex
		else
			call error("Out of memory: Could not create Cell.")
			set this = 0
		endif
	else
		set Cell_firstFree = Cell_firstFree - 1
		set this = Cell_nextFree[Cell_firstFree]
	endif
	return this
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call new_Cell()
	call new_B()
endfunction

function config takes nothing returns nothing
endfunction

