// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Iterator_nextFree
integer Iterator_firstFree=0
integer Iterator_maxIndex=0
integer array Iterator_typeId
integer array List_nextFree
integer List_firstFree=0
integer List_maxIndex=0
integer array List_typeId
integer array Iterator_t
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function Iterator_hasNext takes integer this returns boolean
	return true
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_Iterator_test_Iterator_hasNext takes integer this returns boolean
	if Iterator_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Iterator.hasNext")
		else
			call error("Called Iterator.hasNext on invalid object.")
		endif
	endif
	return Iterator_hasNext(this)
endfunction

function Iterator_next takes integer this returns integer
	return Iterator_t[this]
endfunction

function dispatch_Iterator_test_Iterator_next takes integer this returns integer
	if Iterator_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Iterator.next")
		else
			call error("Called Iterator.next on invalid object.")
		endif
	endif
	return Iterator_next(this)
endfunction

function alloc_Iterator takes nothing returns integer
	local integer this
	if Iterator_firstFree == 0 then
		if Iterator_maxIndex < 32768 then
			set Iterator_maxIndex = Iterator_maxIndex + 1
			set this = Iterator_maxIndex
			set Iterator_typeId[this] = 4
		else
			call error("Out of memory: Could not create Iterator.")
			set this = 0
		endif
	else
		set Iterator_firstFree = Iterator_firstFree - 1
		set this = Iterator_nextFree[Iterator_firstFree]
		set Iterator_typeId[this] = 4
	endif
	return this
endfunction

function Iterator_init takes integer this returns nothing
endfunction

function construct_Iterator takes integer this, integer t returns nothing
	call Iterator_init(this)
endfunction

function new_Iterator takes integer t returns integer
	local integer this = alloc_Iterator()
	call construct_Iterator(this, t)
	return this
endfunction

function List_iterator takes integer this returns integer
	return new_Iterator(this)
endfunction

function dispatch_List_test_List_iterator takes integer this returns integer
	if List_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling List.iterator")
		else
			call error("Called List.iterator on invalid object.")
		endif
	endif
	return List_iterator(this)
endfunction

function alloc_List takes nothing returns integer
	local integer this
	if List_firstFree == 0 then
		if List_maxIndex < 32768 then
			set List_maxIndex = List_maxIndex + 1
			set this = List_maxIndex
			set List_typeId[this] = 5
		else
			call error("Out of memory: Could not create List.")
			set this = 0
		endif
	else
		set List_firstFree = List_firstFree - 1
		set this = List_nextFree[List_firstFree]
		set List_typeId[this] = 5
	endif
	return this
endfunction

function List_init takes integer this returns nothing
endfunction

function construct_List takes integer this returns nothing
	call List_init(this)
endfunction

function new_List takes nothing returns integer
	local integer this = alloc_List()
	call construct_List(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer iterator = dispatch_List_test_List_iterator(new_List())
	loop
		exitwhen  not dispatch_Iterator_test_Iterator_hasNext(iterator)
		call dispatch_Iterator_test_Iterator_next(iterator)
		call testSuccess()
	endloop
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

