// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
integer array Iterator_nextFree
integer Iterator_firstFree=0
integer Iterator_maxIndex=0
integer array Iterator_i
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this_1 = C_maxIndex
			set C_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this_1 = C_nextFree[C_firstFree]
		set C_typeId[this_1] = 1
	endif
	set this = this_1
	return this
endfunction

function new_Iterator takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	local integer this_3
	if Iterator_firstFree == 0 then
		if Iterator_maxIndex < 32768 then
			set Iterator_maxIndex = Iterator_maxIndex + 1
			set this_1 = Iterator_maxIndex
		else
			call error("Out of memory: Could not create Iterator.")
			set this_1 = 0
		endif
	else
		set Iterator_firstFree = Iterator_firstFree - 1
		set this_1 = Iterator_nextFree[Iterator_firstFree]
	endif
	set this = this_1
	set this_2 = this
	set this_3 = this_2
	set Iterator_i[this_3] = 0
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_C()
	local integer this = c
	local integer iter
	local integer i
	local integer from
	local integer test_C_iterator_result
	local integer this_1
	local integer this_2
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.iterator")
		else
			call error("Called C.iterator on invalid object.")
		endif
	endif
	set test_C_iterator_result = new_Iterator()
	set iter = test_C_iterator_result
	set from = iter
	loop
		set this_1 = from
		exitwhen  not (Iterator_i[this_1] < 10)
		set this_2 = from
		set Iterator_i[this_2] = Iterator_i[this_2] + 1
		set i = Iterator_i[this_2]
		if i == 5 then
			call testSuccess()
		endif
	endloop
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

