// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer C_firstFree=0
integer C_maxIndex=0
integer array Iterator_nextFree
integer Iterator_firstFree=0
integer Iterator_maxIndex=0
integer array Iterator_typeId
integer array Iterator_i
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_Iterator_destroyIterator takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if Iterator_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Iterator.Iterator", "when calling error in genericForIn, line 6")
		else
			call error("Called Iterator.Iterator on invalid object.", "when calling error in genericForIn, line 6")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling destroyIterator in genericForIn, line 6"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling dealloc_Iterator in genericForIn, line 6"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Iterator_typeId[this] == 0 then
		call error("Double free: object of type Iterator", "when calling error in genericForIn, line 6")
	else
		set Iterator_nextFree[Iterator_firstFree] = this
		set Iterator_firstFree = Iterator_firstFree + 1
		set Iterator_typeId[this] = 0
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
endfunction

function new_Iterator takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_Iterator in genericForIn, line 6"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Iterator_firstFree == 0 then
		if Iterator_maxIndex < 32768 then
			set Iterator_maxIndex = Iterator_maxIndex + 1
			set this = Iterator_maxIndex
			set Iterator_typeId[this] = 2
		else
			call error("Out of memory: Could not create Iterator.", "when calling error in genericForIn, line 6")
			set this = 0
		endif
	else
		set Iterator_firstFree = Iterator_firstFree - 1
		set this = Iterator_nextFree[Iterator_firstFree]
		set Iterator_typeId[this] = 2
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	set Iterator_i[this] = 0
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling new_C in genericForIn, line 16"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in genericForIn, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
		else
			call error("Out of memory: Could not create C.", "when calling error in genericForIn, line 3")
		endif
	else
		set C_firstFree = C_firstFree - 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	set wurst_stack[wurst_stack_depth] = "when calling iterator in genericForIn, line 17"
	set wurst_stack_depth = wurst_stack_depth + 1
	set this = new_Iterator("when calling new_Iterator in genericForIn, line 5")
	set wurst_stack_depth = wurst_stack_depth - 1
	loop
		exitwhen Iterator_i[this] >= 10
		set Iterator_i[this] = Iterator_i[this] + 1
		if Iterator_i[this] == 5 then
			call testSuccess()
		endif
	endloop
	set wurst_stack[wurst_stack_depth] = "when calling close in genericForIn, line 17"
	set wurst_stack_depth = wurst_stack_depth + 1
	call dispatch_Iterator_destroyIterator(this, "when calling dispatch_Iterator_destroyIterator in genericForIn, line 14")
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in genericForIn, line 1")
endfunction

function config takes nothing returns nothing
endfunction

