// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array Cell_nextFree
integer Cell_firstFree=0
integer Cell_maxIndex=0
integer array Cell_o
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_Test_A_foo takes integer this returns integer
	local integer Test_A_foo_result
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo")
		else
			call error("Called A.foo on invalid object.")
		endif
	endif
	if A_typeId[this] <= 1 then
		set Test_A_foo_result = 5
	else
		set Test_A_foo_result = 6
	endif
	return Test_A_foo_result
endfunction

function new_B takes nothing returns integer
	local integer this
	local integer this_1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create B.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 2
	endif
	set this = this_1
	return this
endfunction

function new_Cell takes nothing returns integer
	local integer this
	local integer this_1
	if Cell_firstFree == 0 then
		if Cell_maxIndex < 32768 then
			set Cell_maxIndex = Cell_maxIndex + 1
			set this_1 = Cell_maxIndex
		else
			call error("Out of memory: Could not create Cell.")
			set this_1 = 0
		endif
	else
		set Cell_firstFree = Cell_firstFree - 1
		set this_1 = Cell_nextFree[Cell_firstFree]
	endif
	set this = this_1
	return this
endfunction

function init_Test takes nothing returns nothing
	local integer c = new_Cell()
	set Cell_o[c] = new_B()
	if dispatch_A_Test_A_foo(Cell_o[c]) == 6 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

