// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
endglobals
function initGlobals takes nothing returns nothing
endfunction

function A_bla takes integer this, integer t returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_Test_A_bla takes integer this, integer t returns nothing
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.bla")
		else
			call error("Called A.bla on invalid object.")
		endif
	endif
	call A_bla(this, t)
endfunction

function alloc_B takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 2
	endif
	return this
endfunction

function B_init takes integer this returns nothing
endfunction

function A_init takes integer this returns nothing
endfunction

function construct_A takes integer this returns nothing
	call A_init(this)
endfunction

function construct_B takes integer this returns nothing
	call construct_A(this)
	call B_init(this)
endfunction

function new_B takes nothing returns integer
	local integer this = alloc_B()
	call construct_B(this)
	return this
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function init_Test takes nothing returns nothing
	call dispatch_A_Test_A_bla(new_B(), new_C())
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

