// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array FoldClosure_nextFree
integer FoldClosure_firstFree=0
integer FoldClosure_maxIndex=0
integer array FoldClosure_typeId
integer array Cell_nextFree
integer Cell_firstFree=0
integer Cell_maxIndex=0
integer array Cell_typeId
integer array Cell_elem
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_FoldClosure_test_FoldClosure_apply takes integer this, integer t, integer q returns integer
	if FoldClosure_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling FoldClosure.apply")
		else
			call error("Called FoldClosure.apply on invalid object.")
		endif
	endif
	return t + q
endfunction

function new_Cell takes nothing returns integer
	local integer this
	if Cell_firstFree == 0 then
		if Cell_maxIndex < 32768 then
			set Cell_maxIndex = Cell_maxIndex + 1
			set this = Cell_maxIndex
			set Cell_typeId[this] = 1
		else
			call error("Out of memory: Could not create Cell.")
			set this = 0
		endif
	else
		set Cell_firstFree = Cell_firstFree - 1
		set this = Cell_nextFree[Cell_firstFree]
		set Cell_typeId[this] = 1
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_Cell()
	local integer this
	if Cell_typeId[c] == 0 then
		if c == 0 then
			call error("Nullpointer exception when calling Cell.set")
		else
			call error("Called Cell.set on invalid object.")
		endif
	endif
	set Cell_elem[c] = 5
	if FoldClosure_firstFree == 0 then
		if FoldClosure_maxIndex < 32768 then
			set FoldClosure_maxIndex = FoldClosure_maxIndex + 1
			set this = FoldClosure_maxIndex
			set FoldClosure_typeId[this] = 3
		else
			call error("Out of memory: Could not create FoldClosure_fold_test.")
			set this = 0
		endif
	else
		set FoldClosure_firstFree = FoldClosure_firstFree - 1
		set this = FoldClosure_nextFree[FoldClosure_firstFree]
		set FoldClosure_typeId[this] = 3
	endif
	if Cell_typeId[c] == 0 then
		if c == 0 then
			call error("Nullpointer exception when calling Cell.fold")
		else
			call error("Called Cell.fold on invalid object.")
		endif
	endif
	if dispatch_FoldClosure_test_FoldClosure_apply(this, Cell_elem[c], 2) == 7 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

