// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Cell_nextFree
integer Cell_firstFree=0
integer Cell_maxIndex=0
integer array Cell_typeId
integer array Cell_elem
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_Cell takes nothing returns integer
	local integer this
	local integer this_1
	if Cell_firstFree == 0 then
		if Cell_maxIndex < 32768 then
			set Cell_maxIndex = Cell_maxIndex + 1
			set this_1 = Cell_maxIndex
			set Cell_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create Cell.")
			set this_1 = 0
		endif
	else
		set Cell_firstFree = Cell_firstFree - 1
		set this_1 = Cell_nextFree[Cell_firstFree]
		set Cell_typeId[this_1] = 1
	endif
	set this = this_1
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_Cell()
	local integer this = c
	local integer tuple_temp = 5
	local integer b_z = tuple_temp
	local integer t = b_z
	local integer this_1
	local integer t_1
	local integer i
	local integer this_2
	local integer test_Cell_get_result
	local integer this_3
	if Cell_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Cell.set")
		else
			call error("Called Cell.set on invalid object.")
		endif
	endif
	set this_1 = this
	set t_1 = t
	set Cell_elem[this_1] = t_1
	set this_2 = c
	if Cell_typeId[this_2] == 0 then
		if this_2 == 0 then
			call error("Nullpointer exception when calling Cell.get")
		else
			call error("Called Cell.get on invalid object.")
		endif
	endif
	set this_3 = this_2
	set test_Cell_get_result = Cell_elem[this_3]
	set i = test_Cell_get_result
	if i == 5 and 2 == 2 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

