// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Cell_nextFree
integer Cell_firstFree=0
integer Cell_maxIndex=0
integer array Cell_typeId
integer array Cell_elem
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_Cell takes nothing returns integer
	local integer this
	if Cell_firstFree == 0 then
		if Cell_maxIndex < 32768 then
			set Cell_maxIndex = Cell_maxIndex + 1
			set this = Cell_maxIndex
			set Cell_typeId[this] = 1
		else
			call error("Out of memory: Could not create Cell.")
			set this = 0
		endif
	else
		set Cell_firstFree = Cell_firstFree - 1
		set this = Cell_nextFree[Cell_firstFree]
		set Cell_typeId[this] = 1
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_Cell()
	if Cell_typeId[c] == 0 then
		if c == 0 then
			call error("Nullpointer exception when calling Cell.set")
		else
			call error("Called Cell.set on invalid object.")
		endif
	endif
	set Cell_elem[c] = 5
	if Cell_typeId[c] == 0 then
		if c == 0 then
			call error("Nullpointer exception when calling Cell.get")
		else
			call error("Called Cell.get on invalid object.")
		endif
	endif
	if Cell_elem[c] == 5 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

