// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Cell_nextFree
integer Cell_firstFree=0
integer Cell_maxIndex=0
integer array Cell_typeId
integer array Cell_elem
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function new_Cell takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_Cell in implicitConversions, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Cell_firstFree == 0 then
		if Cell_maxIndex < 32768 then
			set Cell_maxIndex = Cell_maxIndex + 1
			set this = Cell_maxIndex
			set Cell_typeId[this] = 1
		else
			call error("Out of memory: Could not create Cell.", "when calling error in implicitConversions, line 3")
			set this = 0
		endif
	else
		set Cell_firstFree = Cell_firstFree - 1
		set this = Cell_nextFree[Cell_firstFree]
		set Cell_typeId[this] = 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer c
	local integer test_Cell_get_result
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set c = new_Cell("when calling new_Cell in implicitConversions, line 16")
	set wurst_stack[wurst_stack_depth] = "when calling set in implicitConversions, line 17"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Cell_typeId[c] == 0 then
		if c == 0 then
			call error("Nullpointer exception when calling Cell.set", "when calling error in implicitConversions, line 5")
		else
			call error("Called Cell.set on invalid object.", "when calling error in implicitConversions, line 5")
		endif
	endif
	set Cell_elem[c] = 5
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling get in implicitConversions, line 18"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Cell_typeId[c] == 0 then
		if c == 0 then
			call error("Nullpointer exception when calling Cell.get", "when calling error in implicitConversions, line 7")
		else
			call error("Called Cell.get on invalid object.", "when calling error in implicitConversions, line 7")
		endif
	endif
	set test_Cell_get_result = Cell_elem[c]
	set wurst_stack_depth = wurst_stack_depth - 1
	if test_Cell_get_result == 5 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in implicitConversions, line 1")
endfunction

function config takes nothing returns nothing
endfunction

