// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array FoldClosure_nextFree
integer FoldClosure_firstFree=0
integer FoldClosure_maxIndex=0
integer array LinkedList_nextFree
integer LinkedList_firstFree=0
integer LinkedList_maxIndex=0
integer array LinkedList_typeId
endglobals
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_LinkedList takes nothing returns integer
	local integer this
	local integer this_1
	if LinkedList_firstFree == 0 then
		if LinkedList_maxIndex < 32768 then
			set LinkedList_maxIndex = LinkedList_maxIndex + 1
			set this_1 = LinkedList_maxIndex
			set LinkedList_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create LinkedList.")
			set this_1 = 0
		endif
	else
		set LinkedList_firstFree = LinkedList_firstFree - 1
		set this_1 = LinkedList_nextFree[LinkedList_firstFree]
		set LinkedList_typeId[this_1] = 3
	endif
	set this = this_1
	return this
endfunction

function init_test takes nothing returns nothing
	local integer x = new_LinkedList()
	local integer temp = x
	local integer this
	local integer this_1
	if FoldClosure_firstFree == 0 then
		if FoldClosure_maxIndex < 32768 then
			set FoldClosure_maxIndex = FoldClosure_maxIndex + 1
			set this = FoldClosure_maxIndex
		else
			call error("Out of memory: Could not create FoldClosure_foldl_test.")
			set this = 0
		endif
	else
		set FoldClosure_firstFree = FoldClosure_firstFree - 1
		set this = FoldClosure_nextFree[FoldClosure_firstFree]
	endif
	set this_1 = temp
	if LinkedList_typeId[this_1] == 0 then
		if this_1 == 0 then
			call error("Nullpointer exception when calling LinkedList.foldl")
		else
			call error("Called LinkedList.foldl on invalid object.")
		endif
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

