// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer FoldClosure_firstFree=0
integer FoldClosure_maxIndex=0
integer array LinkedList_nextFree
integer LinkedList_firstFree=0
integer LinkedList_maxIndex=0
integer array LinkedList_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function new_LinkedList takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_LinkedList in strangeFoldl, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	if LinkedList_firstFree == 0 then
		if LinkedList_maxIndex < 32768 then
			set LinkedList_maxIndex = LinkedList_maxIndex + 1
			set this = LinkedList_maxIndex
			set LinkedList_typeId[this] = 3
		else
			call error("Out of memory: Could not create LinkedList.", "when calling error in strangeFoldl, line 3")
			set this = 0
		endif
	else
		set LinkedList_firstFree = LinkedList_firstFree - 1
		set this = LinkedList_nextFree[LinkedList_firstFree]
		set LinkedList_typeId[this] = 3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer x
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set x = new_LinkedList("when calling new_LinkedList in strangeFoldl, line 10")
	set wurst_stack[wurst_stack_depth] = "when calling alloc_FoldClosure_foldl_test in strangeFoldl, line 11"
	set wurst_stack_depth = wurst_stack_depth + 1
	if FoldClosure_firstFree == 0 then
		if FoldClosure_maxIndex < 32768 then
			set FoldClosure_maxIndex = FoldClosure_maxIndex + 1
		else
			call error("Out of memory: Could not create FoldClosure_foldl_test.", "when calling error in strangeFoldl, line 11")
		endif
	else
		set FoldClosure_firstFree = FoldClosure_firstFree - 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling foldl in strangeFoldl, line 11"
	set wurst_stack_depth = wurst_stack_depth + 1
	if LinkedList_typeId[x] == 0 then
		if x == 0 then
			call error("Nullpointer exception when calling LinkedList.foldl", "when calling error in strangeFoldl, line 5")
		else
			call error("Called LinkedList.foldl on invalid object.", "when calling error in strangeFoldl, line 5")
		endif
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in strangeFoldl, line 1")
endfunction

function config takes nothing returns nothing
endfunction

