// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_I_test_I_foo takes integer this returns integer
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling I.foo")
		else
			call error("Called I.foo on invalid object.")
		endif
	endif
	if I_typeId[this] <= 2 then
		if I_typeId[this] <= 1 then
			set this = 5
		else
			set this = 2
		endif
	elseif I_typeId[this] <= 3 then
		set this = 5
	else
		set this = 3
	endif
	return this
endfunction

function new_B takes nothing returns integer
	local integer this
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 2
	endif
	return this
endfunction

function new_C takes nothing returns integer
	local integer this
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 3
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 3
	endif
	return this
endfunction

function new_D takes nothing returns integer
	local integer this
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 4
		else
			call error("Out of memory: Could not create D.")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 4
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer b = new_B()
	local integer c = new_C()
	local integer d = new_D()
	local boolean andLeft
	if I_typeId[b] == 0 then
		if b == 0 then
			call error("Nullpointer exception when calling B.foo")
		else
			call error("Called B.foo on invalid object.")
		endif
	endif
	if dispatch_I_test_I_foo(c) == 5 then
		if I_typeId[d] == 0 then
			if d == 0 then
				call error("Nullpointer exception when calling D.foo")
			else
				call error("Called D.foo on invalid object.")
			endif
		endif
		set andLeft = true
	else
		set andLeft = false
	endif
	if andLeft then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

