// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_B takes nothing returns integer
	local integer this
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 2
	endif
	return this
endfunction

function B_init takes integer this returns nothing
endfunction

function construct_B takes integer this returns nothing
	call B_init(this)
endfunction

function new_B takes nothing returns integer
	local integer this = alloc_B()
	call construct_B(this)
	return this
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 3
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 3
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function B_foo takes integer this returns integer
	return 2
endfunction

function C_foo takes integer this returns integer
	return 3
endfunction

function dispatch_I_test_I_foo takes integer this returns integer
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling I.foo")
		else
			call error("Called I.foo on invalid object.")
		endif
	endif
	if I_typeId[this] <= 2 then
		set this = B_foo(this)
	else
		set this = C_foo(this)
	endif
	return this
endfunction

function test takes integer i1, integer i2 returns nothing
	if dispatch_I_test_I_foo(i1) == 2 and dispatch_I_test_I_foo(i2) == 3 then
		call testSuccess()
	endif
endfunction

function init_test takes nothing returns nothing
	call test(new_B(), new_C())
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

