// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_I_test_I_foo takes integer this returns integer
	local integer test_I_foo_result
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling I.foo")
		else
			call error("Called I.foo on invalid object.")
		endif
	endif
	if I_typeId[this] <= 2 then
		set test_I_foo_result = 2
	else
		set test_I_foo_result = 3
	endif
	return test_I_foo_result
endfunction

function new_B takes nothing returns integer
	local integer this
	local integer this_1
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this_1 = I_maxIndex
			set I_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create B.")
			set this_1 = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this_1 = I_nextFree[I_firstFree]
		set I_typeId[this_1] = 2
	endif
	set this = this_1
	return this
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this_1 = I_maxIndex
			set I_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this_1 = I_nextFree[I_firstFree]
		set I_typeId[this_1] = 3
	endif
	set this = this_1
	return this
endfunction

function test takes boolean b returns integer
	if b then
		return new_B()
	else
		return new_C()
	endif
endfunction

function init_test takes nothing returns nothing
	local integer i1 = test(true)
	if dispatch_I_test_I_foo(i1) == 2 and dispatch_I_test_I_foo(test(false)) == 3 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

