// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 3
	endif
	set this = this_1
	return this
endfunction

function init_test takes nothing returns nothing
	local integer b = new_C()
	local integer a = b
	local integer this = a
	local integer test_A_f1_result
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.f1")
		else
			call error("Called A.f1 on invalid object.")
		endif
	endif
	set test_A_f1_result = 3
	if test_A_f1_result == 3 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

