// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_I_test_I_foo takes integer this, string w__wurst_stackPos returns integer
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling I.foo", "when calling error in simple, line 4")
		else
			call error("Called I.foo on invalid object.", "when calling error in simple, line 4")
		endif
	endif
	if I_typeId[this] <= 2 then
		set this = 2
	else
		set this = 3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function new_B takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_B in simple, line 5"
	set wurst_stack_depth = wurst_stack_depth + 1
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.", "when calling error in simple, line 5")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 2
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function new_C takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in simple, line 8"
	set wurst_stack_depth = wurst_stack_depth + 1
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 3
		else
			call error("Out of memory: Could not create C.", "when calling error in simple, line 8")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer i1
	local integer i2
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set i1 = new_B("when calling new_B in simple, line 12")
	set i2 = new_C("when calling new_C in simple, line 13")
	if dispatch_I_test_I_foo(i1, "when calling foo in simple, line 14") == 2 and dispatch_I_test_I_foo(i2, "when calling foo in simple, line 14") == 3 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in simple, line 1")
endfunction

function config takes nothing returns nothing
endfunction

