// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testFail takes string s returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_A_test_A_foo takes integer this, string w__wurst_stackPos returns integer
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo", "when calling error in twoInterfaces, line 5")
		else
			call error("Called A.foo on invalid object.", "when calling error in twoInterfaces, line 5")
		endif
	endif
	if B_typeId[this] <= 2 then
		set this = 1
	else
		set this = 2
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function dispatch_B_test_B_bar takes integer this, string w__wurst_stackPos returns integer
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.bar", "when calling error in twoInterfaces, line 7")
		else
			call error("Called B.bar on invalid object.", "when calling error in twoInterfaces, line 7")
		endif
	endif
	if B_typeId[this] <= 2 then
		set this = 3
	else
		set this = 4
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function new_C takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in twoInterfaces, line 8"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create C.", "when calling error in twoInterfaces, line 8")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function new_D takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_D in twoInterfaces, line 13"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 3
		else
			call error("Out of memory: Could not create D.", "when calling error in twoInterfaces, line 13")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer x1
	local integer x2
	local integer x3
	local integer x4
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set x1 = new_C("when calling new_C in twoInterfaces, line 19")
	set x2 = new_D("when calling new_D in twoInterfaces, line 20")
	set x3 = new_C("when calling new_C in twoInterfaces, line 21")
	set x4 = new_D("when calling new_D in twoInterfaces, line 22")
	if dispatch_A_test_A_foo(x1, "when calling foo in twoInterfaces, line 23") != 1 then
		call testFail("1")
	endif
	if dispatch_A_test_A_foo(x2, "when calling foo in twoInterfaces, line 25") != 2 then
		call testFail("2")
	endif
	if dispatch_B_test_B_bar(x3, "when calling bar in twoInterfaces, line 27") != 3 then
		call testFail("3")
	endif
	if dispatch_B_test_B_bar(x4, "when calling bar in twoInterfaces, line 29") != 4 then
		call testFail("4")
	endif
	call testSuccess()
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in twoInterfaces, line 1")
endfunction

function config takes nothing returns nothing
endfunction

