// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Collection_nextFree
integer Collection_firstFree=0
integer Collection_maxIndex=0
integer array Collection_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_Set takes nothing returns integer
	local integer this
	if Collection_firstFree == 0 then
		if Collection_maxIndex < 32768 then
			set Collection_maxIndex = Collection_maxIndex + 1
			set this = Collection_maxIndex
			set Collection_typeId[this] = 2
		else
			call error("Out of memory: Could not create Set.")
			set this = 0
		endif
	else
		set Collection_firstFree = Collection_firstFree - 1
		set this = Collection_nextFree[Collection_firstFree]
		set Collection_typeId[this] = 2
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_Set()
	if Collection_typeId[c] == 0 then
		if c == 0 then
			call error("Nullpointer exception when calling Collection.contains")
		else
			call error("Called Collection.contains on invalid object.")
		endif
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

