// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array D_nextFree
integer D_firstFree=0
integer D_maxIndex=0
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set I_firstFree = 0
	set I_maxIndex = 0
	set B_firstFree = 0
	set B_maxIndex = 0
	set C_firstFree = 0
	set C_maxIndex = 0
	set D_firstFree = 0
	set D_maxIndex = 0
endfunction

function A_test takes integer this, integer b, integer y, integer x returns boolean
	return true
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_I_test_I_test takes integer this, integer s, integer t, integer v returns boolean
	local boolean test_I_test_result
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling I.test")
		else
			call error("Called I.test on invalid object.")
		endif
	endif
	set test_I_test_result = A_test(this, s, t, v)
	return test_I_test_result
endfunction

function alloc_A takes nothing returns integer
	local integer this
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 5
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 5
	endif
	return this
endfunction

function A_init takes integer this returns nothing
endfunction

function construct_A takes integer this returns nothing
	call A_init(this)
endfunction

function new_A takes nothing returns integer
	local integer this = alloc_A()
	call construct_A(this)
	return this
endfunction

function alloc_B takes nothing returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
	endif
	return this
endfunction

function B_init takes integer this returns nothing
endfunction

function construct_B takes integer this returns nothing
	call B_init(this)
endfunction

function new_B takes nothing returns integer
	local integer this = alloc_B()
	call construct_B(this)
	return this
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function alloc_D takes nothing returns integer
	local integer this
	if D_firstFree == 0 then
		if D_maxIndex < 32768 then
			set D_maxIndex = D_maxIndex + 1
			set this = D_maxIndex
		else
			call error("Out of memory: Could not create D.")
			set this = 0
		endif
	else
		set D_firstFree = D_firstFree - 1
		set this = D_nextFree[D_firstFree]
	endif
	return this
endfunction

function D_init takes integer this returns nothing
endfunction

function construct_D takes integer this returns nothing
	call D_init(this)
endfunction

function new_D takes nothing returns integer
	local integer this = alloc_D()
	call construct_D(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer i = new_A()
	local integer b = new_B()
	local integer c = new_C()
	local integer d = new_D()
	if dispatch_I_test_I_test(i, b, c, d) then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

