// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
endglobals
native takesInt takes integer i returns nothing
native takesC takes integer c returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this_1 = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this_1 = C_nextFree[C_firstFree]
	endif
	set this = this_1
	return this
endfunction

function testClass takes nothing returns nothing
	local integer cObj = new_C()
	local integer cInt = cObj
	local integer cObj2 = cInt
	call takesC(cObj)
	call takesInt(cInt)
	call takesC(cObj2)
endfunction

function main takes nothing returns nothing
	local integer zeroEnum
	local integer zeroInt
	local integer zeroEnum2
	call initGlobals()
	set zeroEnum = 0
	set zeroInt = zeroEnum
	set zeroEnum2 = zeroInt
	call takesInt(zeroEnum)
	call takesInt(zeroInt)
	call takesInt(zeroEnum2)
	call testClass()
endfunction

function config takes nothing returns nothing
endfunction

