// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
// originframetype ORIGIN_FRAME_GAME_UI=null
// integer bj_MAX_PLAYER_SLOTS=0
integer ClosureTimers_x=0
string array Colors_hexs
integer Colors_decs=0
hashtable ErrorHandling_HT=null
framehandle Framehandle_GAME_UI=null
real GameTimer_currentTime=0.
hashtable HashList_ht=null
hashtable HashList_occurences=null
boolean MagicFunctions_compiletime=false
player array Player_players
player Player_localPlayer=null
hashtable Table_ht=null
integer Test_intMap=0
integer Test_realMap=0
integer Test_boolMap=0
integer Test_strMap=0
integer Test_unitMap=0
timer array TimerUtils_freeTimers
integer TimerUtils_freeTimersCount=0
integer TimerUtils_timerData=0
integer TypeCasting_typecastdata=0
hashtable hashtable_compiletime=null
hashtable hashtable_compiletime_41=null
hashtable hashtable_compiletime_42=null
hashtable hashtable_compiletime_43=null
integer array CallbackSingle_nextFree
integer CallbackSingle_firstFree=0
integer CallbackSingle_maxIndex=0
integer array CallbackSingle_typeId
integer Callback_firstFree=0
integer array Callback_typeId
integer array HashList_typeId
integer array Table_nextFree
integer Table_firstFree=0
integer Table_maxIndex=0
integer array Table_typeId
integer array cb
timerdialog array dia
timer array CallbackSingle_t
integer array HashList_size
integer array HashMap_size
integer array IterableMap_keys
code ref_function_init_AbilityIds=null
code ref_function_init_Real=null
code ref_function_init_Integer=null
code ref_function_init_Angle=null
code ref_function_init_String=null
code ref_function_init_Vectors=null
code ref_function_init_Destructable=null
code ref_function_init_Player=null
code ref_function_init_Basics=null
code ref_function_init_MagicFunctions=null
code ref_function_init_Table=null
code ref_function_init_Playercolor=null
code ref_function_init_Maths=null
code ref_function_init_Colors=null
code ref_function_init_Printing=null
code ref_function_init_GameTimer=null
code ref_function_init_ErrorHandling=null
code ref_function_init_HashList=null
code ref_function_init_Matrices=null
code ref_function_init_Quaternion=null
code ref_function_init_Framehandle=null
code ref_function_init_Group=null
code ref_function_init_Lightning=null
code ref_function_init_WeatherEffects=null
code ref_function_init_TypeCasting=null
code ref_function_init_TimerUtils=null
code ref_function_init_ClosureTimers=null
code ref_function_init_EventHelper=null
code ref_function_init_Test=null
code ref_function_code__startPeriodic_GameTimer=null
code ref_function_code__start_CallbackSingle_ClosureTimers=null
endglobals
function Loglevel_getTag takes integer this returns string
	if this == 0 then
		return "|cffADADADtrace|r"
	elseif this == 1 then
		return "|cff2685DCdebug|r"
	elseif this == 2 then
		return "|cffFFCC00info|r"
	elseif this == 3 then
		return "|cffF47E3Ewarning|r"
	else
		return "|cffFB2700error|r"
	endif
endfunction

function compileError takes string msg returns nothing
endfunction

function error takes string msg returns nothing
	local integer hash
	local player showTo
	if MagicFunctions_compiletime then
		call compileError("ERROR: " + msg)
	else
		set hash = StringHash(msg)
		if HaveSavedInteger(ErrorHandling_HT, -1, hash) then
			if LoadInteger(ErrorHandling_HT, -1, hash) + 60 < GameTimer_currentTime then
				set msg = msg + ""
				set showTo = Player_localPlayer
				if 2 <= 4 then
					call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + msg)
				endif
				call SaveInteger(ErrorHandling_HT, -1, hash, R2I(GameTimer_currentTime))
				call SaveBoolean(ErrorHandling_HT, -1, hash, false)
			elseif HaveSavedBoolean(ErrorHandling_HT, -1, hash) then
				if  not LoadBoolean(ErrorHandling_HT, -1, hash) then
					set showTo = Player_localPlayer
					if 2 <= 4 then
						call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + "|cffFF3A29Excessive repeating errors are being omitted")
					endif
					call SaveBoolean(ErrorHandling_HT, -1, hash, true)
				endif
			else
				set showTo = Player_localPlayer
				if 2 <= 4 then
					call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + "|cffFF3A29Excessive repeating errors are being omitted")
				endif
				call SaveBoolean(ErrorHandling_HT, -1, hash, true)
			endif
		else
			call SaveInteger(ErrorHandling_HT, -1, hash, R2I(GameTimer_currentTime))
			set msg = "Message: " + msg + ""
			set showTo = Player_localPlayer
			if 2 <= 4 then
				call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + msg)
			endif
		endif
		call I2S(1 / 0)
	endif
endfunction

function initCompiletimeState_0 takes nothing returns nothing
	set hashtable_compiletime_43 = InitHashtable()
	set hashtable_compiletime_42 = InitHashtable()
	set hashtable_compiletime_41 = InitHashtable()
	set hashtable_compiletime = InitHashtable()
	call SaveInteger(hashtable_compiletime_43, 1, -242600650, 0)
	call SaveInteger(hashtable_compiletime_43, 1, 1132341824, 1)
	call SaveInteger(hashtable_compiletime_43, 1, -647782241, 2)
	call SaveInteger(hashtable_compiletime_43, 1, -854572045, 3)
	call SaveInteger(hashtable_compiletime_43, 1, -680649701, 4)
	call SaveInteger(hashtable_compiletime_43, 1, -943650483, 5)
	call SaveInteger(hashtable_compiletime_43, 1, -671760605, 6)
	call SaveInteger(hashtable_compiletime_43, 1, 349230650, 7)
	call SaveInteger(hashtable_compiletime_43, 1, -1894922563, 8)
	call SaveInteger(hashtable_compiletime_43, 1, -1474492777, 9)
	call SaveInteger(hashtable_compiletime_43, 1, -1587459251, 10)
	call SaveInteger(hashtable_compiletime_43, 1, -1676716706, 11)
	call SaveInteger(hashtable_compiletime_43, 1, -1559655710, 12)
	call SaveInteger(hashtable_compiletime_43, 1, -1663695754, 13)
	call SaveInteger(hashtable_compiletime_43, 1, 597637742, 14)
	call SaveInteger(hashtable_compiletime_43, 1, 789744696, 15)
	call SaveStr(hashtable_compiletime_43, 2, 0, "")
	call SaveStr(hashtable_compiletime_43, 2, -1587459251, "a")
	call SaveStr(hashtable_compiletime_43, 2, -848360345, "some string")
	call SaveInteger(hashtable_compiletime_43, 3, -1587459251, -848360345)
	call SaveInteger(hashtable_compiletime_43, 4, 4, 8)
	call SaveInteger(hashtable_compiletime_43, 5, 3775, 591530)
	call SaveInteger(hashtable_compiletime_43, 6, 1, 1)
endfunction

function code__startPeriodic_GameTimer takes nothing returns nothing
	set GameTimer_currentTime = GameTimer_currentTime + 0.030
endfunction

function dispatch_Callback_destroyCallback takes integer this returns nothing
	if Callback_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Callback.Callback")
		else
			call error("Called Callback.Callback on invalid object.")
		endif
	endif
	if Callback_typeId[this] == 0 then
		call error("Double free: object of type Callback")
	else
		set Callback_firstFree = Callback_firstFree + 1
		set Callback_typeId[this] = 0
	endif
endfunction

function call_doAfter_ClosureTimers takes integer this returns nothing
	call dispatch_Callback_destroyCallback(cb[this])
	call DestroyTimerDialog(dia[this])
endfunction

function dispatch_Table_Table_Table_hasInt takes integer this, integer parentKey returns boolean
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.hasInt")
		else
			call error("Called Table.hasInt on invalid object.")
		endif
	endif
	return HaveSavedInteger(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_saveInt takes integer this, integer parentKey, integer value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveInt")
		else
			call error("Called Table.saveInt on invalid object.")
		endif
	endif
	call SaveInteger(Table_ht, this, parentKey, value)
endfunction

function HashMap_put takes integer this, integer key, integer value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashMap.has")
		else
			call error("Called HashMap.has on invalid object.")
		endif
	endif
	if  not dispatch_Table_Table_Table_hasInt(this, key) then
		set HashMap_size[this] = HashMap_size[this] + 1
	endif
	call dispatch_Table_Table_Table_saveInt(this, key, value)
endfunction

function dispatch_HashList_HashList_HashList_count takes integer this, integer elem returns integer
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.count")
		else
			call error("Called HashList.count on invalid object.")
		endif
	endif
	return LoadInteger(HashList_occurences, this, elem)
endfunction

function dispatch_HashList_HashList_HashList_incrOccurences takes integer this, integer elem returns nothing
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.incrOccurences")
		else
			call error("Called HashList.incrOccurences on invalid object.")
		endif
	endif
	call SaveInteger(HashList_occurences, this, elem, dispatch_HashList_HashList_HashList_count(this, elem) + 1)
endfunction

function dispatch_HashList_HashList_HashList_add_1 takes integer this, integer elems_0 returns nothing
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.add")
		else
			call error("Called HashList.add on invalid object.")
		endif
	endif
	call SaveInteger(HashList_ht, this, HashList_size[this], elems_0)
	call dispatch_HashList_HashList_HashList_incrOccurences(this, elems_0)
	set HashList_size[this] = HashList_size[this] + 1
endfunction

function dispatch_IterableMap_HashMap_IterableMap_hasKey takes integer this, integer key returns boolean
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling IterableMap.hasKey")
		else
			call error("Called IterableMap.hasKey on invalid object.")
		endif
	endif
	set this = IterableMap_keys[this]
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.has")
		else
			call error("Called HashList.has on invalid object.")
		endif
	endif
	return dispatch_HashList_HashList_HashList_count(this, key) > 0
endfunction

function dispatch_HashMap_HashMap_HashMap_put takes integer this, integer key, integer value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashMap.put")
		else
			call error("Called HashMap.put on invalid object.")
		endif
	endif
	if Table_typeId[this] <= 24 then
		call HashMap_put(this, key, value)
	else
		call HashMap_put(this, key, value)
		if  not dispatch_IterableMap_HashMap_IterableMap_hasKey(this, key) then
			call dispatch_HashList_HashList_HashList_add_1(IterableMap_keys[this], key)
		endif
	endif
endfunction

function dispatch_Table_Table_Table_loadInt takes integer this, integer parentKey returns integer
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadInt")
		else
			call error("Called Table.loadInt on invalid object.")
		endif
	endif
	return LoadInteger(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_loadString takes integer this, integer parentKey returns string
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadString")
		else
			call error("Called Table.loadString on invalid object.")
		endif
	endif
	return LoadStr(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_hasString takes integer this, integer parentKey returns boolean
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.hasString")
		else
			call error("Called Table.hasString on invalid object.")
		endif
	endif
	return HaveSavedString(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_saveString takes integer this, integer parentKey, string value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveString")
		else
			call error("Called Table.saveString on invalid object.")
		endif
	endif
	call SaveStr(Table_ht, this, parentKey, value)
endfunction

function stringToIndex takes string s returns integer
	local integer hash = StringHash(s)
	loop
		if dispatch_Table_Table_Table_hasString(TypeCasting_typecastdata, hash) then
			exitwhen dispatch_Table_Table_Table_loadString(TypeCasting_typecastdata, hash) == s
		else
			call dispatch_Table_Table_Table_saveString(TypeCasting_typecastdata, hash, s)
			exitwhen true
		endif
		set hash = hash + 1
	endloop
	return hash
endfunction

function unitFromIndex takes integer index returns unit
	local integer this = TypeCasting_typecastdata
	local fogstate value = ConvertFogState(index)
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveFogState")
		else
			call error("Called Table.saveFogState on invalid object.")
		endif
	endif
	call SaveFogStateHandle(Table_ht, this, 0, value)
	set index = TypeCasting_typecastdata
	if Table_typeId[index] == 0 then
		if index == 0 then
			call error("Nullpointer exception when calling Table.loadUnit")
		else
			call error("Called Table.loadUnit on invalid object.")
		endif
	endif
	return LoadUnitHandle(Table_ht, index, 0)
endfunction

function foo takes nothing returns nothing
	local string s
	local real r
	local boolean b
	local unit u
	local string str
	local integer HashMap_HashMap_get_result
	local integer temp
	local integer temp_1
	call dispatch_HashMap_HashMap_HashMap_put(Test_strMap, stringToIndex("a"), stringToIndex("some string"))
	set temp = Test_strMap
	set HashMap_HashMap_get_result = stringToIndex("a")
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result)
	set str = dispatch_Table_Table_Table_loadString(TypeCasting_typecastdata, HashMap_HashMap_get_result)
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., str)
	set temp = Test_strMap
	set HashMap_HashMap_get_result = stringToIndex("a")
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result)
	set str = dispatch_Table_Table_Table_loadString(TypeCasting_typecastdata, HashMap_HashMap_get_result)
	set temp = Test_strMap
	set HashMap_HashMap_get_result = stringToIndex("a")
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result)
	set s = "hjgf" + dispatch_Table_Table_Table_loadString(TypeCasting_typecastdata, HashMap_HashMap_get_result)
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., s)
	set s = "hjgf" + str
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., s)
	set temp = Test_strMap
	set HashMap_HashMap_get_result = stringToIndex("a")
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result)
	set str = dispatch_Table_Table_Table_loadString(TypeCasting_typecastdata, HashMap_HashMap_get_result)
	set temp = Test_strMap
	set HashMap_HashMap_get_result = stringToIndex("a")
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result)
	set s = str + dispatch_Table_Table_Table_loadString(TypeCasting_typecastdata, HashMap_HashMap_get_result)
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., s)
	if  not MagicFunctions_compiletime then
		set temp = Test_unitMap
		set HashMap_HashMap_get_result = GetHandleId(null)
		if Table_typeId[temp] == 0 then
			if temp == 0 then
				call error("Nullpointer exception when calling HashMap.get")
			else
				call error("Called HashMap.get on invalid object.")
			endif
		endif
		set u = unitFromIndex(dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result))
		call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., GetUnitName(u))
	endif
	set temp = Test_intMap
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, 0)
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., I2S(HashMap_HashMap_get_result))
	set temp = Test_realMap
	set HashMap_HashMap_get_result = R2I(0.0)
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result)
	set r = HashMap_HashMap_get_result / 1000.
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., R2S(r))
	set temp = Test_boolMap
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, 1)
	set b = HashMap_HashMap_get_result == 1
	set str = "False"
	if b then
		set str = "True"
	endif
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., str)
	if  not MagicFunctions_compiletime then
		set temp = Test_unitMap
		set temp_1 = GetHandleId(null)
		set u = CreateUnit(Player_players[0], 1751543663, 0., 0., 0.0)
		call dispatch_HashMap_HashMap_HashMap_put(temp, temp_1, GetHandleId(u))
		set temp = Test_unitMap
		set HashMap_HashMap_get_result = GetHandleId(null)
		if Table_typeId[temp] == 0 then
			if temp == 0 then
				call error("Nullpointer exception when calling HashMap.get")
			else
				call error("Called HashMap.get on invalid object.")
			endif
		endif
		set u = unitFromIndex(dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result))
		call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., GetUnitName(u))
	endif
	call dispatch_HashMap_HashMap_HashMap_put(Test_intMap, 4, 8)
	set temp = Test_intMap
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, 4)
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., I2S(HashMap_HashMap_get_result))
	call dispatch_HashMap_HashMap_HashMap_put(Test_realMap, R2I(3775.3999), R2I(591530.0))
	set temp = Test_realMap
	set HashMap_HashMap_get_result = R2I(3775.3999)
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, HashMap_HashMap_get_result)
	set r = HashMap_HashMap_get_result / 1000.
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., R2S(r))
	call dispatch_HashMap_HashMap_HashMap_put(Test_boolMap, 1, 1)
	set temp = Test_boolMap
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	set HashMap_HashMap_get_result = dispatch_Table_Table_Table_loadInt(temp, 1)
	set b = HashMap_HashMap_get_result == 1
	set str = "False"
	if b then
		set str = "True"
	endif
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., str)
endfunction

function testFail takes string msg returns nothing
endfunction

function dispatch_CallbackSingle_ClosureTimers_CallbackSingle_call takes integer this returns nothing
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.call")
		else
			call error("Called CallbackSingle.call on invalid object.")
		endif
	endif
	if CallbackSingle_typeId[this] <= 10 then
		if CallbackSingle_typeId[this] <= 9 then
			if CallbackSingle_typeId[this] <= 8 then
				call call_doAfter_ClosureTimers(this)
			else
				set ClosureTimers_x = ClosureTimers_x + 50
			endif
		else
			set ClosureTimers_x = ClosureTimers_x * 2
		endif
	elseif CallbackSingle_typeId[this] <= 11 then
		set ClosureTimers_x = ClosureTimers_x / 2
		set this = ClosureTimers_x
		if this != 250 then
			call testFail("Expected <" + I2S(250) + ">, Actual <" + I2S(this) + ">")
		endif
	else
		call foo()
	endif
endfunction

function timer_release takes timer this returns nothing
	if this == null then
		call error("Trying to release a null timer")
		return
	endif
	if dispatch_Table_Table_Table_loadInt(TimerUtils_timerData, GetHandleId(this)) == 679645218 then
		call error("ReleaseTimer: Double free!")
		return
	endif
	call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, GetHandleId(this), 679645218)
	call PauseTimer(this)
	set TimerUtils_freeTimers[TimerUtils_freeTimersCount] = this
	set TimerUtils_freeTimersCount = TimerUtils_freeTimersCount + 1
endfunction

function dispatch_CallbackSingle_destroyCallbackSingle takes integer this returns nothing
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.CallbackSingle")
		else
			call error("Called CallbackSingle.CallbackSingle on invalid object.")
		endif
	endif
	call timer_release(CallbackSingle_t[this])
	if CallbackSingle_typeId[this] == 0 then
		call error("Double free: object of type CallbackSingle")
	else
		set CallbackSingle_nextFree[CallbackSingle_firstFree] = this
		set CallbackSingle_firstFree = CallbackSingle_firstFree + 1
		set CallbackSingle_typeId[this] = 0
	endif
endfunction

function CallbackSingle_staticCallback takes nothing returns nothing
	local integer cb_1 = dispatch_Table_Table_Table_loadInt(TimerUtils_timerData, GetHandleId(GetExpiredTimer()))
	call dispatch_CallbackSingle_ClosureTimers_CallbackSingle_call(cb_1)
	call dispatch_CallbackSingle_destroyCallbackSingle(cb_1)
endfunction

function code__start_CallbackSingle_ClosureTimers takes nothing returns nothing
	call CallbackSingle_staticCallback()
endfunction

function init_AbilityIds takes nothing returns boolean
	return true
endfunction

function init_Angle takes nothing returns boolean
	return true
endfunction

function init_Basics takes nothing returns boolean
	return true
endfunction

function init_ClosureTimers takes nothing returns boolean
	set ClosureTimers_x = 200
	return true
endfunction

function new_Table takes nothing returns integer
	local integer this
	if Table_firstFree == 0 then
		if Table_maxIndex < 32768 then
			set Table_maxIndex = Table_maxIndex + 1
			set this = Table_maxIndex
			set Table_typeId[this] = 23
		else
			call error("Out of memory: Could not create Table.")
			set this = 0
		endif
	else
		set Table_firstFree = Table_firstFree - 1
		set this = Table_nextFree[Table_firstFree]
		set Table_typeId[this] = 23
	endif
	return this
endfunction

function init_Colors takes nothing returns boolean
	local integer firstpart
	set Colors_hexs[0] = "0"
	set Colors_hexs[1] = "1"
	set Colors_hexs[2] = "2"
	set Colors_hexs[3] = "3"
	set Colors_hexs[4] = "4"
	set Colors_hexs[5] = "5"
	set Colors_hexs[6] = "6"
	set Colors_hexs[7] = "7"
	set Colors_hexs[8] = "8"
	set Colors_hexs[9] = "9"
	set Colors_hexs[10] = "A"
	set Colors_hexs[11] = "B"
	set Colors_hexs[12] = "C"
	set Colors_hexs[13] = "D"
	set Colors_hexs[14] = "E"
	set Colors_hexs[15] = "F"
	set Colors_decs = new_Table()
	set firstpart = 0
	loop
		exitwhen firstpart > 15
		call dispatch_Table_Table_Table_saveInt(Colors_decs, StringHash(Colors_hexs[firstpart]), firstpart)
		set firstpart = firstpart + 1
	endloop
	return true
endfunction

function init_Destructable takes nothing returns boolean
	return true
endfunction

function init_ErrorHandling takes nothing returns boolean
	set ErrorHandling_HT = hashtable_compiletime_42
	return true
endfunction

function new_HashMap takes nothing returns integer
	local integer this
	if Table_firstFree == 0 then
		if Table_maxIndex < 32768 then
			set Table_maxIndex = Table_maxIndex + 1
			set this = Table_maxIndex
			set Table_typeId[this] = 24
		else
			call error("Out of memory: Could not create HashMap.")
			set this = 0
		endif
	else
		set Table_firstFree = Table_firstFree - 1
		set this = Table_nextFree[Table_firstFree]
		set Table_typeId[this] = 24
	endif
	set HashMap_size[this] = 0
	return this
endfunction

function init_EventHelper takes nothing returns boolean
	call new_HashMap()
	call new_HashMap()
	call new_Table()
	return true
endfunction

function verifyFrameNameLength takes string name returns boolean
	if StringLength(name) > 560 then
		call error("Trying to address frame with exceeding maximum frame name length (" + I2S(560) + ") for: " + name)
		return false
	endif
	return true
endfunction

function init_Framehandle takes nothing returns boolean
	local framehandle owner
	set Framehandle_GAME_UI = BlzGetOriginFrame(ORIGIN_FRAME_GAME_UI, 0)
	set owner = Framehandle_GAME_UI
	call verifyFrameNameLength("SetMousePositionCage")
	set owner = BlzCreateFrameByType("FRAME", "SetMousePositionCage", owner, null, 0)
	call BlzFrameSetSize(owner, 0.0001, 0.0001)
	return true
endfunction

function init_GameTimer takes nothing returns boolean
	call TimerStart(CreateTimer(), 100000., false, null)
	call TimerStart(CreateTimer(), 0.030, true, ref_function_code__startPeriodic_GameTimer)
	return true
endfunction

function init_Group takes nothing returns boolean
	call CreateGroup()
	return true
endfunction

function init_HashList takes nothing returns boolean
	set HashList_ht = hashtable_compiletime
	set HashList_occurences = hashtable_compiletime_41
	return true
endfunction

function init_Integer takes nothing returns boolean
	return true
endfunction

function init_Lightning takes nothing returns boolean
	return true
endfunction

function init_MagicFunctions takes nothing returns boolean
	set MagicFunctions_compiletime = false
	return true
endfunction

function init_Maths takes nothing returns boolean
	return true
endfunction

function init_Matrices takes nothing returns boolean
	return true
endfunction

function init_Player takes nothing returns boolean
	local integer i
	local integer temp
	set Player_localPlayer = GetLocalPlayer()
	set i = 0
	set temp = bj_MAX_PLAYER_SLOTS - 1
	loop
		exitwhen i > temp
		set Player_players[i] = Player(i)
		set i = i + 1
	endloop
	return true
endfunction

function init_Playercolor takes nothing returns boolean
	return true
endfunction

function init_Printing takes nothing returns boolean
	return true
endfunction

function init_Quaternion takes nothing returns boolean
	return true
endfunction

function init_Real takes nothing returns boolean
	return true
endfunction

function init_String takes nothing returns boolean
	return true
endfunction

function init_Table takes nothing returns boolean
	set Table_ht = hashtable_compiletime_43
	return true
endfunction

function CallbackSingle_start takes integer this, timer whichTimer, real time returns nothing
	call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, GetHandleId(whichTimer), this)
	call TimerStart(whichTimer, time, false, ref_function_code__start_CallbackSingle_ClosureTimers)
	set CallbackSingle_t[this] = whichTimer
endfunction

function getTimer takes nothing returns timer
	local timer this
	if TimerUtils_freeTimersCount > 0 then
		set TimerUtils_freeTimersCount = TimerUtils_freeTimersCount - 1
		set this = TimerUtils_freeTimers[TimerUtils_freeTimersCount]
		call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, GetHandleId(this), 0)
		return TimerUtils_freeTimers[TimerUtils_freeTimersCount]
	else
		set this = CreateTimer()
		call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, GetHandleId(this), 0)
		return this
	endif
endfunction

function init_Test takes nothing returns boolean
	local integer this
	local timer this_1
	set Test_intMap = new_HashMap()
	set Test_realMap = new_HashMap()
	set Test_boolMap = new_HashMap()
	set Test_strMap = new_HashMap()
	set Test_unitMap = new_HashMap()
	call new_HashMap()
	if CallbackSingle_firstFree == 0 then
		if CallbackSingle_maxIndex < 32768 then
			set CallbackSingle_maxIndex = CallbackSingle_maxIndex + 1
			set this = CallbackSingle_maxIndex
			set CallbackSingle_typeId[this] = 12
		else
			call error("Out of memory: Could not create CallbackSingle_doAfter_Test.")
			set this = 0
		endif
	else
		set CallbackSingle_firstFree = CallbackSingle_firstFree - 1
		set this = CallbackSingle_nextFree[CallbackSingle_firstFree]
		set CallbackSingle_typeId[this] = 12
	endif
	set this_1 = getTimer()
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.start")
		else
			call error("Called CallbackSingle.start on invalid object.")
		endif
	endif
	call CallbackSingle_start(this, this_1, 0.0)
	return true
endfunction

function init_TimerUtils takes nothing returns boolean
	set TimerUtils_timerData = new_Table()
	call new_HashMap()
	return true
endfunction

function init_TypeCasting takes nothing returns boolean
	local integer this
	set TypeCasting_typecastdata = new_Table()
	set this = TypeCasting_typecastdata
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveString")
		else
			call error("Called Table.saveString on invalid object.")
		endif
	endif
	call SaveStr(Table_ht, this, 0, "")
	return true
endfunction

function init_Vectors takes nothing returns boolean
	call Location(0., 0.)
	return true
endfunction

function init_WeatherEffects takes nothing returns boolean
	return true
endfunction

function initGlobals takes nothing returns nothing
	set ref_function_init_AbilityIds = function init_AbilityIds
	set ref_function_init_Real = function init_Real
	set ref_function_init_Integer = function init_Integer
	set ref_function_init_Angle = function init_Angle
	set ref_function_init_String = function init_String
	set ref_function_init_Vectors = function init_Vectors
	set ref_function_init_Destructable = function init_Destructable
	set ref_function_init_Player = function init_Player
	set ref_function_init_Basics = function init_Basics
	set ref_function_init_MagicFunctions = function init_MagicFunctions
	set ref_function_init_Table = function init_Table
	set ref_function_init_Playercolor = function init_Playercolor
	set ref_function_init_Maths = function init_Maths
	set ref_function_init_Colors = function init_Colors
	set ref_function_init_Printing = function init_Printing
	set ref_function_init_GameTimer = function init_GameTimer
	set ref_function_init_ErrorHandling = function init_ErrorHandling
	set ref_function_init_HashList = function init_HashList
	set ref_function_init_Matrices = function init_Matrices
	set ref_function_init_Quaternion = function init_Quaternion
	set ref_function_init_Framehandle = function init_Framehandle
	set ref_function_init_Group = function init_Group
	set ref_function_init_Lightning = function init_Lightning
	set ref_function_init_WeatherEffects = function init_WeatherEffects
	set ref_function_init_TypeCasting = function init_TypeCasting
	set ref_function_init_TimerUtils = function init_TimerUtils
	set ref_function_init_ClosureTimers = function init_ClosureTimers
	set ref_function_init_EventHelper = function init_EventHelper
	set ref_function_init_Test = function init_Test
	set ref_function_code__startPeriodic_GameTimer = function code__startPeriodic_GameTimer
	set ref_function_code__start_CallbackSingle_ClosureTimers = function code__start_CallbackSingle_ClosureTimers
endfunction

function main takes nothing returns nothing
	local trigger initTrig
	call initGlobals()
	call ExecuteFunc("initCompiletimeState_0")
	set initTrig = CreateTrigger()
	call TriggerAddCondition(initTrig, Condition(ref_function_init_AbilityIds))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package AbilityIds.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Real))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Real.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Integer))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Integer.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Angle))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Angle.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_String))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package String.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Vectors))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Vectors.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Destructable))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Destructable.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Player))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Player.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Basics))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Basics.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_MagicFunctions))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package MagicFunctions.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Table))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Table.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Playercolor))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Playercolor.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Maths))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Maths.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Colors))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Colors.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Printing))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Printing.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_GameTimer))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package GameTimer.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ErrorHandling))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ErrorHandling.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_HashList))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package HashList.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Matrices))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Matrices.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Quaternion))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Quaternion.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Framehandle))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Framehandle.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Group))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Group.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Lightning))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Lightning.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_WeatherEffects))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package WeatherEffects.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_TypeCasting))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TypeCasting.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_TimerUtils))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TimerUtils.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ClosureTimers))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ClosureTimers.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_EventHelper))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package EventHelper.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Test))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Test.")
	endif
	call TriggerClearConditions(initTrig)
	call DestroyTrigger(initTrig)
endfunction

function config takes nothing returns nothing
endfunction

