// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
// originframetype ORIGIN_FRAME_GAME_UI=null
// integer bj_MAX_PLAYER_SLOTS=0
integer ClosureTimers_x=0
string array Colors_hexs
integer Colors_decs=0
hashtable ErrorHandling_HT=null
framehandle Framehandle_GAME_UI=null
real GameTimer_currentTime=0.
hashtable HashList_ht=null
hashtable HashList_occurences=null
boolean MagicFunctions_compiletime=false
player array Player_players
player Player_localPlayer=null
hashtable Table_ht=null
integer Test_intMap=0
integer Test_realMap=0
integer Test_boolMap=0
integer Test_strMap=0
integer Test_unitMap=0
timer array TimerUtils_freeTimers
integer TimerUtils_freeTimersCount=0
integer TimerUtils_timerData=0
integer TypeCasting_typecastdata=0
hashtable hashtable_compiletime=null
hashtable hashtable_compiletime_41=null
hashtable hashtable_compiletime_42=null
hashtable hashtable_compiletime_43=null
integer array CallbackSingle_nextFree
integer CallbackSingle_firstFree=0
integer CallbackSingle_maxIndex=0
integer array CallbackSingle_typeId
integer Callback_firstFree=0
integer array Callback_typeId
integer array HashList_typeId
integer array Table_nextFree
integer Table_firstFree=0
integer Table_maxIndex=0
integer array Table_typeId
integer array cb
timerdialog array dia
timer array CallbackSingle_t
integer array HashList_size
integer array HashMap_size
integer array IterableMap_keys
code ref_function_init_AbilityIds=null
code ref_function_init_Real=null
code ref_function_init_Integer=null
code ref_function_init_Angle=null
code ref_function_init_String=null
code ref_function_init_Vectors=null
code ref_function_init_Destructable=null
code ref_function_init_Player=null
code ref_function_init_Basics=null
code ref_function_init_MagicFunctions=null
code ref_function_init_Table=null
code ref_function_init_Playercolor=null
code ref_function_init_Maths=null
code ref_function_init_Colors=null
code ref_function_init_Printing=null
code ref_function_init_GameTimer=null
code ref_function_init_ErrorHandling=null
code ref_function_init_HashList=null
code ref_function_init_Matrices=null
code ref_function_init_Quaternion=null
code ref_function_init_Framehandle=null
code ref_function_init_Group=null
code ref_function_init_Lightning=null
code ref_function_init_WeatherEffects=null
code ref_function_init_TypeCasting=null
code ref_function_init_TimerUtils=null
code ref_function_init_ClosureTimers=null
code ref_function_init_EventHelper=null
code ref_function_init_Test=null
code ref_function_code__startPeriodic_GameTimer=null
code ref_function_code__start_CallbackSingle_ClosureTimers=null
endglobals
function Loglevel_getTag takes integer this returns string
	if this == 0 then
		return "|cffADADADtrace|r"
	elseif this == 1 then
		return "|cff2685DCdebug|r"
	elseif this == 2 then
		return "|cffFFCC00info|r"
	elseif this == 3 then
		return "|cffF47E3Ewarning|r"
	else
		return "|cffFB2700error|r"
	endif
endfunction

function printLog takes player showTo, integer loglvl, string msg returns nothing
	if 2 <= loglvl then
		call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(loglvl) + " - " + msg)
	endif
endfunction

function Log_error takes string msg returns nothing
	call printLog(Player_localPlayer, 4, msg)
endfunction

function compileError takes string msg returns nothing
endfunction

function hashtable_hasBoolean takes hashtable this, integer parentKey, integer childKey returns boolean
	return HaveSavedBoolean(this, parentKey, childKey)
endfunction

function hashtable_hasInt takes hashtable this, integer parentKey, integer childKey returns boolean
	return HaveSavedInteger(this, parentKey, childKey)
endfunction

function hashtable_loadBoolean takes hashtable this, integer parentKey, integer childKey returns boolean
	return LoadBoolean(this, parentKey, childKey)
endfunction

function hashtable_loadInt takes hashtable this, integer parentKey, integer childKey returns integer
	return LoadInteger(this, parentKey, childKey)
endfunction

function hashtable_saveBoolean takes hashtable this, integer parentKey, integer childKey, boolean value returns nothing
	call SaveBoolean(this, parentKey, childKey, value)
endfunction

function hashtable_saveInt takes hashtable this, integer parentKey, integer childKey, integer value returns nothing
	call SaveInteger(this, parentKey, childKey, value)
endfunction

function real_toInt takes real this returns integer
	return R2I(this)
endfunction

function string_getHash takes string this returns integer
	return StringHash(this)
endfunction

function error takes string msg returns nothing
	local integer hash
	if MagicFunctions_compiletime then
		call compileError("ERROR: " + msg)
	else
		set hash = string_getHash(msg)
		if hashtable_hasInt(ErrorHandling_HT, -1, hash) then
			if hashtable_loadInt(ErrorHandling_HT, -1, hash) + 60 < GameTimer_currentTime then
				call Log_error(msg + "")
				call hashtable_saveInt(ErrorHandling_HT, -1, hash, real_toInt(GameTimer_currentTime))
				call hashtable_saveBoolean(ErrorHandling_HT, -1, hash, false)
			elseif hashtable_hasBoolean(ErrorHandling_HT, -1, hash) then
				if  not hashtable_loadBoolean(ErrorHandling_HT, -1, hash) then
					call Log_error("|cffFF3A29Excessive repeating errors are being omitted")
					call hashtable_saveBoolean(ErrorHandling_HT, -1, hash, true)
				endif
			else
				call Log_error("|cffFF3A29Excessive repeating errors are being omitted")
				call hashtable_saveBoolean(ErrorHandling_HT, -1, hash, true)
			endif
		else
			call hashtable_saveInt(ErrorHandling_HT, -1, hash, real_toInt(GameTimer_currentTime))
			call Log_error("Message: " + msg + "")
		endif
		call I2S(1 / 0)
	endif
endfunction

function initCompiletimeState_0 takes nothing returns nothing
	set hashtable_compiletime_43 = InitHashtable()
	set hashtable_compiletime_42 = InitHashtable()
	set hashtable_compiletime_41 = InitHashtable()
	set hashtable_compiletime = InitHashtable()
	call SaveInteger(hashtable_compiletime_43, 1, -242600650, 0)
	call SaveInteger(hashtable_compiletime_43, 1, 1132341824, 1)
	call SaveInteger(hashtable_compiletime_43, 1, -647782241, 2)
	call SaveInteger(hashtable_compiletime_43, 1, -854572045, 3)
	call SaveInteger(hashtable_compiletime_43, 1, -680649701, 4)
	call SaveInteger(hashtable_compiletime_43, 1, -943650483, 5)
	call SaveInteger(hashtable_compiletime_43, 1, -671760605, 6)
	call SaveInteger(hashtable_compiletime_43, 1, 349230650, 7)
	call SaveInteger(hashtable_compiletime_43, 1, -1894922563, 8)
	call SaveInteger(hashtable_compiletime_43, 1, -1474492777, 9)
	call SaveInteger(hashtable_compiletime_43, 1, -1587459251, 10)
	call SaveInteger(hashtable_compiletime_43, 1, -1676716706, 11)
	call SaveInteger(hashtable_compiletime_43, 1, -1559655710, 12)
	call SaveInteger(hashtable_compiletime_43, 1, -1663695754, 13)
	call SaveInteger(hashtable_compiletime_43, 1, 597637742, 14)
	call SaveInteger(hashtable_compiletime_43, 1, 789744696, 15)
	call SaveStr(hashtable_compiletime_43, 2, 0, "")
	call SaveStr(hashtable_compiletime_43, 2, -1587459251, "a")
	call SaveStr(hashtable_compiletime_43, 2, -848360345, "some string")
	call SaveInteger(hashtable_compiletime_43, 3, -1587459251, -848360345)
	call SaveInteger(hashtable_compiletime_43, 4, 4, 8)
	call SaveInteger(hashtable_compiletime_43, 5, 3775, 591530)
	call SaveInteger(hashtable_compiletime_43, 6, 1, 1)
endfunction

function initCompiletimeState takes nothing returns nothing
	call ExecuteFunc("initCompiletimeState_0")
endfunction

function code__startPeriodic_GameTimer takes nothing returns nothing
	set GameTimer_currentTime = GameTimer_currentTime + 0.030
endfunction

function dispatch_Callback_ClosureTimers_Callback_call takes integer this returns nothing
endfunction

function dealloc_Callback takes integer obj returns nothing
	if Callback_typeId[obj] == 0 then
		call error("Double free: object of type Callback")
	else
		set Callback_firstFree = Callback_firstFree + 1
		set Callback_typeId[obj] = 0
	endif
endfunction

function destroyCallback takes integer this returns nothing
	call dealloc_Callback(this)
endfunction

function dispatch_Callback_destroyCallback takes integer this returns nothing
	if Callback_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Callback.Callback")
		else
			call error("Called Callback.Callback on invalid object.")
		endif
	endif
	call destroyCallback(this)
endfunction

function timerdialog_destr takes timerdialog this returns nothing
	call DestroyTimerDialog(this)
endfunction

function call_doAfter_ClosureTimers takes integer this returns nothing
	call dispatch_Callback_ClosureTimers_Callback_call(cb[this])
	call dispatch_Callback_destroyCallback(cb[this])
	call timerdialog_destr(dia[this])
endfunction

function call_doAfter_ClosureTimers_72 takes integer this returns nothing
	set ClosureTimers_x = ClosureTimers_x + 50
endfunction

function call_doAfter_ClosureTimers_73 takes integer this returns nothing
	set ClosureTimers_x = ClosureTimers_x * 2
endfunction

function int_toString takes integer this returns string
	return I2S(this)
endfunction

function testFail takes string msg returns nothing
endfunction

function int_assertEquals takes integer this, integer expected returns nothing
	if this != expected then
		call testFail("Expected <" + int_toString(expected) + ">, Actual <" + int_toString(this) + ">")
	endif
endfunction

function call_doAfter_ClosureTimers_74 takes integer this returns nothing
	set ClosureTimers_x = ClosureTimers_x / 2
	call int_assertEquals(ClosureTimers_x, 250)
endfunction

function booleanFromIndex takes integer index returns boolean
	return index == 1
endfunction

function booleanToIndex takes boolean u returns integer
	local integer cond_result
	if u then
		set cond_result = 1
	else
		set cond_result = 0
	endif
	return cond_result
endfunction

function angle_degrees takes real this_radians returns real
	return this_radians * 57.295779513
endfunction

function createUnit takes player p, integer unitId, real pos_x, real pos_y, real facing_radians returns unit
	return CreateUnit(p, unitId, pos_x, pos_y, angle_degrees(facing_radians))
endfunction

function Table_loadInt takes integer this, integer parentKey returns integer
	return hashtable_loadInt(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_loadInt takes integer this, integer parentKey returns integer
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadInt")
		else
			call error("Called Table.loadInt on invalid object.")
		endif
	endif
	return Table_loadInt(this, parentKey)
endfunction

function HashMap_get takes integer this, integer key returns integer
	return dispatch_Table_Table_Table_loadInt(this, key)
endfunction

function dispatch_HashMap_HashMap_HashMap_get takes integer this, integer key returns integer
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashMap.get")
		else
			call error("Called HashMap.get on invalid object.")
		endif
	endif
	return HashMap_get(this, key)
endfunction

function Table_hasInt takes integer this, integer parentKey returns boolean
	return hashtable_hasInt(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_hasInt takes integer this, integer parentKey returns boolean
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.hasInt")
		else
			call error("Called Table.hasInt on invalid object.")
		endif
	endif
	return Table_hasInt(this, parentKey)
endfunction

function HashMap_has takes integer this, integer key returns boolean
	return dispatch_Table_Table_Table_hasInt(this, key)
endfunction

function dispatch_HashMap_HashMap_HashMap_has takes integer this, integer key returns boolean
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashMap.has")
		else
			call error("Called HashMap.has on invalid object.")
		endif
	endif
	return HashMap_has(this, key)
endfunction

function Table_saveInt takes integer this, integer parentKey, integer value returns nothing
	call hashtable_saveInt(Table_ht, this, parentKey, value)
endfunction

function dispatch_Table_Table_Table_saveInt takes integer this, integer parentKey, integer value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveInt")
		else
			call error("Called Table.saveInt on invalid object.")
		endif
	endif
	call Table_saveInt(this, parentKey, value)
endfunction

function HashMap_put takes integer this, integer key, integer value returns nothing
	if  not dispatch_HashMap_HashMap_HashMap_has(this, key) then
		set HashMap_size[this] = HashMap_size[this] + 1
	endif
	call dispatch_Table_Table_Table_saveInt(this, key, value)
endfunction

function HashList_count takes integer this, integer elem returns integer
	return hashtable_loadInt(HashList_occurences, this, elem)
endfunction

function dispatch_HashList_HashList_HashList_count takes integer this, integer elem returns integer
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.count")
		else
			call error("Called HashList.count on invalid object.")
		endif
	endif
	return HashList_count(this, elem)
endfunction

function HashList_incrOccurences takes integer this, integer elem returns nothing
	call hashtable_saveInt(HashList_occurences, this, elem, dispatch_HashList_HashList_HashList_count(this, elem) + 1)
endfunction

function dispatch_HashList_HashList_HashList_incrOccurences takes integer this, integer elem returns nothing
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.incrOccurences")
		else
			call error("Called HashList.incrOccurences on invalid object.")
		endif
	endif
	call HashList_incrOccurences(this, elem)
endfunction

function HashList_add_1 takes integer this, integer elems_0 returns nothing
	call hashtable_saveInt(HashList_ht, this, HashList_size[this], elems_0)
	call dispatch_HashList_HashList_HashList_incrOccurences(this, elems_0)
	set HashList_size[this] = HashList_size[this] + 1
endfunction

function dispatch_HashList_HashList_HashList_add_1 takes integer this, integer elems_0 returns nothing
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.add")
		else
			call error("Called HashList.add on invalid object.")
		endif
	endif
	call HashList_add_1(this, elems_0)
endfunction

function HashList_has takes integer this, integer elem returns boolean
	return dispatch_HashList_HashList_HashList_count(this, elem) > 0
endfunction

function dispatch_HashList_HashList_HashList_has takes integer this, integer elem returns boolean
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.has")
		else
			call error("Called HashList.has on invalid object.")
		endif
	endif
	return HashList_has(this, elem)
endfunction

function IterableMap_hasKey takes integer this, integer key returns boolean
	return dispatch_HashList_HashList_HashList_has(IterableMap_keys[this], key)
endfunction

function dispatch_IterableMap_HashMap_IterableMap_hasKey takes integer this, integer key returns boolean
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling IterableMap.hasKey")
		else
			call error("Called IterableMap.hasKey on invalid object.")
		endif
	endif
	return IterableMap_hasKey(this, key)
endfunction

function IterableMap_put takes integer this, integer key, integer value returns nothing
	call HashMap_put(this, key, value)
	if  not dispatch_IterableMap_HashMap_IterableMap_hasKey(this, key) then
		call dispatch_HashList_HashList_HashList_add_1(IterableMap_keys[this], key)
	endif
endfunction

function dispatch_HashMap_HashMap_HashMap_put takes integer this, integer key, integer value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashMap.put")
		else
			call error("Called HashMap.put on invalid object.")
		endif
	endif
	if Table_typeId[this] <= 24 then
		call HashMap_put(this, key, value)
	else
		call IterableMap_put(this, key, value)
	endif
endfunction

function print takes string msg returns nothing
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., msg)
endfunction

function print_169 takes integer msg returns nothing
	call print(I2S(msg))
endfunction

function print_170 takes real msg returns nothing
	call print(R2S(msg))
endfunction

function print_171 takes boolean msg returns nothing
	local string msgString = "False"
	if msg then
		set msgString = "True"
	endif
	call print(msgString)
endfunction

function realFromIndex takes integer index returns real
	return index / 1000.
endfunction

function realToIndex takes real r returns integer
	return real_toInt(r * 1000.)
endfunction

function hashtable_loadString takes hashtable this, integer parentKey, integer childKey returns string
	return LoadStr(this, parentKey, childKey)
endfunction

function Table_loadString takes integer this, integer parentKey returns string
	return hashtable_loadString(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_loadString takes integer this, integer parentKey returns string
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadString")
		else
			call error("Called Table.loadString on invalid object.")
		endif
	endif
	return Table_loadString(this, parentKey)
endfunction

function stringFromIndex takes integer index returns string
	return dispatch_Table_Table_Table_loadString(TypeCasting_typecastdata, index)
endfunction

function hashtable_hasString takes hashtable this, integer parentKey, integer childKey returns boolean
	return HaveSavedString(this, parentKey, childKey)
endfunction

function Table_hasString takes integer this, integer parentKey returns boolean
	return hashtable_hasString(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_hasString takes integer this, integer parentKey returns boolean
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.hasString")
		else
			call error("Called Table.hasString on invalid object.")
		endif
	endif
	return Table_hasString(this, parentKey)
endfunction

function hashtable_saveString takes hashtable this, integer parentKey, integer childKey, string value returns nothing
	call SaveStr(this, parentKey, childKey, value)
endfunction

function Table_saveString takes integer this, integer parentKey, string value returns nothing
	call hashtable_saveString(Table_ht, this, parentKey, value)
endfunction

function dispatch_Table_Table_Table_saveString takes integer this, integer parentKey, string value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveString")
		else
			call error("Called Table.saveString on invalid object.")
		endif
	endif
	call Table_saveString(this, parentKey, value)
endfunction

function stringToIndex takes string s returns integer
	local integer hash = string_getHash(s)
	loop
		if dispatch_Table_Table_Table_hasString(TypeCasting_typecastdata, hash) then
			exitwhen dispatch_Table_Table_Table_loadString(TypeCasting_typecastdata, hash) == s
		else
			call dispatch_Table_Table_Table_saveString(TypeCasting_typecastdata, hash, s)
			exitwhen true
		endif
		set hash = hash + 1
	endloop
	return hash
endfunction

function hashtable_loadUnitHandle takes hashtable this, integer parentKey, integer childKey returns unit
	return LoadUnitHandle(this, parentKey, childKey)
endfunction

function Table_loadUnit takes integer this, integer parentKey returns unit
	return hashtable_loadUnitHandle(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_loadUnit takes integer this, integer parentKey returns unit
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadUnit")
		else
			call error("Called Table.loadUnit on invalid object.")
		endif
	endif
	return Table_loadUnit(this, parentKey)
endfunction

function hashtable_saveFogStateHandle takes hashtable this, integer parentKey, integer childKey, fogstate value returns nothing
	call SaveFogStateHandle(this, parentKey, childKey, value)
endfunction

function Table_saveFogState takes integer this, integer parentKey, fogstate value returns nothing
	call hashtable_saveFogStateHandle(Table_ht, this, parentKey, value)
endfunction

function dispatch_Table_Table_Table_saveFogState takes integer this, integer parentKey, fogstate value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveFogState")
		else
			call error("Called Table.saveFogState on invalid object.")
		endif
	endif
	call Table_saveFogState(this, parentKey, value)
endfunction

function unitFromIndex takes integer index returns unit
	call dispatch_Table_Table_Table_saveFogState(TypeCasting_typecastdata, 0, ConvertFogState(index))
	return dispatch_Table_Table_Table_loadUnit(TypeCasting_typecastdata, 0)
endfunction

function handle_getHandleId takes handle this returns integer
	return GetHandleId(this)
endfunction

function unitToIndex takes unit object returns integer
	return handle_getHandleId(object)
endfunction

function unit_getName takes unit this returns string
	return GetUnitName(this)
endfunction

function foo takes nothing returns nothing
	local string aString
	local string s
	local integer i
	local real r
	local boolean b
	call dispatch_HashMap_HashMap_HashMap_put(Test_strMap, stringToIndex("a"), stringToIndex("some string"))
	call print(stringFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a"))))
	set aString = stringFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a")))
	set s = "hjgf" + stringFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a")))
	call print(s)
	set s = "hjgf" + aString
	call print(s)
	set s = stringFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a"))) + stringFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a")))
	call print(s)
	if  not MagicFunctions_compiletime then
		call print(unit_getName(unitFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_unitMap, unitToIndex(null)))))
	endif
	set i = dispatch_HashMap_HashMap_HashMap_get(Test_intMap, 0)
	call print_169(i)
	set r = realFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_realMap, realToIndex(0.0)))
	call print_170(r)
	set b = booleanFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_boolMap, booleanToIndex(true)))
	call print_171(b)
	if  not MagicFunctions_compiletime then
		call dispatch_HashMap_HashMap_HashMap_put(Test_unitMap, unitToIndex(null), unitToIndex(createUnit(Player_players[0], 1751543663, 0., 0., 0.)))
		call print(unit_getName(unitFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_unitMap, unitToIndex(null)))))
	endif
	call dispatch_HashMap_HashMap_HashMap_put(Test_intMap, 4, 8)
	set i = dispatch_HashMap_HashMap_HashMap_get(Test_intMap, 4)
	call print_169(i)
	call dispatch_HashMap_HashMap_HashMap_put(Test_realMap, realToIndex(3.7754), realToIndex(591.53))
	set r = realFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_realMap, realToIndex(3.7754)))
	call print_170(r)
	call dispatch_HashMap_HashMap_HashMap_put(Test_boolMap, booleanToIndex(true), booleanToIndex(true))
	set b = booleanFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_boolMap, booleanToIndex(true)))
	call print_171(b)
endfunction

function call_doAfter_Test takes integer this returns nothing
	call foo()
endfunction

function dispatch_CallbackSingle_ClosureTimers_CallbackSingle_call takes integer this returns nothing
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.call")
		else
			call error("Called CallbackSingle.call on invalid object.")
		endif
	endif
	if CallbackSingle_typeId[this] <= 10 then
		if CallbackSingle_typeId[this] <= 9 then
			if CallbackSingle_typeId[this] <= 8 then
				call call_doAfter_ClosureTimers(this)
			else
				call call_doAfter_ClosureTimers_72(this)
			endif
		else
			call call_doAfter_ClosureTimers_73(this)
		endif
	elseif CallbackSingle_typeId[this] <= 11 then
		call call_doAfter_ClosureTimers_74(this)
	else
		call call_doAfter_Test(this)
	endif
endfunction

function timer_getHandleId takes timer this returns integer
	return GetHandleId(this)
endfunction

function timer_getData takes timer this returns integer
	return dispatch_Table_Table_Table_loadInt(TimerUtils_timerData, timer_getHandleId(this))
endfunction

function timer_pause takes timer this returns nothing
	call PauseTimer(this)
endfunction

function timer_setData takes timer this, integer data returns nothing
	call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, timer_getHandleId(this), data)
endfunction

function timer_release takes timer this returns nothing
	if this == null then
		call error("Trying to release a null timer")
		return
	endif
	if timer_getData(this) == 679645218 then
		call error("ReleaseTimer: Double free!")
		return
	endif
	call timer_setData(this, 679645218)
	call timer_pause(this)
	set TimerUtils_freeTimers[TimerUtils_freeTimersCount] = this
	set TimerUtils_freeTimersCount = TimerUtils_freeTimersCount + 1
endfunction

function CallbackSingle_onDestroy takes integer this returns nothing
	call timer_release(CallbackSingle_t[this])
endfunction

function dealloc_CallbackSingle takes integer obj returns nothing
	if CallbackSingle_typeId[obj] == 0 then
		call error("Double free: object of type CallbackSingle")
	else
		set CallbackSingle_nextFree[CallbackSingle_firstFree] = obj
		set CallbackSingle_firstFree = CallbackSingle_firstFree + 1
		set CallbackSingle_typeId[obj] = 0
	endif
endfunction

function destroyCallbackSingle takes integer this returns nothing
	call CallbackSingle_onDestroy(this)
	call dealloc_CallbackSingle(this)
endfunction

function dispatch_CallbackSingle_destroyCallbackSingle takes integer this returns nothing
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.CallbackSingle")
		else
			call error("Called CallbackSingle.CallbackSingle on invalid object.")
		endif
	endif
	call destroyCallbackSingle(this)
endfunction

function CallbackSingle_staticCallback takes nothing returns nothing
	local integer cb_1 = timer_getData(GetExpiredTimer())
	call dispatch_CallbackSingle_ClosureTimers_CallbackSingle_call(cb_1)
	call dispatch_CallbackSingle_destroyCallbackSingle(cb_1)
endfunction

function code__start_CallbackSingle_ClosureTimers takes nothing returns nothing
	call CallbackSingle_staticCallback()
endfunction

function init_AbilityIds takes nothing returns boolean
	return true
endfunction

function init_Angle takes nothing returns boolean
	return true
endfunction

function init_Basics takes nothing returns boolean
	return true
endfunction

function init_ClosureTimers takes nothing returns boolean
	set ClosureTimers_x = 200
	return true
endfunction

function toHex takes integer number returns string
	local integer firstpart = number / 16
	return Colors_hexs[firstpart] + Colors_hexs[number - firstpart * 16]
endfunction

function colorA_toColorString takes integer this_red, integer this_green, integer this_blue, integer this_alpha returns string
	return "|c" + toHex(this_alpha) + toHex(this_red) + toHex(this_green) + toHex(this_blue)
endfunction

function initializeTable takes nothing returns nothing
	local integer i = 0
	loop
		exitwhen i > 15
		call dispatch_Table_Table_Table_saveInt(Colors_decs, string_getHash(Colors_hexs[i]), i)
		set i = i + 1
	endloop
endfunction

function alloc_Table takes nothing returns integer
	local integer this
	if Table_firstFree == 0 then
		if Table_maxIndex < 32768 then
			set Table_maxIndex = Table_maxIndex + 1
			set this = Table_maxIndex
			set Table_typeId[this] = 23
		else
			call error("Out of memory: Could not create Table.")
			set this = 0
		endif
	else
		set Table_firstFree = Table_firstFree - 1
		set this = Table_nextFree[Table_firstFree]
		set Table_typeId[this] = 23
	endif
	return this
endfunction

function Table_init takes integer this returns nothing
endfunction

function construct_Table takes integer this returns nothing
	call Table_init(this)
endfunction

function new_Table takes nothing returns integer
	local integer this = alloc_Table()
	call construct_Table(this)
	return this
endfunction

function init_Colors takes nothing returns boolean
	set Colors_hexs[0] = "0"
	set Colors_hexs[1] = "1"
	set Colors_hexs[2] = "2"
	set Colors_hexs[3] = "3"
	set Colors_hexs[4] = "4"
	set Colors_hexs[5] = "5"
	set Colors_hexs[6] = "6"
	set Colors_hexs[7] = "7"
	set Colors_hexs[8] = "8"
	set Colors_hexs[9] = "9"
	set Colors_hexs[10] = "A"
	set Colors_hexs[11] = "B"
	set Colors_hexs[12] = "C"
	set Colors_hexs[13] = "D"
	set Colors_hexs[14] = "E"
	set Colors_hexs[15] = "F"
	set Colors_decs = new_Table()
	call colorA_toColorString(255, 255, 255, 255)
	call colorA_toColorString(0, 0, 0, 0)
	call colorA_toColorString(255, 204, 0, 255)
	call initializeTable()
	return true
endfunction

function init_Destructable takes nothing returns boolean
	return true
endfunction

function init_ErrorHandling takes nothing returns boolean
	set ErrorHandling_HT = hashtable_compiletime_42
	return true
endfunction

function alloc_HashMap takes nothing returns integer
	local integer this
	if Table_firstFree == 0 then
		if Table_maxIndex < 32768 then
			set Table_maxIndex = Table_maxIndex + 1
			set this = Table_maxIndex
			set Table_typeId[this] = 24
		else
			call error("Out of memory: Could not create HashMap.")
			set this = 0
		endif
	else
		set Table_firstFree = Table_firstFree - 1
		set this = Table_nextFree[Table_firstFree]
		set Table_typeId[this] = 24
	endif
	return this
endfunction

function HashMap_init takes integer this returns nothing
	set HashMap_size[this] = 0
endfunction

function construct_HashMap takes integer this returns nothing
	call construct_Table(this)
	call HashMap_init(this)
endfunction

function new_HashMap takes nothing returns integer
	local integer this = alloc_HashMap()
	call construct_HashMap(this)
	return this
endfunction

function init_EventHelper takes nothing returns boolean
	call new_HashMap()
	call new_HashMap()
	call new_Table()
	return true
endfunction

function string_length takes string this returns integer
	return StringLength(this)
endfunction

function verifyFrameNameLength takes string name returns boolean
	if string_length(name) > 560 then
		call error("Trying to address frame with exceeding maximum frame name length (" + int_toString(560) + ") for: " + name)
		return false
	endif
	return true
endfunction

function createFrame takes string typeName, string name, framehandle owner, string inherits, integer createContext returns framehandle
	call verifyFrameNameLength(name)
	return BlzCreateFrameByType(typeName, name, owner, inherits, createContext)
endfunction

function framehandle_setSize takes framehandle this, real width, real height returns nothing
	call BlzFrameSetSize(this, width, height)
endfunction

function init_Framehandle takes nothing returns boolean
	set Framehandle_GAME_UI = BlzGetOriginFrame(ORIGIN_FRAME_GAME_UI, 0)
	call framehandle_setSize(createFrame("FRAME", "SetMousePositionCage", Framehandle_GAME_UI, null, 0), 0.0001, 0.0001)
	return true
endfunction

function timer_start takes timer this, real time, code timerCallBack returns nothing
	call TimerStart(this, time, false, timerCallBack)
endfunction

function timer_startPeriodic takes timer this, real time, code timerCallBack returns nothing
	call TimerStart(this, time, true, timerCallBack)
endfunction

function init_GameTimer takes nothing returns boolean
	call timer_start(CreateTimer(), 100000., null)
	call timer_startPeriodic(CreateTimer(), 0.030, ref_function_code__startPeriodic_GameTimer)
	return true
endfunction

function init_Group takes nothing returns boolean
	call CreateGroup()
	return true
endfunction

function init_HashList takes nothing returns boolean
	set HashList_ht = hashtable_compiletime
	set HashList_occurences = hashtable_compiletime_41
	return true
endfunction

function init_Integer takes nothing returns boolean
	return true
endfunction

function init_Lightning takes nothing returns boolean
	return true
endfunction

function init_MagicFunctions takes nothing returns boolean
	set MagicFunctions_compiletime = false
	return true
endfunction

function init_Maths takes nothing returns boolean
	return true
endfunction

function init_Matrices takes nothing returns boolean
	return true
endfunction

function initPlayerArray takes nothing returns nothing
	local integer i = 0
	local integer temp = bj_MAX_PLAYER_SLOTS - 1
	loop
		exitwhen i > temp
		set Player_players[i] = Player(i)
		set i = i + 1
	endloop
endfunction

function init_Player takes nothing returns boolean
	set Player_localPlayer = GetLocalPlayer()
	call initPlayerArray()
	return true
endfunction

function init_Playercolor takes nothing returns boolean
	return true
endfunction

function init_Printing takes nothing returns boolean
	return true
endfunction

function init_Quaternion takes nothing returns boolean
	return true
endfunction

function init_Real takes nothing returns boolean
	return true
endfunction

function init_String takes nothing returns boolean
	call string_length("0123456789")
	call string_length("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ")
	return true
endfunction

function init_Table takes nothing returns boolean
	set Table_ht = hashtable_compiletime_43
	return true
endfunction

function alloc_CallbackSingle_doAfter_Test takes nothing returns integer
	local integer this
	if CallbackSingle_firstFree == 0 then
		if CallbackSingle_maxIndex < 32768 then
			set CallbackSingle_maxIndex = CallbackSingle_maxIndex + 1
			set this = CallbackSingle_maxIndex
			set CallbackSingle_typeId[this] = 12
		else
			call error("Out of memory: Could not create CallbackSingle_doAfter_Test.")
			set this = 0
		endif
	else
		set CallbackSingle_firstFree = CallbackSingle_firstFree - 1
		set this = CallbackSingle_nextFree[CallbackSingle_firstFree]
		set CallbackSingle_typeId[this] = 12
	endif
	return this
endfunction

function CallbackSingle_init takes integer this returns nothing
endfunction

function construct_CallbackSingle takes integer this returns nothing
	call CallbackSingle_init(this)
endfunction

function getTimer takes nothing returns timer
	local timer receiver
	if TimerUtils_freeTimersCount > 0 then
		set TimerUtils_freeTimersCount = TimerUtils_freeTimersCount - 1
		call timer_setData(TimerUtils_freeTimers[TimerUtils_freeTimersCount], 0)
		return TimerUtils_freeTimers[TimerUtils_freeTimersCount]
	else
		set receiver = CreateTimer()
		call timer_setData(receiver, 0)
		return receiver
	endif
endfunction

function CallbackSingle_start takes integer this, timer whichTimer, real time returns nothing
	call timer_setData(whichTimer, this)
	call timer_start(whichTimer, time, ref_function_code__start_CallbackSingle_ClosureTimers)
	set CallbackSingle_t[this] = whichTimer
endfunction

function dispatch_CallbackSingle_ClosureTimers_CallbackSingle_start takes integer this, timer whichTimer, real time returns nothing
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.start")
		else
			call error("Called CallbackSingle.start on invalid object.")
		endif
	endif
	call CallbackSingle_start(this, whichTimer, time)
endfunction

function timer_doAfter takes timer this, real timeToWait, integer cb_1 returns integer
	call dispatch_CallbackSingle_ClosureTimers_CallbackSingle_start(cb_1, this, timeToWait)
	return cb_1
endfunction

function doAfter takes real timeToWait, integer cb_1 returns integer
	return timer_doAfter(getTimer(), timeToWait, cb_1)
endfunction

function init_Test takes nothing returns boolean
	local integer clVar
	set Test_intMap = new_HashMap()
	set Test_realMap = new_HashMap()
	set Test_boolMap = new_HashMap()
	set Test_strMap = new_HashMap()
	set Test_unitMap = new_HashMap()
	call new_HashMap()
	set clVar = alloc_CallbackSingle_doAfter_Test()
	call construct_CallbackSingle(clVar)
	call doAfter(0.0, clVar)
	return true
endfunction

function init_TimerUtils takes nothing returns boolean
	set TimerUtils_timerData = new_Table()
	call new_HashMap()
	return true
endfunction

function initTypecastData takes nothing returns nothing
	call dispatch_Table_Table_Table_saveString(TypeCasting_typecastdata, 0, "")
endfunction

function init_TypeCasting takes nothing returns boolean
	set TypeCasting_typecastdata = new_Table()
	call initTypecastData()
	return true
endfunction

function init_Vectors takes nothing returns boolean
	call Location(0., 0.)
	return true
endfunction

function init_WeatherEffects takes nothing returns boolean
	return true
endfunction

function initGlobals takes nothing returns nothing
	set ref_function_init_AbilityIds = function init_AbilityIds
	set ref_function_init_Real = function init_Real
	set ref_function_init_Integer = function init_Integer
	set ref_function_init_Angle = function init_Angle
	set ref_function_init_String = function init_String
	set ref_function_init_Vectors = function init_Vectors
	set ref_function_init_Destructable = function init_Destructable
	set ref_function_init_Player = function init_Player
	set ref_function_init_Basics = function init_Basics
	set ref_function_init_MagicFunctions = function init_MagicFunctions
	set ref_function_init_Table = function init_Table
	set ref_function_init_Playercolor = function init_Playercolor
	set ref_function_init_Maths = function init_Maths
	set ref_function_init_Colors = function init_Colors
	set ref_function_init_Printing = function init_Printing
	set ref_function_init_GameTimer = function init_GameTimer
	set ref_function_init_ErrorHandling = function init_ErrorHandling
	set ref_function_init_HashList = function init_HashList
	set ref_function_init_Matrices = function init_Matrices
	set ref_function_init_Quaternion = function init_Quaternion
	set ref_function_init_Framehandle = function init_Framehandle
	set ref_function_init_Group = function init_Group
	set ref_function_init_Lightning = function init_Lightning
	set ref_function_init_WeatherEffects = function init_WeatherEffects
	set ref_function_init_TypeCasting = function init_TypeCasting
	set ref_function_init_TimerUtils = function init_TimerUtils
	set ref_function_init_ClosureTimers = function init_ClosureTimers
	set ref_function_init_EventHelper = function init_EventHelper
	set ref_function_init_Test = function init_Test
	set ref_function_code__startPeriodic_GameTimer = function code__startPeriodic_GameTimer
	set ref_function_code__start_CallbackSingle_ClosureTimers = function code__start_CallbackSingle_ClosureTimers
endfunction

function main takes nothing returns nothing
	local trigger initTrig
	call initGlobals()
	call initCompiletimeState()
	set initTrig = CreateTrigger()
	call TriggerAddCondition(initTrig, Condition(ref_function_init_AbilityIds))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package AbilityIds.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Real))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Real.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Integer))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Integer.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Angle))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Angle.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_String))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package String.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Vectors))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Vectors.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Destructable))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Destructable.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Player))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Player.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Basics))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Basics.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_MagicFunctions))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package MagicFunctions.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Table))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Table.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Playercolor))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Playercolor.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Maths))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Maths.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Colors))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Colors.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Printing))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Printing.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_GameTimer))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package GameTimer.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ErrorHandling))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ErrorHandling.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_HashList))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package HashList.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Matrices))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Matrices.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Quaternion))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Quaternion.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Framehandle))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Framehandle.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Group))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Group.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Lightning))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Lightning.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_WeatherEffects))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package WeatherEffects.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_TypeCasting))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TypeCasting.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_TimerUtils))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TimerUtils.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ClosureTimers))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ClosureTimers.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_EventHelper))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package EventHelper.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Test))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Test.")
	endif
	call TriggerClearConditions(initTrig)
	call DestroyTrigger(initTrig)
endfunction

function config takes nothing returns nothing
endfunction

