// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array D_nextFree
integer D_firstFree=0
integer D_maxIndex=0
integer array D_typeId
integer array D_B_A_x
integer array D_C_A_x
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native println takes string s returns nothing
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function D_setX takes integer this, integer x returns nothing
	local integer x_1 = x / 2
	call println("set x " + I2S(x_1))
	set D_B_A_x[this] = x_1
	call println("get x " + I2S(D_B_A_x[this]))
	set x = x - D_B_A_x[this]
	call println("set x " + I2S(x))
	set D_C_A_x[this] = x
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function new_D takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_D in diamond.wurst, line 31"
	set wurst_stack_depth = wurst_stack_depth + 1
	if D_firstFree == 0 then
		if D_maxIndex < 32768 then
			set D_maxIndex = D_maxIndex + 1
			set this = D_maxIndex
			set D_typeId[this] = 1
		else
			call error("Out of memory: Could not create D.", "when calling error in diamond.wurst, line 31")
			set this = 0
		endif
	else
		set D_firstFree = D_firstFree - 1
		set this = D_nextFree[D_firstFree]
		set D_typeId[this] = 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer d
	local integer temp
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set d = new_D("when calling new_D in diamond.wurst, line 50")
	set wurst_stack[wurst_stack_depth] = "when calling setX in diamond.wurst, line 52"
	set wurst_stack_depth = wurst_stack_depth + 1
	if D_typeId[d] == 0 then
		if d == 0 then
			call error("Nullpointer exception when calling D.setX", "when calling error in diamond.wurst, line 35")
		else
			call error("Called D.setX on invalid object.", "when calling error in diamond.wurst, line 35")
		endif
	endif
	call D_setX(d, 5)
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling getX in diamond.wurst, line 54"
	set wurst_stack_depth = wurst_stack_depth + 1
	if D_typeId[d] == 0 then
		if d == 0 then
			call error("Nullpointer exception when calling D.getX", "when calling error in diamond.wurst, line 41")
		else
			call error("Called D.getX on invalid object.", "when calling error in diamond.wurst, line 41")
		endif
	endif
	call println("get x " + I2S(D_B_A_x[d]))
	set temp = D_B_A_x[d]
	call println("get x " + I2S(D_C_A_x[d]))
	set temp = temp + D_C_A_x[d]
	set wurst_stack_depth = wurst_stack_depth - 1
	if temp != 5 then
		set wurst_stack[wurst_stack_depth] = "when calling getX in diamond.wurst, line 55"
		set wurst_stack_depth = wurst_stack_depth + 1
		if D_typeId[d] == 0 then
			if d == 0 then
				call error("Nullpointer exception when calling D.getX", "when calling error in diamond.wurst, line 41")
			else
				call error("Called D.getX on invalid object.", "when calling error in diamond.wurst, line 41")
			endif
		endif
		call println("get x " + I2S(D_B_A_x[d]))
		set temp = D_B_A_x[d]
		call println("get x " + I2S(D_C_A_x[d]))
		set d = temp + D_C_A_x[d]
		set wurst_stack_depth = wurst_stack_depth - 1
		call testFail("foo fail" + I2S(d))
	endif
	call testSuccess()
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in diamond.wurst, line 1")
endfunction

function config takes nothing returns nothing
endfunction

