// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array D_nextFree
integer D_firstFree=0
integer D_maxIndex=0
integer array D_typeId
integer array D_B_A_x
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function new_D takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_D in diamond2.wurst, line 28"
	set wurst_stack_depth = wurst_stack_depth + 1
	if D_firstFree == 0 then
		if D_maxIndex < 32768 then
			set D_maxIndex = D_maxIndex + 1
			set this = D_maxIndex
			set D_typeId[this] = 1
		else
			call error("Out of memory: Could not create D.", "when calling error in diamond2.wurst, line 28")
			set this = 0
		endif
	else
		set D_firstFree = D_firstFree - 1
		set this = D_nextFree[D_firstFree]
		set D_typeId[this] = 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer d
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set d = new_D("when calling new_D in diamond2.wurst, line 44")
	set wurst_stack[wurst_stack_depth] = "when calling setX in diamond2.wurst, line 46"
	set wurst_stack_depth = wurst_stack_depth + 1
	if D_typeId[d] == 0 then
		if d == 0 then
			call error("Nullpointer exception when calling D.setX", "when calling error in diamond2.wurst, line 32")
		else
			call error("Called D.setX on invalid object.", "when calling error in diamond2.wurst, line 32")
		endif
	endif
	set D_B_A_x[d] = 4
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling getX in diamond2.wurst, line 48"
	set wurst_stack_depth = wurst_stack_depth + 1
	if D_typeId[d] == 0 then
		if d == 0 then
			call error("Nullpointer exception when calling D.getX", "when calling error in diamond2.wurst, line 35")
		else
			call error("Called D.getX on invalid object.", "when calling error in diamond2.wurst, line 35")
		endif
	endif
	set d = D_B_A_x[d]
	set wurst_stack_depth = wurst_stack_depth - 1
	if d != 4 then
		call testFail("foo fail")
	endif
	call testSuccess()
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in diamond2.wurst, line 1")
endfunction

function config takes nothing returns nothing
endfunction

