// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer Test_res=0
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set A_firstFree = 0
	set A_maxIndex = 0
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
	endif
	return this
endfunction

function construct_A_Test takes integer this returns nothing
	local integer x = 2
	local integer y
	set Test_res = Test_res + x
	set y = 1
	set Test_res = Test_res - y
endfunction

function A_init takes integer this returns nothing
	call construct_A_Test(this)
endfunction

function construct_A takes integer this returns nothing
	call A_init(this)
	set Test_res = Test_res * 2
endfunction

function new_A takes nothing returns integer
	local integer this = alloc_A()
	call construct_A(this)
	return this
endfunction

function construct_A2 takes integer this, integer i returns nothing
	call A_init(this)
	set Test_res = Test_res * i
endfunction

function new_A_11 takes integer i returns integer
	local integer this = alloc_A()
	call construct_A2(this, i)
	return this
endfunction

function init_Test takes nothing returns nothing
	set Test_res = 1
	call new_A()
	call new_A_11(3)
	if Test_res == 15 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

