// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array A_M_i
endglobals
native testFail takes string message returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_Test_A_f takes integer this returns nothing
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.f")
		else
			call error("Called A.f on invalid object.")
		endif
	endif
	set A_M_i[this] = A_M_i[this] + 1
	set A_M_i[this] = A_M_i[this] + 1
endfunction

function dispatch_B_Test_B_g takes integer this returns nothing
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.g")
		else
			call error("Called B.g on invalid object.")
		endif
	endif
	set A_M_i[this] = A_M_i[this] + 1
	set A_M_i[this] = A_M_i[this] + 1
	set A_M_i[this] = A_M_i[this] + 1
endfunction

function new_B takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 2
	endif
	set A_M_i[this] = 0
	return this
endfunction

function init_Test takes nothing returns nothing
	local integer b = new_B()
	call dispatch_A_Test_A_f(b)
	call dispatch_B_Test_B_g(b)
	if A_M_i[b] != 5 then
		call testFail("foo")
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

