// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array E_nextFree
integer E_firstFree=0
integer E_maxIndex=0
integer array E_typeId
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_E takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	local integer this_3
	if E_firstFree == 0 then
		if E_maxIndex < 32768 then
			set E_maxIndex = E_maxIndex + 1
			set this_1 = E_maxIndex
			set E_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create E.")
			set this_1 = 0
		endif
	else
		set E_firstFree = E_firstFree - 1
		set this_1 = E_nextFree[E_firstFree]
		set E_typeId[this_1] = 1
	endif
	set this = this_1
	set this_2 = this
	set this_3 = this_2
	return this
endfunction

function init_test takes nothing returns nothing
	local integer e = new_E()
	local integer this = e
	local integer test_E_D_C_B_foo_result
	local integer this_1
	local integer test_E_D_C_A_bar_result
	if E_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling E.foo")
		else
			call error("Called E.foo on invalid object.")
		endif
	endif
	set test_E_D_C_B_foo_result = 3
	if test_E_D_C_B_foo_result != 3 then
		call testFail("foo fail")
	endif
	set this_1 = e
	if E_typeId[this_1] == 0 then
		if this_1 == 0 then
			call error("Nullpointer exception when calling E.bar")
		else
			call error("Called E.bar on invalid object.")
		endif
	endif
	set test_E_D_C_A_bar_result = 2
	if test_E_D_C_A_bar_result != 2 then
		call testFail("bar fail")
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

