// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array E_nextFree
integer E_firstFree=0
integer E_maxIndex=0
integer array E_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_E takes nothing returns integer
	local integer this
	if E_firstFree == 0 then
		if E_maxIndex < 32768 then
			set E_maxIndex = E_maxIndex + 1
			set this = E_maxIndex
			set E_typeId[this] = 1
		else
			call error("Out of memory: Could not create E.")
			set this = 0
		endif
	else
		set E_firstFree = E_firstFree - 1
		set this = E_nextFree[E_firstFree]
		set E_typeId[this] = 1
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer e = new_E()
	if E_typeId[e] == 0 then
		if e == 0 then
			call error("Nullpointer exception when calling E.foo")
		else
			call error("Called E.foo on invalid object.")
		endif
	endif
	if E_typeId[e] == 0 then
		if e == 0 then
			call error("Nullpointer exception when calling E.bar")
		else
			call error("Called E.bar on invalid object.")
		endif
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

