// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
integer array E_nextFree
integer E_firstFree=0
integer E_maxIndex=0
integer array E_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function D_foo takes integer this returns nothing
	call testSuccess()
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_D_Test_E_A_D_foo takes integer this returns nothing
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling D.foo")
		else
			call error("Called D.foo on invalid object.")
		endif
	endif
	call D_foo(this)
endfunction

function alloc_D takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 2
		else
			call error("Out of memory: Could not create D.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 2
	endif
	return this
endfunction

function D_init takes integer this returns nothing
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function construct_D takes integer this returns nothing
	call construct_C(this)
	call D_init(this)
endfunction

function new_D takes nothing returns integer
	local integer this = alloc_D()
	call construct_D(this)
	return this
endfunction

function E_A_test takes integer this returns nothing
	call dispatch_D_Test_E_A_D_foo(new_D())
endfunction

function dispatch_E_Test_E_A_test takes integer this returns nothing
	if E_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling E.test")
		else
			call error("Called E.test on invalid object.")
		endif
	endif
	call E_A_test(this)
endfunction

function alloc_E takes nothing returns integer
	local integer this
	if E_firstFree == 0 then
		if E_maxIndex < 32768 then
			set E_maxIndex = E_maxIndex + 1
			set this = E_maxIndex
			set E_typeId[this] = 3
		else
			call error("Out of memory: Could not create E.")
			set this = 0
		endif
	else
		set E_firstFree = E_firstFree - 1
		set this = E_nextFree[E_firstFree]
		set E_typeId[this] = 3
	endif
	return this
endfunction

function construct_E_A takes integer this returns nothing
endfunction

function E_init takes integer this returns nothing
	call construct_E_A(this)
endfunction

function construct_E takes integer this returns nothing
	call E_init(this)
endfunction

function new_E takes nothing returns integer
	local integer this = alloc_E()
	call construct_E(this)
	return this
endfunction

function init_Test takes nothing returns nothing
	call dispatch_E_Test_E_A_test(new_E())
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

