// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_B_A_x
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set C_firstFree = 0
	set C_maxIndex = 0
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	return this
endfunction

function construct_C_B_A takes integer this returns nothing
	set C_B_A_x[this] = C_B_A_x[this] - 1
endfunction

function construct_C_B takes integer this returns nothing
	call construct_C_B_A(this)
endfunction

function C_init takes integer this returns nothing
	set C_B_A_x[this] = 3
	call construct_C_B(this)
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function init_Test takes nothing returns nothing
	local integer c = new_C()
	if C_B_A_x[c] == 2 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

