// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function destroyB takes integer this returns nothing
	local integer obj
	call testSuccess()
	set obj = this
	if A_typeId[obj] == 0 then
		call error("Double free: object of type B")
	else
		set A_nextFree[A_firstFree] = obj
		set A_firstFree = A_firstFree + 1
		set A_typeId[obj] = 0
	endif
endfunction

function dispatch_A_destroyA takes integer this returns nothing
	local integer this_1
	local integer obj
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.A")
		else
			call error("Called A.A on invalid object.")
		endif
	endif
	if A_typeId[this] <= 1 then
		set this_1 = this
		set obj = this_1
		if A_typeId[obj] == 0 then
			call error("Double free: object of type A")
		else
			set A_nextFree[A_firstFree] = obj
			set A_firstFree = A_firstFree + 1
			set A_typeId[obj] = 0
		endif
	else
		call destroyB(this)
	endif
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_B takes nothing returns integer
	local integer this
	local integer this_1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create B.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 2
	endif
	set this = this_1
	return this
endfunction

function main takes nothing returns nothing
	local integer b
	call initGlobals()
	set b = new_B()
	call dispatch_A_destroyA(b)
endfunction

function config takes nothing returns nothing
endfunction

