// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Blub_nextFree
integer Blub_firstFree=0
integer Blub_maxIndex=0
integer array Blub_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_Blub takes nothing returns integer
	local integer this
	if Blub_firstFree == 0 then
		if Blub_maxIndex < 32768 then
			set Blub_maxIndex = Blub_maxIndex + 1
			set this = Blub_maxIndex
			set Blub_typeId[this] = 1
		else
			call error("Out of memory: Could not create Blub.")
			set this = 0
		endif
	else
		set Blub_firstFree = Blub_firstFree - 1
		set this = Blub_nextFree[Blub_firstFree]
		set Blub_typeId[this] = 1
	endif
	return this
endfunction

function new_Foo takes nothing returns integer
	local integer this
	if Blub_firstFree == 0 then
		if Blub_maxIndex < 32768 then
			set Blub_maxIndex = Blub_maxIndex + 1
			set this = Blub_maxIndex
			set Blub_typeId[this] = 2
		else
			call error("Out of memory: Could not create Foo.")
			set this = 0
		endif
	else
		set Blub_firstFree = Blub_firstFree - 1
		set this = Blub_nextFree[Blub_firstFree]
		set Blub_typeId[this] = 2
	endif
	return this
endfunction

function init_Test takes nothing returns nothing
	local integer b = new_Blub()
	local integer f = new_Foo()
	if Blub_typeId[b] == 1 and Blub_typeId[f] == 2 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

