// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
// integer PLAYER_NEUTRAL_PASSIVE=0
// originframetype ORIGIN_FRAME_GAME_UI=null
// integer bj_MAX_PLAYER_SLOTS=0
// rect bj_mapInitialPlayableArea=null
player Basics_DUMMY_PLAYER=null
integer array BitSet_pows
integer array ClosureForGroups_tempCallbacks
integer ClosureForGroups_iterCount=0
integer ClosureTimers_x=0
string array Colors_hexs
integer Colors_decs=0
real DummyRecycler_ANGLE_DEGREE=0.
integer array DummyRecycler_angleQueues
trigger UnitEntity_dmgTrig=null
hashtable ErrorHandling_HT=null
framehandle Framehandle_GAME_UI=null
real GameTimer_currentTime=0.
boolean MagicFunctions_compiletime=false
rect MapBounds_playableMapRect=null
rect MapBounds_boundRect=null
real MapBounds_playableMin_x=0.
real MapBounds_playableMin_y=0.
real MapBounds_boundMax_x=0.
real MapBounds_boundMax_y=0.
player array Player_players
player Player_localPlayer=null
group Preloader_dumg=null
unit Preloader_dum=null
integer array ChannelData_TimedLoop_instances
integer ChannelData_TimedLoop_instanceCount=0
triggercondition ChannelData_TimedLoop_triggerCond=null
hashtable Table_ht=null
item Terrain_dItem=null
trigger TimedLoop_timedLoopTrig=null
integer TimedLoop_conditionCount=0
timer array TimerUtils_freeTimers
integer TimerUtils_freeTimersCount=0
integer TimerUtils_timerData=0
integer TypeCasting_typecastdata=0
hashtable hashtable_compiletime=null
hashtable hashtable_compiletime_81=null
integer array ForGroupCallback_nextFree
integer ForGroupCallback_firstFree=0
integer ForGroupCallback_maxIndex=0
integer array ForGroupCallback_typeId
integer array CallbackSingle_nextFree
integer CallbackSingle_firstFree=0
integer CallbackSingle_maxIndex=0
integer array CallbackSingle_typeId
integer Callback_firstFree=0
integer array Callback_typeId
integer BackIterator_firstFree=0
integer BackIterator_maxIndex=0
integer Iterator_firstFree=0
integer Iterator_maxIndex=0
integer array Table_nextFree
integer Table_firstFree=0
integer Table_maxIndex=0
integer array Table_typeId
integer Comparator_firstFree=0
integer Comparator_maxIndex=0
integer array LLEntry_nextFree
integer LLEntry_firstFree=0
integer LLEntry_maxIndex=0
integer array LinkedList_nextFree
integer LinkedList_firstFree=0
integer LinkedList_maxIndex=0
integer array LinkedList_typeId
integer IdGenerator_firstFree=0
integer IdGenerator_maxIndex=0
integer ChannelData_firstFree=0
integer array ChannelData_typeId
integer array cb
timerdialog array dia
timer array CallbackSingle_t
unit array u
integer array result
integer array LLEntry_prev
integer array LinkedList_dummy
integer array LinkedList_size
texttag array ChannelData_tt
real array ChannelData_currentAmount
real array ChannelData_incAmount
integer array ChannelData_TimedLoop_mode
code ref_function_init_AbilityIds=null
code ref_function_init_Real=null
code ref_function_init_Integer=null
code ref_function_init_BitSet=null
code ref_function_init_String=null
code ref_function_init_TargetsAllowed=null
code ref_function_init_Angle=null
code ref_function_init_Vectors=null
code ref_function_init_Destructable=null
code ref_function_init_Player=null
code ref_function_init_Maths=null
code ref_function_init_Printing=null
code ref_function_init_MagicFunctions=null
code ref_function_init_Basics=null
code ref_function_init_GameTimer=null
code ref_function_init_ErrorHandling=null
code ref_function_init_Matrices=null
code ref_function_init_Quaternion=null
code ref_function_init_Table=null
code ref_function_init_Playercolor=null
code ref_function_init_Colors=null
code ref_function_init_Framehandle=null
code ref_function_init_Group=null
code ref_function_init_Lightning=null
code ref_function_init_WeatherEffects=null
code ref_function_init_TypeCasting=null
code ref_function_init_HashList=null
code ref_function_init_EventHelper=null
code ref_function_init_AbilityObjEditing=null
code ref_function_init_ClosureForGroups=null
code ref_function_init_TimerUtils=null
code ref_function_init_ClosureTimers=null
code ref_function_init_MapBounds=null
code ref_function_init_LinkedList=null
code ref_function_init_ObjectIds=null
code ref_function_init_UnitIds=null
code ref_function_init_Icons=null
code ref_function_init_Preloader=null
code ref_function_init_ObjectIdGenerator=null
code ref_function_init_DummyRecycler=null
code ref_function_init_Terrain=null
code ref_function_init_Entity=null
code ref_function_init_TimedLoop=null
code ref_function_init_SpellEnergyBarrier=null
code ref_function_code__Filter_ClosureForGroups=null
code ref_function_UnitEntity_onDamage=null
code ref_function_code__startPeriodic_GameTimer=null
code ref_function_ChannelData_TimedLoop_onExpire=null
code ref_function_code__start_CallbackSingle_ClosureTimers=null
endglobals
function Loglevel_getTag takes integer this returns string
	if this == 0 then
		return "|cffADADADtrace|r"
	elseif this == 1 then
		return "|cff2685DCdebug|r"
	elseif this == 2 then
		return "|cffFFCC00info|r"
	elseif this == 3 then
		return "|cffF47E3Ewarning|r"
	else
		return "|cffFB2700error|r"
	endif
endfunction

function compileError takes string msg returns nothing
endfunction

function error takes string msg returns nothing
	local integer hash
	local player showTo
	if MagicFunctions_compiletime then
		call compileError("ERROR: " + msg)
	else
		set hash = StringHash(msg)
		if HaveSavedInteger(ErrorHandling_HT, -1, hash) then
			if LoadInteger(ErrorHandling_HT, -1, hash) + 60 < GameTimer_currentTime then
				set msg = msg + ""
				set showTo = Player_localPlayer
				if 2 <= 4 then
					call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + msg)
				endif
				call SaveInteger(ErrorHandling_HT, -1, hash, R2I(GameTimer_currentTime))
				call SaveBoolean(ErrorHandling_HT, -1, hash, false)
			elseif HaveSavedBoolean(ErrorHandling_HT, -1, hash) then
				if  not LoadBoolean(ErrorHandling_HT, -1, hash) then
					set showTo = Player_localPlayer
					if 2 <= 4 then
						call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + "|cffFF3A29Excessive repeating errors are being omitted")
					endif
					call SaveBoolean(ErrorHandling_HT, -1, hash, true)
				endif
			else
				set showTo = Player_localPlayer
				if 2 <= 4 then
					call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + "|cffFF3A29Excessive repeating errors are being omitted")
				endif
				call SaveBoolean(ErrorHandling_HT, -1, hash, true)
			endif
		else
			call SaveInteger(ErrorHandling_HT, -1, hash, R2I(GameTimer_currentTime))
			set msg = "Message: " + msg + ""
			set showTo = Player_localPlayer
			if 2 <= 4 then
				call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + msg)
			endif
		endif
		call I2S(1 / 0)
	endif
endfunction

function initCompiletimeState_0 takes nothing returns nothing
	call InitHashtable()
	call InitHashtable()
	set hashtable_compiletime_81 = InitHashtable()
	set hashtable_compiletime = InitHashtable()
	call SaveInteger(hashtable_compiletime_81, 1, -242600650, 0)
	call SaveInteger(hashtable_compiletime_81, 1, 1132341824, 1)
	call SaveInteger(hashtable_compiletime_81, 1, -647782241, 2)
	call SaveInteger(hashtable_compiletime_81, 1, -854572045, 3)
	call SaveInteger(hashtable_compiletime_81, 1, -680649701, 4)
	call SaveInteger(hashtable_compiletime_81, 1, -943650483, 5)
	call SaveInteger(hashtable_compiletime_81, 1, -671760605, 6)
	call SaveInteger(hashtable_compiletime_81, 1, 349230650, 7)
	call SaveInteger(hashtable_compiletime_81, 1, -1894922563, 8)
	call SaveInteger(hashtable_compiletime_81, 1, -1474492777, 9)
	call SaveInteger(hashtable_compiletime_81, 1, -1587459251, 10)
	call SaveInteger(hashtable_compiletime_81, 1, -1676716706, 11)
	call SaveInteger(hashtable_compiletime_81, 1, -1559655710, 12)
	call SaveInteger(hashtable_compiletime_81, 1, -1663695754, 13)
	call SaveInteger(hashtable_compiletime_81, 1, 597637742, 14)
	call SaveInteger(hashtable_compiletime_81, 1, 789744696, 15)
	call SaveStr(hashtable_compiletime_81, 2, 0, "")
	call SaveStr(hashtable_compiletime_81, 2, 1804483594, "air")
	call SaveStr(hashtable_compiletime_81, 2, -1221441622, "debris")
	call SaveStr(hashtable_compiletime_81, 2, -681966791, "ground")
	call SaveStr(hashtable_compiletime_81, 2, -1912775212, "invulnerable")
	call SaveStr(hashtable_compiletime_81, 2, 392811314, "item")
	call SaveStr(hashtable_compiletime_81, 2, 124309475, "structure")
	call SaveStr(hashtable_compiletime_81, 2, -543400682, "vulnerable")
	call SaveStr(hashtable_compiletime_81, 2, -85648186, "ward")
	call SaveStr(hashtable_compiletime_81, 2, -612826229, "Avul")
	call SaveStr(hashtable_compiletime_81, 2, 1282521876, "Aloc")
	call SaveStr(hashtable_compiletime_81, 2, -844489484, "AM02")
endfunction

function destroyChannelData takes integer this returns nothing
	if ChannelData_TimedLoop_mode[this] != 1 then
		if ChannelData_typeId[this] == 0 then
			if this == 0 then
				call error("Nullpointer exception when calling ChannelData.stopTimedLoop")
			else
				call error("Called ChannelData.stopTimedLoop on invalid object.")
			endif
		endif
		set ChannelData_TimedLoop_mode[this] = 2
	endif
	if ChannelData_typeId[this] == 0 then
		call error("Double free: object of type ChannelData")
	else
		set ChannelData_firstFree = ChannelData_firstFree + 1
		set ChannelData_typeId[this] = 0
	endif
endfunction

function dispatch_ChannelData_SpellEnergyBarrier_ChannelData_onTimedLoop takes integer this returns nothing
	if ChannelData_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling ChannelData.onTimedLoop")
		else
			call error("Called ChannelData.onTimedLoop on invalid object.")
		endif
	endif
	set ChannelData_currentAmount[this] = ChannelData_currentAmount[this] + ChannelData_incAmount[this]
	call SetTextTagText(ChannelData_tt[this], R2S(ChannelData_currentAmount[this]), 0.00007935)
endfunction

function ChannelData_TimedLoop_onExpire takes nothing returns boolean
	local integer i = ChannelData_TimedLoop_instanceCount - 1
	local integer t
	loop
		exitwhen i < 0
		set t = ChannelData_TimedLoop_instances[i]
		call dispatch_ChannelData_SpellEnergyBarrier_ChannelData_onTimedLoop(t)
		if ChannelData_TimedLoop_mode[t] != 0 then
			set ChannelData_TimedLoop_instanceCount = ChannelData_TimedLoop_instanceCount - 1
			set ChannelData_TimedLoop_instances[i] = ChannelData_TimedLoop_instances[ChannelData_TimedLoop_instanceCount]
			if ChannelData_TimedLoop_mode[t] == 3 then
				set ChannelData_TimedLoop_mode[t] = 1
				if ChannelData_typeId[t] == 0 then
					if t == 0 then
						call error("Nullpointer exception when calling ChannelData.ChannelData")
					else
						call error("Called ChannelData.ChannelData on invalid object.")
					endif
				endif
				call destroyChannelData(t)
			else
				set ChannelData_TimedLoop_mode[t] = 1
			endif
		endif
		set i = i - 1
	endloop
	if ChannelData_TimedLoop_instanceCount == 0 then
		call TriggerRemoveCondition(TimedLoop_timedLoopTrig, ChannelData_TimedLoop_triggerCond)
		set ChannelData_TimedLoop_triggerCond = null
		set TimedLoop_conditionCount = TimedLoop_conditionCount - 1
	endif
	return false
endfunction

function UnitEntity_onDamage takes nothing returns nothing
endfunction

function new_LLEntry takes integer elem, integer prev, integer next returns integer
	if LLEntry_firstFree == 0 then
		if LLEntry_maxIndex < 32768 then
			set LLEntry_maxIndex = LLEntry_maxIndex + 1
			set next = LLEntry_maxIndex
		else
			call error("Out of memory: Could not create LLEntry.")
			set next = 0
		endif
	else
		set LLEntry_firstFree = LLEntry_firstFree - 1
		set next = LLEntry_nextFree[LLEntry_firstFree]
	endif
	set LLEntry_prev[next] = prev
	return next
endfunction

function dispatch_LinkedList_LinkedList_LinkedList_add_1 takes integer this, integer elems_0 returns nothing
	local integer entry
	if LinkedList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling LinkedList.add")
		else
			call error("Called LinkedList.add on invalid object.")
		endif
	endif
	set entry = new_LLEntry(elems_0, LLEntry_prev[LinkedList_dummy[this]], LinkedList_dummy[this])
	set LLEntry_prev[LinkedList_dummy[this]] = entry
	set LinkedList_size[this] = LinkedList_size[this] + 1
endfunction

function dispatch_ForGroupCallback_ClosureForGroups_ForGroupCallback_callback takes integer this, unit u_1 returns nothing
	if ForGroupCallback_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling ForGroupCallback.callback")
		else
			call error("Called ForGroupCallback.callback on invalid object.")
		endif
	endif
	if ForGroupCallback_typeId[this] <= 656 then
		call dispatch_LinkedList_LinkedList_LinkedList_add_1(result[this], GetHandleId(u_1))
	else
		call RemoveUnit(u_1)
	endif
endfunction

function code__Filter_ClosureForGroups takes nothing returns nothing
	local unit filter = GetFilterUnit()
	if ClosureForGroups_iterCount < 2147483647 then
		call dispatch_ForGroupCallback_ClosureForGroups_ForGroupCallback_callback(ClosureForGroups_tempCallbacks[-1], filter)
	endif
	set ClosureForGroups_iterCount = ClosureForGroups_iterCount + 1
endfunction

function code__startPeriodic_GameTimer takes nothing returns nothing
	set GameTimer_currentTime = GameTimer_currentTime + 0.030
endfunction

function DummyRecycler_recycle takes unit u_1 returns nothing
	local integer smallestQueue = 0
	local integer i = 1
	local integer temp = 7
	local integer LinkedList_LinkedList_size_result
	local integer this
	local integer elem
	local real tuple_temp
	local real tuple_temp_1
	loop
		exitwhen i > temp
		set LinkedList_LinkedList_size_result = DummyRecycler_angleQueues[smallestQueue]
		if LinkedList_typeId[LinkedList_LinkedList_size_result] == 0 then
			if LinkedList_LinkedList_size_result == 0 then
				call error("Nullpointer exception when calling LinkedList.size")
			else
				call error("Called LinkedList.size on invalid object.")
			endif
		endif
		set LinkedList_LinkedList_size_result = LinkedList_size[LinkedList_LinkedList_size_result]
		set this = DummyRecycler_angleQueues[i]
		if LinkedList_typeId[this] == 0 then
			if this == 0 then
				call error("Nullpointer exception when calling LinkedList.size")
			else
				call error("Called LinkedList.size on invalid object.")
			endif
		endif
		if LinkedList_LinkedList_size_result > LinkedList_size[this] then
			set smallestQueue = i
		endif
		set i = i + 1
	endloop
	set temp = DummyRecycler_angleQueues[smallestQueue]
	if LinkedList_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling LinkedList.size")
		else
			call error("Called LinkedList.size on invalid object.")
		endif
	endif
	if LinkedList_size[temp] >= 6 then
		call RemoveUnit(u_1)
	else
		set temp = DummyRecycler_angleQueues[smallestQueue]
		set elem = GetHandleId(u_1)
		if LinkedList_typeId[temp] == 0 then
			if temp == 0 then
				call error("Nullpointer exception when calling LinkedList.enqueue")
			else
				call error("Called LinkedList.enqueue on invalid object.")
			endif
		endif
		call dispatch_LinkedList_LinkedList_LinkedList_add_1(temp, elem)
		set tuple_temp_1 = MapBounds_boundMax_x
		set tuple_temp = MapBounds_boundMax_y
		set tuple_temp_1 = tuple_temp_1 - 16.
		set tuple_temp = tuple_temp - 16.
		call SetUnitX(u_1, tuple_temp_1)
		call SetUnitY(u_1, tuple_temp)
		call PauseUnit(u_1, true)
		set tuple_temp = smallestQueue * DummyRecycler_ANGLE_DEGREE * 0.017453293
		call SetUnitFacing(u_1, tuple_temp * 57.295779513)
		call SetUnitScale(u_1, 1., 1., 1.)
		call SetUnitVertexColor(u_1, 255, 255, 255, 255)
		call SetUnitOwner(u_1, Basics_DUMMY_PLAYER, true)
	endif
endfunction

function dispatch_Callback_destroyCallback takes integer this returns nothing
	if Callback_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Callback.Callback")
		else
			call error("Called Callback.Callback on invalid object.")
		endif
	endif
	if Callback_typeId[this] == 0 then
		call error("Double free: object of type Callback")
	else
		set Callback_firstFree = Callback_firstFree + 1
		set Callback_typeId[this] = 0
	endif
endfunction

function call_doAfter_ClosureTimers takes integer this returns nothing
	call dispatch_Callback_destroyCallback(cb[this])
	call DestroyTimerDialog(dia[this])
endfunction

function dispatch_ForGroupCallback_destroyForGroupCallback takes integer this returns nothing
	if ForGroupCallback_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling ForGroupCallback.ForGroupCallback")
		else
			call error("Called ForGroupCallback.ForGroupCallback on invalid object.")
		endif
	endif
	if ForGroupCallback_typeId[this] == 0 then
		call error("Double free: object of type ForGroupCallback")
	else
		set ForGroupCallback_nextFree[ForGroupCallback_firstFree] = this
		set ForGroupCallback_firstFree = ForGroupCallback_firstFree + 1
		set ForGroupCallback_typeId[this] = 0
	endif
endfunction

function group_forEachFrom takes group this, integer cb_1 returns nothing
	local unit iterUnit
	loop
		exitwhen FirstOfGroup(this) == null
		set iterUnit = FirstOfGroup(this)
		call GroupRemoveUnit(this, iterUnit)
		call dispatch_ForGroupCallback_ClosureForGroups_ForGroupCallback_callback(cb_1, iterUnit)
	endloop
	call dispatch_ForGroupCallback_destroyForGroupCallback(cb_1)
endfunction

function finishPreload takes nothing returns nothing
	local group temp
	local integer this
	call RemoveUnit(Preloader_dum)
	set temp = Preloader_dumg
	if ForGroupCallback_firstFree == 0 then
		if ForGroupCallback_maxIndex < 32768 then
			set ForGroupCallback_maxIndex = ForGroupCallback_maxIndex + 1
			set this = ForGroupCallback_maxIndex
			set ForGroupCallback_typeId[this] = 657
		else
			call error("Out of memory: Could not create ForGroupCallback_forEachFrom_Preloader.")
			set this = 0
		endif
	else
		set ForGroupCallback_firstFree = ForGroupCallback_firstFree - 1
		set this = ForGroupCallback_nextFree[ForGroupCallback_firstFree]
		set ForGroupCallback_typeId[this] = 657
	endif
	call group_forEachFrom(temp, this)
	call DestroyGroup(Preloader_dumg)
	set Preloader_dumg = null
endfunction

function testFail takes string msg returns nothing
endfunction

function dispatch_CallbackSingle_ClosureTimers_CallbackSingle_call takes integer this returns nothing
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.call")
		else
			call error("Called CallbackSingle.call on invalid object.")
		endif
	endif
	if CallbackSingle_typeId[this] <= 639 then
		if CallbackSingle_typeId[this] <= 638 then
			if CallbackSingle_typeId[this] <= 637 then
				call call_doAfter_ClosureTimers(this)
			else
				set ClosureTimers_x = ClosureTimers_x + 50
			endif
		else
			set ClosureTimers_x = ClosureTimers_x * 2
		endif
	elseif CallbackSingle_typeId[this] <= 641 then
		if CallbackSingle_typeId[this] <= 640 then
			set ClosureTimers_x = ClosureTimers_x / 2
			set this = ClosureTimers_x
			if this != 250 then
				call testFail("Expected <" + I2S(250) + ">, Actual <" + I2S(this) + ">")
			endif
		else
			call DummyRecycler_recycle(u[this])
		endif
	else
		call finishPreload()
	endif
endfunction

function dispatch_Table_Table_Table_loadInt takes integer this, integer parentKey returns integer
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadInt")
		else
			call error("Called Table.loadInt on invalid object.")
		endif
	endif
	return LoadInteger(Table_ht, this, parentKey)
endfunction

function dispatch_Table_Table_Table_saveInt takes integer this, integer parentKey, integer value returns nothing
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveInt")
		else
			call error("Called Table.saveInt on invalid object.")
		endif
	endif
	call SaveInteger(Table_ht, this, parentKey, value)
endfunction

function timer_release takes timer this returns nothing
	if this == null then
		call error("Trying to release a null timer")
		return
	endif
	if dispatch_Table_Table_Table_loadInt(TimerUtils_timerData, GetHandleId(this)) == 679645218 then
		call error("ReleaseTimer: Double free!")
		return
	endif
	call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, GetHandleId(this), 679645218)
	call PauseTimer(this)
	set TimerUtils_freeTimers[TimerUtils_freeTimersCount] = this
	set TimerUtils_freeTimersCount = TimerUtils_freeTimersCount + 1
endfunction

function dispatch_CallbackSingle_destroyCallbackSingle takes integer this returns nothing
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.CallbackSingle")
		else
			call error("Called CallbackSingle.CallbackSingle on invalid object.")
		endif
	endif
	call timer_release(CallbackSingle_t[this])
	if CallbackSingle_typeId[this] == 0 then
		call error("Double free: object of type CallbackSingle")
	else
		set CallbackSingle_nextFree[CallbackSingle_firstFree] = this
		set CallbackSingle_firstFree = CallbackSingle_firstFree + 1
		set CallbackSingle_typeId[this] = 0
	endif
endfunction

function CallbackSingle_staticCallback takes nothing returns nothing
	local integer cb_1 = dispatch_Table_Table_Table_loadInt(TimerUtils_timerData, GetHandleId(GetExpiredTimer()))
	call dispatch_CallbackSingle_ClosureTimers_CallbackSingle_call(cb_1)
	call dispatch_CallbackSingle_destroyCallbackSingle(cb_1)
endfunction

function code__start_CallbackSingle_ClosureTimers takes nothing returns nothing
	call CallbackSingle_staticCallback()
endfunction

function init_AbilityIds takes nothing returns boolean
	return true
endfunction

function init_AbilityObjEditing takes nothing returns boolean
	return true
endfunction

function init_Angle takes nothing returns boolean
	return true
endfunction

function init_Basics takes nothing returns boolean
	set Basics_DUMMY_PLAYER = Player_players[PLAYER_NEUTRAL_PASSIVE]
	return true
endfunction

function initPows takes nothing returns nothing
	local integer allPows
	local integer i
	local integer temp
	set BitSet_pows[0] = 1
	set allPows = 1
	set i = 1
	set temp = 31
	loop
		exitwhen i > temp
		set BitSet_pows[i] = BitSet_pows[i - 1] * 2
		set allPows = BlzBitOr(allPows, BitSet_pows[i])
		set i = i + 1
	endloop
	set i = 0
	set temp = 31
	loop
		exitwhen i > temp
		set i = i + 1
	endloop
endfunction

function init_BitSet takes nothing returns boolean
	call initPows()
	return true
endfunction

function init_ClosureForGroups takes nothing returns boolean
	call CreateGroup()
	call Filter(ref_function_code__Filter_ClosureForGroups)
	call Rect(0., 0., 0., 0.)
	return true
endfunction

function init_ClosureTimers takes nothing returns boolean
	set ClosureTimers_x = 200
	return true
endfunction

function new_Table takes nothing returns integer
	local integer this
	if Table_firstFree == 0 then
		if Table_maxIndex < 32768 then
			set Table_maxIndex = Table_maxIndex + 1
			set this = Table_maxIndex
			set Table_typeId[this] = 731
		else
			call error("Out of memory: Could not create Table.")
			set this = 0
		endif
	else
		set Table_firstFree = Table_firstFree - 1
		set this = Table_nextFree[Table_firstFree]
		set Table_typeId[this] = 731
	endif
	return this
endfunction

function init_Colors takes nothing returns boolean
	local integer firstpart
	set Colors_hexs[0] = "0"
	set Colors_hexs[1] = "1"
	set Colors_hexs[2] = "2"
	set Colors_hexs[3] = "3"
	set Colors_hexs[4] = "4"
	set Colors_hexs[5] = "5"
	set Colors_hexs[6] = "6"
	set Colors_hexs[7] = "7"
	set Colors_hexs[8] = "8"
	set Colors_hexs[9] = "9"
	set Colors_hexs[10] = "A"
	set Colors_hexs[11] = "B"
	set Colors_hexs[12] = "C"
	set Colors_hexs[13] = "D"
	set Colors_hexs[14] = "E"
	set Colors_hexs[15] = "F"
	set Colors_decs = new_Table()
	set firstpart = 0
	loop
		exitwhen firstpart > 15
		call dispatch_Table_Table_Table_saveInt(Colors_decs, StringHash(Colors_hexs[firstpart]), firstpart)
		set firstpart = firstpart + 1
	endloop
	return true
endfunction

function init_Destructable takes nothing returns boolean
	return true
endfunction

function createDummy takes real pos_x, real pos_y, real facing_radians returns unit
	local unit u_1 = CreateUnit(Basics_DUMMY_PLAYER, 2016423985, pos_x, pos_y, facing_radians * 57.295779513)
	call UnitAddAbility(u_1, 1097691750)
	call UnitRemoveAbility(u_1, 1097691750)
	call UnitAddAbility(u_1, 1095577649)
	call UnitRemoveAbility(u_1, 1095577649)
	call SetUnitX(u_1, pos_x)
	call SetUnitY(u_1, pos_y)
	call SetUnitFacing(u_1, facing_radians * 57.295779513)
	return u_1
endfunction

function new_LinkedList takes nothing returns integer
	local integer this
	if LinkedList_firstFree == 0 then
		if LinkedList_maxIndex < 32768 then
			set LinkedList_maxIndex = LinkedList_maxIndex + 1
			set this = LinkedList_maxIndex
			set LinkedList_typeId[this] = 710
		else
			call error("Out of memory: Could not create LinkedList.")
			set this = 0
		endif
	else
		set LinkedList_firstFree = LinkedList_firstFree - 1
		set this = LinkedList_nextFree[LinkedList_firstFree]
		set LinkedList_typeId[this] = 710
	endif
	set LinkedList_dummy[this] = new_LLEntry(0, 0, 0)
	set LinkedList_size[this] = 0
	set LLEntry_prev[LinkedList_dummy[this]] = LinkedList_dummy[this]
	return this
endfunction

function init_DummyRecycler takes nothing returns boolean
	local integer i
	local integer temp
	local real facing_radians
	local integer j
	local integer temp_1
	local unit dummy
	local integer this
	local integer elem
	set DummyRecycler_ANGLE_DEGREE = 360 * 1. / 8
	set i = 0
	set temp = 7
	loop
		exitwhen i > temp
		set DummyRecycler_angleQueues[i] = new_LinkedList()
		set facing_radians = i * DummyRecycler_ANGLE_DEGREE
		set j = 0
		set temp_1 = 5
		loop
			exitwhen j > temp_1
			set dummy = createDummy(MapBounds_boundMax_x - 16., MapBounds_boundMax_y - 16., facing_radians)
			set this = DummyRecycler_angleQueues[i]
			set elem = GetHandleId(dummy)
			if LinkedList_typeId[this] == 0 then
				if this == 0 then
					call error("Nullpointer exception when calling LinkedList.enqueue")
				else
					call error("Called LinkedList.enqueue on invalid object.")
				endif
			endif
			call dispatch_LinkedList_LinkedList_LinkedList_add_1(this, elem)
			set j = j + 1
		endloop
		set i = i + 1
	endloop
	return true
endfunction

function init_Entity takes nothing returns boolean
	if Iterator_firstFree == 0 then
		if Iterator_maxIndex < 32768 then
			set Iterator_maxIndex = Iterator_maxIndex + 1
		else
			call error("Out of memory: Could not create Iterator.")
		endif
	else
		set Iterator_firstFree = Iterator_firstFree - 1
	endif
	if BackIterator_firstFree == 0 then
		if BackIterator_maxIndex < 32768 then
			set BackIterator_maxIndex = BackIterator_maxIndex + 1
		else
			call error("Out of memory: Could not create BackIterator.")
		endif
	else
		set BackIterator_firstFree = BackIterator_firstFree - 1
	endif
	set UnitEntity_dmgTrig = CreateTrigger()
	call TriggerAddAction(UnitEntity_dmgTrig, ref_function_UnitEntity_onDamage)
	return true
endfunction

function init_ErrorHandling takes nothing returns boolean
	set ErrorHandling_HT = hashtable_compiletime
	return true
endfunction

function new_HashMap takes nothing returns integer
	local integer this
	if Table_firstFree == 0 then
		if Table_maxIndex < 32768 then
			set Table_maxIndex = Table_maxIndex + 1
			set this = Table_maxIndex
			set Table_typeId[this] = 732
		else
			call error("Out of memory: Could not create HashMap.")
			set this = 0
		endif
	else
		set Table_firstFree = Table_firstFree - 1
		set this = Table_nextFree[Table_firstFree]
		set Table_typeId[this] = 732
	endif
	return this
endfunction

function init_EventHelper takes nothing returns boolean
	call new_HashMap()
	call new_HashMap()
	call new_Table()
	return true
endfunction

function verifyFrameNameLength takes string name returns boolean
	if StringLength(name) > 560 then
		call error("Trying to address frame with exceeding maximum frame name length (" + I2S(560) + ") for: " + name)
		return false
	endif
	return true
endfunction

function init_Framehandle takes nothing returns boolean
	local framehandle owner
	set Framehandle_GAME_UI = BlzGetOriginFrame(ORIGIN_FRAME_GAME_UI, 0)
	set owner = Framehandle_GAME_UI
	call verifyFrameNameLength("SetMousePositionCage")
	set owner = BlzCreateFrameByType("FRAME", "SetMousePositionCage", owner, null, 0)
	call BlzFrameSetSize(owner, 0.0001, 0.0001)
	return true
endfunction

function init_GameTimer takes nothing returns boolean
	call TimerStart(CreateTimer(), 100000., false, null)
	call TimerStart(CreateTimer(), 0.030, true, ref_function_code__startPeriodic_GameTimer)
	return true
endfunction

function init_Group takes nothing returns boolean
	call CreateGroup()
	return true
endfunction

function init_HashList takes nothing returns boolean
	return true
endfunction

function init_Icons takes nothing returns boolean
	return true
endfunction

function init_Integer takes nothing returns boolean
	return true
endfunction

function init_Lightning takes nothing returns boolean
	return true
endfunction

function init_LinkedList takes nothing returns boolean
	if Comparator_firstFree == 0 then
		if Comparator_maxIndex < 32768 then
			set Comparator_maxIndex = Comparator_maxIndex + 1
		else
			call error("Out of memory: Could not create Comparator_LinkedList.")
		endif
	else
		set Comparator_firstFree = Comparator_firstFree - 1
	endif
	if Comparator_firstFree == 0 then
		if Comparator_maxIndex < 32768 then
			set Comparator_maxIndex = Comparator_maxIndex + 1
		else
			call error("Out of memory: Could not create Comparator_LinkedList.")
		endif
	else
		set Comparator_firstFree = Comparator_firstFree - 1
	endif
	return true
endfunction

function init_MagicFunctions takes nothing returns boolean
	set MagicFunctions_compiletime = false
	return true
endfunction

function initMapBounds takes nothing returns nothing
	local rect cond_result
	local region receiver
	local real tuple_temp
	local real tuple_temp_1
	if MagicFunctions_compiletime then
		set cond_result = Rect(-1024., -1024., 1024., 1024.)
	else
		set cond_result = bj_mapInitialPlayableArea
	endif
	set MapBounds_playableMapRect = cond_result
	set receiver = CreateRegion()
	call RegionAddRect(receiver, MapBounds_playableMapRect)
	if MagicFunctions_compiletime then
		set cond_result = Rect(-1536., -1536., 1536., 1536.)
	else
		set cond_result = GetWorldBounds()
	endif
	set MapBounds_boundRect = cond_result
	set receiver = CreateRegion()
	call RegionAddRect(receiver, MapBounds_boundRect)
	set tuple_temp = GetRectMinX(MapBounds_playableMapRect)
	set tuple_temp_1 = GetRectMinY(MapBounds_playableMapRect)
	set MapBounds_playableMin_x = tuple_temp
	set MapBounds_playableMin_y = tuple_temp_1
	call GetRectMaxX(MapBounds_playableMapRect)
	call GetRectMaxY(MapBounds_playableMapRect)
	call GetRectMinX(MapBounds_boundRect)
	call GetRectMinY(MapBounds_boundRect)
	set tuple_temp_1 = GetRectMaxX(MapBounds_boundRect)
	set tuple_temp = GetRectMaxY(MapBounds_boundRect)
	set MapBounds_boundMax_x = tuple_temp_1
	set MapBounds_boundMax_y = tuple_temp
endfunction

function init_MapBounds takes nothing returns boolean
	call initMapBounds()
	return true
endfunction

function init_Maths takes nothing returns boolean
	return true
endfunction

function init_Matrices takes nothing returns boolean
	return true
endfunction

function init_ObjectIdGenerator takes nothing returns boolean
	if IdGenerator_firstFree == 0 then
		if IdGenerator_maxIndex < 32768 then
			set IdGenerator_maxIndex = IdGenerator_maxIndex + 1
		else
			call error("Out of memory: Could not create IdGenerator.")
		endif
	else
		set IdGenerator_firstFree = IdGenerator_firstFree - 1
	endif
	if IdGenerator_firstFree == 0 then
		if IdGenerator_maxIndex < 32768 then
			set IdGenerator_maxIndex = IdGenerator_maxIndex + 1
		else
			call error("Out of memory: Could not create IdGenerator.")
		endif
	else
		set IdGenerator_firstFree = IdGenerator_firstFree - 1
	endif
	if IdGenerator_firstFree == 0 then
		if IdGenerator_maxIndex < 32768 then
			set IdGenerator_maxIndex = IdGenerator_maxIndex + 1
		else
			call error("Out of memory: Could not create IdGenerator.")
		endif
	else
		set IdGenerator_firstFree = IdGenerator_firstFree - 1
	endif
	if IdGenerator_firstFree == 0 then
		if IdGenerator_maxIndex < 32768 then
			set IdGenerator_maxIndex = IdGenerator_maxIndex + 1
		else
			call error("Out of memory: Could not create IdGenerator.")
		endif
	else
		set IdGenerator_firstFree = IdGenerator_firstFree - 1
	endif
	if IdGenerator_firstFree == 0 then
		if IdGenerator_maxIndex < 32768 then
			set IdGenerator_maxIndex = IdGenerator_maxIndex + 1
		else
			call error("Out of memory: Could not create IdGenerator.")
		endif
	else
		set IdGenerator_firstFree = IdGenerator_firstFree - 1
	endif
	if IdGenerator_firstFree == 0 then
		if IdGenerator_maxIndex < 32768 then
			set IdGenerator_maxIndex = IdGenerator_maxIndex + 1
		else
			call error("Out of memory: Could not create IdGenerator.")
		endif
	else
		set IdGenerator_firstFree = IdGenerator_firstFree - 1
	endif
	return true
endfunction

function init_ObjectIds takes nothing returns boolean
	return true
endfunction

function init_Player takes nothing returns boolean
	local integer i
	local integer temp
	set Player_localPlayer = GetLocalPlayer()
	set i = 0
	set temp = bj_MAX_PLAYER_SLOTS - 1
	loop
		exitwhen i > temp
		set Player_players[i] = Player(i)
		set i = i + 1
	endloop
	return true
endfunction

function init_Playercolor takes nothing returns boolean
	return true
endfunction

function CallbackSingle_start takes integer this, timer whichTimer, real time returns nothing
	call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, GetHandleId(whichTimer), this)
	call TimerStart(whichTimer, time, false, ref_function_code__start_CallbackSingle_ClosureTimers)
	set CallbackSingle_t[this] = whichTimer
endfunction

function getTimer takes nothing returns timer
	local timer this
	if TimerUtils_freeTimersCount > 0 then
		set TimerUtils_freeTimersCount = TimerUtils_freeTimersCount - 1
		set this = TimerUtils_freeTimers[TimerUtils_freeTimersCount]
		call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, GetHandleId(this), 0)
		return TimerUtils_freeTimers[TimerUtils_freeTimersCount]
	else
		set this = CreateTimer()
		call dispatch_Table_Table_Table_saveInt(TimerUtils_timerData, GetHandleId(this), 0)
		return this
	endif
endfunction

function init_Preloader takes nothing returns boolean
	local integer this
	local timer this_1
	set Preloader_dumg = CreateGroup()
	set Preloader_dum = CreateUnit(Basics_DUMMY_PLAYER, 1970497636, MapBounds_playableMin_x, MapBounds_playableMin_y, 0.0)
	call SetUnitInvulnerable(Preloader_dum, true)
	if Preloader_dum == null then
		call error("DUMMY_UNITID not added correctly to the map.")
	endif
	if CallbackSingle_firstFree == 0 then
		if CallbackSingle_maxIndex < 32768 then
			set CallbackSingle_maxIndex = CallbackSingle_maxIndex + 1
			set this = CallbackSingle_maxIndex
			set CallbackSingle_typeId[this] = 642
		else
			call error("Out of memory: Could not create CallbackSingle_nullTimer_Preloader.")
			set this = 0
		endif
	else
		set CallbackSingle_firstFree = CallbackSingle_firstFree - 1
		set this = CallbackSingle_nextFree[CallbackSingle_firstFree]
		set CallbackSingle_typeId[this] = 642
	endif
	set this_1 = getTimer()
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.start")
		else
			call error("Called CallbackSingle.start on invalid object.")
		endif
	endif
	call CallbackSingle_start(this, this_1, 0.)
	return true
endfunction

function init_Printing takes nothing returns boolean
	return true
endfunction

function init_Quaternion takes nothing returns boolean
	return true
endfunction

function init_Real takes nothing returns boolean
	return true
endfunction

function init_SpellEnergyBarrier takes nothing returns boolean
	set ChannelData_TimedLoop_triggerCond = null
	call Condition(ref_function_ChannelData_TimedLoop_onExpire)
	return true
endfunction

function init_String takes nothing returns boolean
	return true
endfunction

function init_Table takes nothing returns boolean
	set Table_ht = hashtable_compiletime_81
	return true
endfunction

function init_TargetsAllowed takes nothing returns boolean
	return true
endfunction

function init_Terrain takes nothing returns boolean
	call Location(0., 0.)
	set Terrain_dItem = null
	call Rect(0., 0., 128., 128.)
	set Terrain_dItem = CreateItem(2003790951, 0., 0.)
	call SetItemVisible(Terrain_dItem, false)
	return true
endfunction

function init_TimedLoop takes nothing returns boolean
	call CreateTimer()
	set TimedLoop_timedLoopTrig = CreateTrigger()
	set TimedLoop_conditionCount = 0
	return true
endfunction

function init_TimerUtils takes nothing returns boolean
	set TimerUtils_timerData = new_Table()
	call new_HashMap()
	return true
endfunction

function init_TypeCasting takes nothing returns boolean
	local integer this
	set TypeCasting_typecastdata = new_Table()
	set this = TypeCasting_typecastdata
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveString")
		else
			call error("Called Table.saveString on invalid object.")
		endif
	endif
	call SaveStr(Table_ht, this, 0, "")
	return true
endfunction

function init_UnitIds takes nothing returns boolean
	return true
endfunction

function init_Vectors takes nothing returns boolean
	call Location(0., 0.)
	return true
endfunction

function init_WeatherEffects takes nothing returns boolean
	return true
endfunction

function initGlobals takes nothing returns nothing
	set ref_function_init_AbilityIds = function init_AbilityIds
	set ref_function_init_Real = function init_Real
	set ref_function_init_Integer = function init_Integer
	set ref_function_init_BitSet = function init_BitSet
	set ref_function_init_String = function init_String
	set ref_function_init_TargetsAllowed = function init_TargetsAllowed
	set ref_function_init_Angle = function init_Angle
	set ref_function_init_Vectors = function init_Vectors
	set ref_function_init_Destructable = function init_Destructable
	set ref_function_init_Player = function init_Player
	set ref_function_init_Maths = function init_Maths
	set ref_function_init_Printing = function init_Printing
	set ref_function_init_MagicFunctions = function init_MagicFunctions
	set ref_function_init_Basics = function init_Basics
	set ref_function_init_GameTimer = function init_GameTimer
	set ref_function_init_ErrorHandling = function init_ErrorHandling
	set ref_function_init_Matrices = function init_Matrices
	set ref_function_init_Quaternion = function init_Quaternion
	set ref_function_init_Table = function init_Table
	set ref_function_init_Playercolor = function init_Playercolor
	set ref_function_init_Colors = function init_Colors
	set ref_function_init_Framehandle = function init_Framehandle
	set ref_function_init_Group = function init_Group
	set ref_function_init_Lightning = function init_Lightning
	set ref_function_init_WeatherEffects = function init_WeatherEffects
	set ref_function_init_TypeCasting = function init_TypeCasting
	set ref_function_init_HashList = function init_HashList
	set ref_function_init_EventHelper = function init_EventHelper
	set ref_function_init_AbilityObjEditing = function init_AbilityObjEditing
	set ref_function_init_ClosureForGroups = function init_ClosureForGroups
	set ref_function_init_TimerUtils = function init_TimerUtils
	set ref_function_init_ClosureTimers = function init_ClosureTimers
	set ref_function_init_MapBounds = function init_MapBounds
	set ref_function_init_LinkedList = function init_LinkedList
	set ref_function_init_ObjectIds = function init_ObjectIds
	set ref_function_init_UnitIds = function init_UnitIds
	set ref_function_init_Icons = function init_Icons
	set ref_function_init_Preloader = function init_Preloader
	set ref_function_init_ObjectIdGenerator = function init_ObjectIdGenerator
	set ref_function_init_DummyRecycler = function init_DummyRecycler
	set ref_function_init_Terrain = function init_Terrain
	set ref_function_init_Entity = function init_Entity
	set ref_function_init_TimedLoop = function init_TimedLoop
	set ref_function_init_SpellEnergyBarrier = function init_SpellEnergyBarrier
	set ref_function_code__Filter_ClosureForGroups = function code__Filter_ClosureForGroups
	set ref_function_UnitEntity_onDamage = function UnitEntity_onDamage
	set ref_function_code__startPeriodic_GameTimer = function code__startPeriodic_GameTimer
	set ref_function_ChannelData_TimedLoop_onExpire = function ChannelData_TimedLoop_onExpire
	set ref_function_code__start_CallbackSingle_ClosureTimers = function code__start_CallbackSingle_ClosureTimers
endfunction

function main takes nothing returns nothing
	local trigger initTrig
	call initGlobals()
	call ExecuteFunc("initCompiletimeState_0")
	set initTrig = CreateTrigger()
	call TriggerAddCondition(initTrig, Condition(ref_function_init_AbilityIds))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package AbilityIds.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Real))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Real.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Integer))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Integer.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_BitSet))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package BitSet.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_String))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package String.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_TargetsAllowed))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TargetsAllowed.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Angle))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Angle.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Vectors))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Vectors.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Destructable))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Destructable.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Player))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Player.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Maths))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Maths.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Printing))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Printing.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_MagicFunctions))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package MagicFunctions.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Basics))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Basics.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_GameTimer))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package GameTimer.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ErrorHandling))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ErrorHandling.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Matrices))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Matrices.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Quaternion))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Quaternion.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Table))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Table.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Playercolor))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Playercolor.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Colors))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Colors.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Framehandle))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Framehandle.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Group))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Group.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Lightning))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Lightning.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_WeatherEffects))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package WeatherEffects.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_TypeCasting))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TypeCasting.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_HashList))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package HashList.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_EventHelper))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package EventHelper.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_AbilityObjEditing))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package AbilityObjEditing.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ClosureForGroups))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ClosureForGroups.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_TimerUtils))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TimerUtils.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ClosureTimers))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ClosureTimers.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_MapBounds))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package MapBounds.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_LinkedList))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package LinkedList.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ObjectIds))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ObjectIds.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_UnitIds))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package UnitIds.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Icons))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Icons.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Preloader))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Preloader.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ObjectIdGenerator))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ObjectIdGenerator.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_DummyRecycler))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package DummyRecycler.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Terrain))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Terrain.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Entity))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Entity.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_TimedLoop))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TimedLoop.")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_SpellEnergyBarrier))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package SpellEnergyBarrier.")
	endif
	call TriggerClearConditions(initTrig)
	call DestroyTrigger(initTrig)
endfunction

function config takes nothing returns nothing
endfunction

