// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer C_count=0
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_x
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function C_hasNext takes integer this returns boolean
	return C_x[this] < 10
endfunction

function C_next takes integer this returns integer
	set C_x[this] = C_x[this] + 1
	return C_x[this]
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	return this
endfunction

function C_init takes integer this returns nothing
	set C_x[this] = 0
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
	set C_count = C_count + 1
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer from = new_C()
	loop
		exitwhen  not C_hasNext(from)
		call C_next(from)
	endloop
	if C_count == 1 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

