// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
real array A_pos_x
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_A takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	local real tuple_temp
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create A.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 1
	endif
	set this = this_1
	set this_2 = this
	set tuple_temp = 1.
	set A_pos_x[this_2] = tuple_temp
	return this
endfunction

function init_test takes nothing returns nothing
	local integer a = new_A()
	local integer this = a
	local integer this_1
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo")
		else
			call error("Called A.foo on invalid object.")
		endif
	endif
	set this_1 = this
	set A_pos_x[this_1] = 3.
	if A_pos_x[a] == 3. then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

