// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer wurst_stack_depth=0
string array wurst_stack
real array C_v_x_0
real array C_v_x_1
real array C_v_x_2
real array C_v_x_3
real array C_v_x_4
real array C_v_y_0
real array C_v_y_1
real array C_v_y_2
real array C_v_y_3
real array C_v_y_4
real array C_v_z_0
real array C_v_z_1
real array C_v_z_2
real array C_v_z_3
real array C_v_z_4
endglobals
native println takes string s returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function C_v_x_get takes integer index1, integer index2, string stackPos returns real
	local real returnVal
	if index2 < 0 or index2 >= 5 then
		call error("Index out of Bounds", stackPos)
	elseif index2 <= 2 then
		if index2 <= 1 then
			if index2 <= 0 then
				set returnVal = C_v_x_0[index1]
			else
				set returnVal = C_v_x_1[index1]
			endif
		else
			set returnVal = C_v_x_2[index1]
		endif
	elseif index2 <= 3 then
		set returnVal = C_v_x_3[index1]
	else
		set returnVal = C_v_x_4[index1]
	endif
	return returnVal
endfunction

function C_v_x_set takes integer instanceId, integer arrayIndex, real value, string stackPos returns nothing
	if arrayIndex < 0 or arrayIndex >= 5 then
		call error("Index out of Bounds", stackPos)
	elseif arrayIndex <= 2 then
		if arrayIndex <= 1 then
			if arrayIndex <= 0 then
				set C_v_x_0[instanceId] = value
			else
				set C_v_x_1[instanceId] = value
			endif
		else
			set C_v_x_2[instanceId] = value
		endif
	elseif arrayIndex <= 3 then
		set C_v_x_3[instanceId] = value
	else
		set C_v_x_4[instanceId] = value
	endif
endfunction

function C_v_y_get takes integer index1, integer index2, string stackPos returns real
	local real returnVal
	if index2 < 0 or index2 >= 5 then
		call error("Index out of Bounds", stackPos)
	elseif index2 <= 2 then
		if index2 <= 1 then
			if index2 <= 0 then
				set returnVal = C_v_y_0[index1]
			else
				set returnVal = C_v_y_1[index1]
			endif
		else
			set returnVal = C_v_y_2[index1]
		endif
	elseif index2 <= 3 then
		set returnVal = C_v_y_3[index1]
	else
		set returnVal = C_v_y_4[index1]
	endif
	return returnVal
endfunction

function C_v_y_set takes integer instanceId, integer arrayIndex, real value, string stackPos returns nothing
	if arrayIndex < 0 or arrayIndex >= 5 then
		call error("Index out of Bounds", stackPos)
	elseif arrayIndex <= 2 then
		if arrayIndex <= 1 then
			if arrayIndex <= 0 then
				set C_v_y_0[instanceId] = value
			else
				set C_v_y_1[instanceId] = value
			endif
		else
			set C_v_y_2[instanceId] = value
		endif
	elseif arrayIndex <= 3 then
		set C_v_y_3[instanceId] = value
	else
		set C_v_y_4[instanceId] = value
	endif
endfunction

function C_v_z_get takes integer index1, integer index2, string stackPos returns real
	local real returnVal
	if index2 < 0 or index2 >= 5 then
		call error("Index out of Bounds", stackPos)
	elseif index2 <= 2 then
		if index2 <= 1 then
			if index2 <= 0 then
				set returnVal = C_v_z_0[index1]
			else
				set returnVal = C_v_z_1[index1]
			endif
		else
			set returnVal = C_v_z_2[index1]
		endif
	elseif index2 <= 3 then
		set returnVal = C_v_z_3[index1]
	else
		set returnVal = C_v_z_4[index1]
	endif
	return returnVal
endfunction

function C_v_z_set takes integer instanceId, integer arrayIndex, real value, string stackPos returns nothing
	if arrayIndex < 0 or arrayIndex >= 5 then
		call error("Index out of Bounds", stackPos)
	elseif arrayIndex <= 2 then
		if arrayIndex <= 1 then
			if arrayIndex <= 0 then
				set C_v_z_0[instanceId] = value
			else
				set C_v_z_1[instanceId] = value
			endif
		else
			set C_v_z_2[instanceId] = value
		endif
	elseif arrayIndex <= 3 then
		set C_v_z_3[instanceId] = value
	else
		set C_v_z_4[instanceId] = value
	endif
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling new_C in tupleArrayInClass2, line 9"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in tupleArrayInClass2, line 5"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.", "when calling error in tupleArrayInClass2, line 5")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	call C_v_x_set(this, 0, 1., "when writing array C_v_x in tupleArrayInClass2, line 10")
	call C_v_y_set(this, 0, 2., "when writing array C_v_y in tupleArrayInClass2, line 10")
	call C_v_z_set(this, 0, 3., "when writing array C_v_z in tupleArrayInClass2, line 10")
	call C_v_x_set(this, 1, 5., "when writing array C_v_x in tupleArrayInClass2, line 11")
	call C_v_y_set(this, 1, 6., "when writing array C_v_y in tupleArrayInClass2, line 12")
	call C_v_z_set(this, 1, 7., "when writing array C_v_z in tupleArrayInClass2, line 13")
	call println(R2S(C_v_x_get(this, 0, "when reading array C_v_x in  in tupleArrayInClass2, line 14")))
	call println(R2S(C_v_z_get(this, 0, "when reading array C_v_z in  in tupleArrayInClass2, line 15")))
	call println(R2S(C_v_y_get(this, 1, "when reading array C_v_y in  in tupleArrayInClass2, line 16")))
	if C_v_x_get(this, 0, "when reading array C_v_x in  in tupleArrayInClass2, line 17") == 1. and C_v_z_get(this, 0, "when reading array C_v_z in  in tupleArrayInClass2, line 17") == 3. and C_v_y_get(this, 1, "when reading array C_v_y in  in tupleArrayInClass2, line 17") == 6. then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in tupleArrayInClass2, line 1")
endfunction

function config takes nothing returns nothing
endfunction

