// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer wurst_stack_depth=0
string array wurst_stack
real array C_ang_rad_0
real array C_ang_rad_1
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function C_ang_rad_get takes integer index1, integer index2, string stackPos returns real
	local real returnVal
	if index2 < 0 or index2 >= 2 then
		call error("Index out of Bounds", stackPos)
	elseif index2 <= 0 then
		set returnVal = C_ang_rad_0[index1]
	else
		set returnVal = C_ang_rad_1[index1]
	endif
	return returnVal
endfunction

function C_ang_rad_set takes integer instanceId, integer arrayIndex, real value, string stackPos returns nothing
	if arrayIndex < 0 or arrayIndex >= 2 then
		call error("Index out of Bounds", stackPos)
	elseif arrayIndex <= 0 then
		set C_ang_rad_0[instanceId] = value
	else
		set C_ang_rad_1[instanceId] = value
	endif
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling new_C in tupleArrayInClass, line 7"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in tupleArrayInClass, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.", "when calling error in tupleArrayInClass, line 3")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	call C_ang_rad_set(this, 0, 4., "when writing array C_ang_rad in tupleArrayInClass, line 8")
	call C_ang_rad_set(this, 1, 2., "when writing array C_ang_rad in tupleArrayInClass, line 9")
	if C_ang_rad_get(this, 0, "when reading array C_ang_rad in  in tupleArrayInClass, line 10") == 4. and C_ang_rad_get(this, 1, "when reading array C_ang_rad in  in tupleArrayInClass, line 10") == 2. then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in tupleArrayInClass, line 1")
endfunction

function config takes nothing returns nothing
endfunction

