// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_v_0
integer array C_v_1
integer array C_v_2
integer array C_v_3
integer array C_v_4
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function C_v_get takes integer index1, integer index2 returns integer
	local integer returnVal
	if index2 < 0 or index2 >= 5 then
		call error("Index out of Bounds")
	elseif index2 <= 2 then
		if index2 <= 1 then
			if index2 <= 0 then
				set returnVal = C_v_0[index1]
			else
				set returnVal = C_v_1[index1]
			endif
		else
			set returnVal = C_v_2[index1]
		endif
	elseif index2 <= 3 then
		set returnVal = C_v_3[index1]
	else
		set returnVal = C_v_4[index1]
	endif
	return returnVal
endfunction

function C_v_set takes integer instanceId, integer arrayIndex, integer value returns nothing
	if arrayIndex < 0 or arrayIndex >= 5 then
		call error("Index out of Bounds")
	elseif arrayIndex <= 2 then
		if arrayIndex <= 1 then
			if arrayIndex <= 0 then
				set C_v_0[instanceId] = value
			else
				set C_v_1[instanceId] = value
			endif
		else
			set C_v_2[instanceId] = value
		endif
	elseif arrayIndex <= 3 then
		set C_v_3[instanceId] = value
	else
		set C_v_4[instanceId] = value
	endif
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this_1 = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this_1 = C_nextFree[C_firstFree]
	endif
	set this = this_1
	return this
endfunction

function main takes nothing returns nothing
	local integer c
	call initGlobals()
	set c = new_C()
	call C_v_set(c, 2, C_v_get(c, 3) + 1)
	if C_v_get(c, 2) == 1 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

