// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer wurst_stack_depth=0
string array wurst_stack
integer array C_v_0
integer array C_v_1
integer array C_v_2
integer array C_v_3
integer array C_v_4
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function C_v_get takes integer index1, integer index2, string stackPos returns integer
	local integer returnVal
	if index2 < 0 or index2 >= 5 then
		call error("Index out of Bounds", stackPos)
	elseif index2 <= 2 then
		if index2 <= 1 then
			if index2 <= 0 then
				set returnVal = C_v_0[index1]
			else
				set returnVal = C_v_1[index1]
			endif
		else
			set returnVal = C_v_2[index1]
		endif
	elseif index2 <= 3 then
		set returnVal = C_v_3[index1]
	else
		set returnVal = C_v_4[index1]
	endif
	return returnVal
endfunction

function C_v_set takes integer instanceId, integer arrayIndex, integer value, string stackPos returns nothing
	if arrayIndex < 0 or arrayIndex >= 5 then
		call error("Index out of Bounds", stackPos)
	elseif arrayIndex <= 2 then
		if arrayIndex <= 1 then
			if arrayIndex <= 0 then
				set C_v_0[instanceId] = value
			else
				set C_v_1[instanceId] = value
			endif
		else
			set C_v_2[instanceId] = value
		endif
	elseif arrayIndex <= 3 then
		set C_v_3[instanceId] = value
	else
		set C_v_4[instanceId] = value
	endif
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling new_C in multiArrayDefaultValue, line 6"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in multiArrayDefaultValue, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.", "when calling error in multiArrayDefaultValue, line 3")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	call C_v_set(this, 2, C_v_get(this, 3, "when reading array C_v in  in multiArrayDefaultValue, line 7") + 1, "when writing array C_v in multiArrayDefaultValue, line 7")
	if C_v_get(this, 2, "when reading array C_v in  in multiArrayDefaultValue, line 8") == 1 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in multiArrayDefaultValue, line 1")
endfunction

function config takes nothing returns nothing
endfunction

