// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer wurst_stack_depth=0
string array wurst_stack
integer array C_v_0
integer array C_v_1
integer array C_v_2
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function C_v_get takes integer index1, integer index2, string stackPos returns integer
	local integer returnVal
	if index2 < 0 or index2 >= 3 then
		call error("Index out of Bounds", stackPos)
	elseif index2 <= 1 then
		if index2 <= 0 then
			set returnVal = C_v_0[index1]
		else
			set returnVal = C_v_1[index1]
		endif
	else
		set returnVal = C_v_2[index1]
	endif
	return returnVal
endfunction

function initGlobals takes nothing returns nothing
endfunction

function C_v_set takes integer instanceId, integer arrayIndex, integer value, string stackPos returns nothing
	if arrayIndex < 0 or arrayIndex >= 3 then
		call error("Index out of Bounds", stackPos)
	elseif arrayIndex <= 1 then
		if arrayIndex <= 0 then
			set C_v_0[instanceId] = value
		else
			set C_v_1[instanceId] = value
		endif
	else
		set C_v_2[instanceId] = value
	endif
endfunction

function new_C takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in multiArrayInit, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.", "when calling error in multiArrayInit, line 3")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling construct_C in multiArrayInit, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling C_init in multiArrayInit, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	call C_v_set(this, 0, 7, "when writing array C_v in multiArrayInit, line 3")
	call C_v_set(this, 1, 8, "when writing array C_v in multiArrayInit, line 3")
	call C_v_set(this, 2, 9, "when writing array C_v in multiArrayInit, line 3")
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
	return this
endfunction

function main takes nothing returns nothing
	local integer c
	call initGlobals()
	set wurst_stack[wurst_stack_depth] = "when calling init_test in multiArrayInit, line 1"
	set wurst_stack_depth = wurst_stack_depth + 1
	set c = new_C("when calling new_C in multiArrayInit, line 6")
	if C_v_get(c, 0, "when reading array C_v in  in multiArrayInit, line 7") == 7 and C_v_get(c, 1, "when reading array C_v in  in multiArrayInit, line 7") == 8 and C_v_get(c, 2, "when reading array C_v in  in multiArrayInit, line 7") == 9 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function config takes nothing returns nothing
endfunction

