// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array D_c
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function destroyD takes integer this returns nothing
	local integer this_1 = this
	local integer obj
	loop
		exitwhen  not (D_c[this_1] < 4)
		set D_c[this_1] = D_c[this_1] + 1
	endloop
	call testSuccess()
	set obj = this
	if A_typeId[obj] == 0 then
		call error("Double free: object of type D")
	else
		set A_nextFree[A_firstFree] = obj
		set A_firstFree = A_firstFree + 1
		set A_typeId[obj] = 0
	endif
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_D takes integer i returns integer
	local integer this
	local integer this_1
	local integer this_2
	local integer i_1
	local integer this_3
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 4
		else
			call error("Out of memory: Could not create D.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 4
	endif
	set this = this_1
	set this_2 = this
	set i_1 = i
	set this_3 = this_2
	set D_c[this_2] = i_1
	return this
endfunction

function main takes nothing returns nothing
	local integer d
	local integer this
	call initGlobals()
	set d = new_D(0)
	set this = d
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling D.D")
		else
			call error("Called D.D on invalid object.")
		endif
	endif
	call destroyD(this)
endfunction

function config takes nothing returns nothing
endfunction

