// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_C_test_C_foo takes integer this returns integer
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.foo")
		else
			call error("Called C.foo on invalid object.")
		endif
	endif
	if C_typeId[this] <= 2 then
		set this = 3
	else
		set this = 4
	endif
	return this
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_E takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 3
		else
			call error("Out of memory: Could not create E.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 3
	endif
	return this
endfunction

function main takes nothing returns nothing
	call initGlobals()
	if dispatch_C_test_C_foo(new_E()) == 4 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

