// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_C_test_C_foo takes integer this returns integer
	local integer test_C_foo_result
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.foo")
		else
			call error("Called C.foo on invalid object.")
		endif
	endif
	if C_typeId[this] <= 2 then
		set test_C_foo_result = 3
	else
		set test_C_foo_result = 4
	endif
	return test_C_foo_result
endfunction

function new_E takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this_1 = C_maxIndex
			set C_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create E.")
			set this_1 = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this_1 = C_nextFree[C_firstFree]
		set C_typeId[this_1] = 3
	endif
	set this = this_1
	set this_2 = this
	return this
endfunction

function init_test takes nothing returns nothing
	local integer e = new_E()
	local integer this = e
	local integer test_D_bla_result
	local integer this_1
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling D.bla")
		else
			call error("Called D.bla on invalid object.")
		endif
	endif
	set this_1 = this
	set test_D_bla_result = dispatch_C_test_C_foo(this_1)
	if test_D_bla_result == 4 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

