// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_C_test_C_foo takes integer this, string w__wurst_stackPos returns integer
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.foo", "when calling error in extends_override4, line 4")
		else
			call error("Called C.foo on invalid object.", "when calling error in extends_override4, line 4")
		endif
	endif
	if C_typeId[this] <= 2 then
		set this = 3
	else
		set this = 4
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function new_E takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_E in extends_override4, line 9"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 3
		else
			call error("Out of memory: Could not create E.", "when calling error in extends_override4, line 9")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer e
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set e = new_E("when calling new_E in extends_override4, line 13")
	set wurst_stack[wurst_stack_depth] = "when calling bla in extends_override4, line 14"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_typeId[e] == 0 then
		if e == 0 then
			call error("Nullpointer exception when calling D.bla", "when calling error in extends_override4, line 7")
		else
			call error("Called D.bla on invalid object.", "when calling error in extends_override4, line 7")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling bla in extends_override4, line 7"
	set wurst_stack_depth = wurst_stack_depth + 1
	set e = dispatch_C_test_C_foo(e, "when calling foo in extends_override4, line 8")
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	if e == 4 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in extends_override4, line 1")
endfunction

function config takes nothing returns nothing
endfunction

