// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
integer array C_i
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set C_firstFree = 0
	set C_maxIndex = 0
endfunction

function D_foo takes integer this returns integer
	return C_i[this] + 1
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_D_test_D_foo takes integer this returns integer
	local integer test_D_foo_result
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling D.foo")
		else
			call error("Called D.foo on invalid object.")
		endif
	endif
	set test_D_foo_result = D_foo(this)
	return test_D_foo_result
endfunction

function alloc_D takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 2
		else
			call error("Out of memory: Could not create D.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 2
	endif
	return this
endfunction

function D_init takes integer this returns nothing
endfunction

function C_init takes integer this returns nothing
	set C_i[this] = 5
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function construct_D takes integer this returns nothing
	call construct_C(this)
	call D_init(this)
endfunction

function new_D takes nothing returns integer
	local integer this = alloc_D()
	call construct_D(this)
	return this
endfunction

function init_test takes nothing returns nothing
	if dispatch_D_test_D_foo(new_D()) == 6 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

