// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer test_x=0
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
integer array B_y
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function destroyA takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set test_x = (test_x + B_y[this]) * B_y[this]
	set wurst_stack[wurst_stack_depth] = "when calling dealloc_A in ondestroyUsingThis, line 9"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_typeId[this] == 0 then
		call error("Double free: object of type A", "when calling error in ondestroyUsingThis, line 8")
	else
		set B_nextFree[B_firstFree] = this
		set B_firstFree = B_firstFree + 1
		set B_typeId[this] = 0
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
endfunction

function new_A takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_A in ondestroyUsingThis, line 8"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create A.", "when calling error in ondestroyUsingThis, line 8")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	set B_y[this] = 2
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer a
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set test_x = 2
	set a = new_A("when calling new_A in ondestroyUsingThis, line 12")
	set wurst_stack[wurst_stack_depth] = "when calling dispatch_A_destroyA in ondestroyUsingThis, line 13"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_typeId[a] == 0 then
		if a == 0 then
			call error("Nullpointer exception when calling A.A", "when calling error in ondestroyUsingThis, line 8")
		else
			call error("Called A.A on invalid object.", "when calling error in ondestroyUsingThis, line 8")
		endif
	endif
	call destroyA(a, "when calling destroyA in ondestroyUsingThis, line 8")
	set wurst_stack_depth = wurst_stack_depth - 1
	if test_x == 8 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in ondestroyUsingThis, line 1")
endfunction

function config takes nothing returns nothing
endfunction

