// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer test_x=0
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function destroyX takes integer this returns nothing
	local integer obj
	set test_x = test_x + 1
	set test_x = test_x * 2
	set obj = this
	if B_typeId[obj] == 0 then
		call error("Double free: object of type X")
	else
		set B_nextFree[B_firstFree] = obj
		set B_firstFree = B_firstFree + 1
		set B_typeId[obj] = 0
	endif
endfunction

function dispatch_B_destroyB takes integer this returns nothing
	local integer this_1
	local integer obj
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.B")
		else
			call error("Called B.B on invalid object.")
		endif
	endif
	if B_typeId[this] <= 2 then
		set this_1 = this
		set test_x = test_x * 2
		set obj = this_1
		if B_typeId[obj] == 0 then
			call error("Double free: object of type B")
		else
			set B_nextFree[B_firstFree] = obj
			set B_firstFree = B_firstFree + 1
			set B_typeId[obj] = 0
		endif
	else
		call destroyX(this)
	endif
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_X takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this_1 = B_maxIndex
			set B_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create X.")
			set this_1 = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this_1 = B_nextFree[B_firstFree]
		set B_typeId[this_1] = 3
	endif
	set this = this_1
	set this_2 = this
	return this
endfunction

function main takes nothing returns nothing
	local integer a
	call initGlobals()
	set test_x = 2
	set a = new_X()
	call dispatch_B_destroyB(a)
	if test_x == 6 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

