// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
integer array A_b
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_test_A_get takes integer this returns integer
	local integer test_A_get_result
	local integer this_1
	local integer this_2
	local integer test_A_B_get_result
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.get")
		else
			call error("Called A.get on invalid object.")
		endif
	endif
	set this_1 = this
	set this_2 = A_b[this_1]
	if B_typeId[this_2] == 0 then
		if this_2 == 0 then
			call error("Nullpointer exception when calling B.get")
		else
			call error("Called B.get on invalid object.")
		endif
	endif
	set test_A_B_get_result = 1
	set test_A_get_result = test_A_B_get_result
	return test_A_get_result
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_B takes nothing returns integer
	local integer this
	local integer this_1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this_1 = B_maxIndex
			set B_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create B.")
			set this_1 = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this_1 = B_nextFree[B_firstFree]
		set B_typeId[this_1] = 2
	endif
	set this = this_1
	return this
endfunction

function new_A takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	local integer this_3
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create A.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 1
	endif
	set this = this_1
	set this_2 = this
	set this_3 = this_2
	set A_b[this_3] = new_B()
	return this
endfunction

function main takes nothing returns nothing
	local integer a
	call initGlobals()
	set a = new_A()
	if dispatch_A_test_A_get(a) == 1 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

