// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_test_A_foo takes integer this returns integer
	local integer test_A_foo_result
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo")
		else
			call error("Called A.foo on invalid object.")
		endif
	endif
	if A_typeId[this] <= 6 then
		if A_typeId[this] <= 1 then
			set test_A_foo_result = 7
		else
			set test_A_foo_result = 8
		endif
	else
		set test_A_foo_result = 9
	endif
	return test_A_foo_result
endfunction

function new_A takes nothing returns integer
	local integer this
	local integer this_1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create A.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 1
	endif
	set this = this_1
	return this
endfunction

function new_B11 takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	local integer this_3
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 4
		else
			call error("Out of memory: Could not create B11.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 4
	endif
	set this = this_1
	set this_2 = this
	set this_3 = this_2
	return this
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 7
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 7
	endif
	set this = this_1
	return this
endfunction

function new_C11 takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	local integer this_3
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this_1 = A_maxIndex
			set A_typeId[this_1] = 9
		else
			call error("Out of memory: Could not create C11.")
			set this_1 = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this_1 = A_nextFree[A_firstFree]
		set A_typeId[this_1] = 9
	endif
	set this = this_1
	set this_2 = this
	set this_3 = this_2
	return this
endfunction

function init_test takes nothing returns nothing
	local integer a = new_C11()
	if dispatch_A_test_A_foo(a) != 9 then
		call testFail("c11")
	endif
	set a = new_B11()
	if dispatch_A_test_A_foo(a) != 8 then
		call testFail("b11")
	endif
	set a = new_C()
	if dispatch_A_test_A_foo(a) != 9 then
		call testFail("C")
	endif
	set a = new_A()
	if dispatch_A_test_A_foo(a) != 7 then
		call testFail("A")
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

