// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_A_test_A_foo takes integer this returns integer
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.foo")
		else
			call error("Called A.foo on invalid object.")
		endif
	endif
	if A_typeId[this] <= 1 then
		set this = 7
	else
		set this = 8
	endif
	return this
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_C takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 3
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 3
	endif
	return this
endfunction

function main takes nothing returns nothing
	call initGlobals()
	if dispatch_A_test_A_foo(new_C()) == 8 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

