// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array test_cs
integer test_count=0
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
integer array C_alive
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_C_destroyC takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.C", "when calling error in recyling_random, line 8")
		else
			call error("Called C.C on invalid object.", "when calling error in recyling_random, line 8")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling destroyC in recyling_random, line 8"
	set wurst_stack_depth = wurst_stack_depth + 1
	set C_alive[this] = 2
	set wurst_stack[wurst_stack_depth] = "when calling dealloc_C in recyling_random, line 14"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_typeId[this] == 0 then
		call error("Double free: object of type C", "when calling error in recyling_random, line 8")
	else
		set C_nextFree[C_firstFree] = this
		set C_firstFree = C_firstFree + 1
		set C_typeId[this] = 0
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
endfunction

function new_C takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in recyling_random, line 10"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 1
		else
			call error("Out of memory: Could not create C.", "when calling error in recyling_random, line 8")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	if C_alive[this] == 1 then
		call testFail("already alive")
	endif
	set C_alive[this] = 1
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer i
	local integer j
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set test_count = 0
	set i = 0
	loop
		exitwhen i > 1000
		if test_count < 100 and GetRandomReal(0., 1.) <= 0.5 then
			set test_cs[test_count] = new_C("when calling new_C in recyling_random, line 21")
			set test_count = test_count + 1
		endif
		if test_count > 0 and GetRandomReal(0., 1.) <= 0.1 then
			set j = GetRandomInt(0, test_count - 1)
			call dispatch_C_destroyC(test_cs[j], "when calling dispatch_C_destroyC in recyling_random, line 25")
			set test_count = test_count - 1
			set test_cs[j] = test_cs[test_count]
		endif
		set i = i + 1
	endloop
	call testSuccess()
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in recyling_random, line 1")
endfunction

function config takes nothing returns nothing
endfunction

