// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
integer array A_M_x
integer array B_parent
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_B takes integer parent returns integer
	local integer this
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create B.")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	set B_parent[this] = parent
	return this
endfunction

function dispatch_A_test_A_M_bar takes integer this returns integer
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.bar")
		else
			call error("Called A.bar on invalid object.")
		endif
	endif
	set this = new_B(this)
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.foo")
		else
			call error("Called B.foo on invalid object.")
		endif
	endif
	set this = A_M_x[B_parent[this]]
	return this
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_A takes nothing returns integer
	local integer this
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 1
		else
			call error("Out of memory: Could not create A.")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 1
	endif
	return this
endfunction

function main takes nothing returns nothing
	local integer a
	call initGlobals()
	set a = new_A()
	set A_M_x[a] = a
	if dispatch_A_test_A_M_bar(a) == a then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

