// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array SimpleFunc_nextFree
integer SimpleFunc_firstFree=0
integer SimpleFunc_maxIndex=0
integer array SimpleFunc_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_SimpleFunc_test takes nothing returns integer
	local integer this
	if SimpleFunc_firstFree == 0 then
		if SimpleFunc_maxIndex < 32768 then
			set SimpleFunc_maxIndex = SimpleFunc_maxIndex + 1
			set this = SimpleFunc_maxIndex
			set SimpleFunc_typeId[this] = 2
		else
			call error("Out of memory: Could not create SimpleFunc_test.")
			set this = 0
		endif
	else
		set SimpleFunc_firstFree = SimpleFunc_firstFree - 1
		set this = SimpleFunc_nextFree[SimpleFunc_firstFree]
		set SimpleFunc_typeId[this] = 2
	endif
	return this
endfunction

function Test_apply takes integer this, integer x, integer y returns integer
	return x * y
endfunction

function apply_test takes integer this, integer x, integer y returns integer
	return x + y
endfunction

function dispatch_SimpleFunc_test_SimpleFunc_apply takes integer this, integer x, integer y returns integer
	if SimpleFunc_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling SimpleFunc.apply")
		else
			call error("Called SimpleFunc.apply on invalid object.")
		endif
	endif
	if SimpleFunc_typeId[this] <= 2 then
		set this = apply_test(this, x, y)
	else
		set this = Test_apply(this, x, y)
	endif
	return this
endfunction

function alloc_Test takes nothing returns integer
	local integer this
	if SimpleFunc_firstFree == 0 then
		if SimpleFunc_maxIndex < 32768 then
			set SimpleFunc_maxIndex = SimpleFunc_maxIndex + 1
			set this = SimpleFunc_maxIndex
			set SimpleFunc_typeId[this] = 3
		else
			call error("Out of memory: Could not create Test.")
			set this = 0
		endif
	else
		set SimpleFunc_firstFree = SimpleFunc_firstFree - 1
		set this = SimpleFunc_nextFree[SimpleFunc_firstFree]
		set SimpleFunc_typeId[this] = 3
	endif
	return this
endfunction

function Test_init takes integer this returns nothing
endfunction

function construct_Test takes integer this returns nothing
	call Test_init(this)
endfunction

function new_Test takes nothing returns integer
	local integer this = alloc_Test()
	call construct_Test(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer clVar = alloc_SimpleFunc_test()
	local integer g = new_Test()
	if dispatch_SimpleFunc_test_SimpleFunc_apply(clVar, 3, 4) == 7 and dispatch_SimpleFunc_test_SimpleFunc_apply(g, 3, 4) == 12 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

