// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array B_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_B_destroyB takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.B", "when calling error in testDispatch, line 3")
		else
			call error("Called B.B on invalid object.", "when calling error in testDispatch, line 3")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling destroyB in testDispatch, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling dealloc_B in testDispatch, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_typeId[this] == 0 then
		call error("Double free: object of type B", "when calling error in testDispatch, line 3")
	else
		set B_nextFree[B_firstFree] = this
		set B_firstFree = B_firstFree + 1
		set B_typeId[this] = 0
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
endfunction

function init_A takes string w__wurst_stackPos returns nothing
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_B_bar_A in testDispatch, line 8"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 3
		else
			call error("Out of memory: Could not create B_bar_A.", "when calling error in testDispatch, line 8")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling bar in testDispatch, line 8"
	set wurst_stack_depth = wurst_stack_depth + 1
	call dispatch_B_destroyB(this, "when calling dispatch_B_destroyB in testDispatch, line 6")
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_B_A in testDispatch, line 9"
	set wurst_stack_depth = wurst_stack_depth + 1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this = B_maxIndex
			set B_typeId[this] = 2
		else
			call error("Out of memory: Could not create B_A.", "when calling error in testDispatch, line 9")
			set this = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this = B_nextFree[B_firstFree]
		set B_typeId[this] = 2
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	if this == 1 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_A("when calling init_A in testDispatch, line 1")
endfunction

function config takes nothing returns nothing
endfunction

