// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array SimpleFunc_nextFree
integer SimpleFunc_firstFree=0
integer SimpleFunc_maxIndex=0
integer array SimpleFunc_typeId
real array v_x
real array v_y
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set SimpleFunc_firstFree = 0
	set SimpleFunc_maxIndex = 0
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_SimpleFunc_test takes nothing returns integer
	local integer this
	if SimpleFunc_firstFree == 0 then
		if SimpleFunc_maxIndex < 32768 then
			set SimpleFunc_maxIndex = SimpleFunc_maxIndex + 1
			set this = SimpleFunc_maxIndex
			set SimpleFunc_typeId[this] = 2
		else
			call error("Out of memory: Could not create SimpleFunc_test.")
			set this = 0
		endif
	else
		set SimpleFunc_firstFree = SimpleFunc_firstFree - 1
		set this = SimpleFunc_nextFree[SimpleFunc_firstFree]
		set SimpleFunc_typeId[this] = 2
	endif
	return this
endfunction

function call_test takes integer this returns nothing
	set v_x[this] = v_y[this]
	if v_x[this] == v_y[this] then
		call testSuccess()
	endif
endfunction

function dispatch_SimpleFunc_test_SimpleFunc_call takes integer this returns nothing
	if SimpleFunc_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling SimpleFunc.call")
		else
			call error("Called SimpleFunc.call on invalid object.")
		endif
	endif
	call call_test(this)
endfunction

function init_test takes nothing returns nothing
	local real tuple_temp = 1.
	local real tuple_temp_1 = 2.
	local real v_x_1 = tuple_temp
	local real v_y_1 = tuple_temp_1
	local integer clVar = alloc_SimpleFunc_test()
	local real tuple_temp_2 = v_x_1
	local real tuple_temp_3 = v_y_1
	local integer f
	set v_x[clVar] = tuple_temp_2
	set v_y[clVar] = tuple_temp_3
	set f = clVar
	call dispatch_SimpleFunc_test_SimpleFunc_call(f)
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

