// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Iterator_nextFree
integer Iterator_firstFree=0
integer Iterator_maxIndex=0
integer array Iterator_typeId
integer array List_nextFree
integer List_firstFree=0
integer List_maxIndex=0
integer array List_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_Iterator takes integer t returns integer
	local integer this
	local integer this_1
	if Iterator_firstFree == 0 then
		if Iterator_maxIndex < 32768 then
			set Iterator_maxIndex = Iterator_maxIndex + 1
			set this_1 = Iterator_maxIndex
			set Iterator_typeId[this_1] = 4
		else
			call error("Out of memory: Could not create Iterator.")
			set this_1 = 0
		endif
	else
		set Iterator_firstFree = Iterator_firstFree - 1
		set this_1 = Iterator_nextFree[Iterator_firstFree]
		set Iterator_typeId[this_1] = 4
	endif
	set this = this_1
	return this
endfunction

function new_List takes nothing returns integer
	local integer this
	local integer this_1
	if List_firstFree == 0 then
		if List_maxIndex < 32768 then
			set List_maxIndex = List_maxIndex + 1
			set this_1 = List_maxIndex
			set List_typeId[this_1] = 5
		else
			call error("Out of memory: Could not create List.")
			set this_1 = 0
		endif
	else
		set List_firstFree = List_firstFree - 1
		set this_1 = List_nextFree[List_firstFree]
		set List_typeId[this_1] = 5
	endif
	set this = this_1
	return this
endfunction

function init_test takes nothing returns nothing
	local integer a = new_List()
	local integer this = a
	local integer iterator
	local integer test_List_iterator_result
	local integer this_1
	local integer this_2
	local boolean test_Iterator_hasNext_result
	local integer this_3
	if List_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling List.iterator")
		else
			call error("Called List.iterator on invalid object.")
		endif
	endif
	set this_1 = this
	set test_List_iterator_result = new_Iterator(this_1)
	set iterator = test_List_iterator_result
	loop
		set this_2 = iterator
		if Iterator_typeId[this_2] == 0 then
			if this_2 == 0 then
				call error("Nullpointer exception when calling Iterator.hasNext")
			else
				call error("Called Iterator.hasNext on invalid object.")
			endif
		endif
		set test_Iterator_hasNext_result = true
		exitwhen  not test_Iterator_hasNext_result
		set this_3 = iterator
		if Iterator_typeId[this_3] == 0 then
			if this_3 == 0 then
				call error("Nullpointer exception when calling Iterator.next")
			else
				call error("Called Iterator.next on invalid object.")
			endif
		endif
		call testSuccess()
	endloop
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

