// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array Iterator_nextFree
integer Iterator_firstFree=0
integer Iterator_maxIndex=0
integer array Iterator_typeId
integer array Iterator_i
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_Iterator_destroyIterator takes integer this returns nothing
	local integer this_1
	local integer obj
	if Iterator_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Iterator.Iterator")
		else
			call error("Called Iterator.Iterator on invalid object.")
		endif
	endif
	set this_1 = this
	set obj = this_1
	if Iterator_typeId[obj] == 0 then
		call error("Double free: object of type Iterator")
	else
		set Iterator_nextFree[Iterator_firstFree] = obj
		set Iterator_firstFree = Iterator_firstFree + 1
		set Iterator_typeId[obj] = 0
	endif
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this_1 = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this_1 = C_nextFree[C_firstFree]
	endif
	set this = this_1
	return this
endfunction

function new_Iterator takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	local integer this_3
	if Iterator_firstFree == 0 then
		if Iterator_maxIndex < 32768 then
			set Iterator_maxIndex = Iterator_maxIndex + 1
			set this_1 = Iterator_maxIndex
			set Iterator_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create Iterator.")
			set this_1 = 0
		endif
	else
		set Iterator_firstFree = Iterator_firstFree - 1
		set this_1 = Iterator_nextFree[Iterator_firstFree]
		set Iterator_typeId[this_1] = 2
	endif
	set this = this_1
	set this_2 = this
	set this_3 = this_2
	set Iterator_i[this_3] = 0
	return this
endfunction

function init_test takes nothing returns nothing
	local integer iterator
	local integer i
	local integer this
	local integer this_1
	local integer this_2
	call new_C()
	set iterator = new_Iterator()
	loop
		set this = iterator
		exitwhen  not (Iterator_i[this] < 10)
		set this_1 = iterator
		set Iterator_i[this_1] = Iterator_i[this_1] + 1
		set i = Iterator_i[this_1]
		if i == 5 then
			call testSuccess()
		endif
	endloop
	set this_2 = iterator
	call dispatch_Iterator_destroyIterator(this_2)
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

