// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array FoldClosure_nextFree
integer FoldClosure_firstFree=0
integer FoldClosure_maxIndex=0
integer array FoldClosure_typeId
integer array Cell_nextFree
integer Cell_firstFree=0
integer Cell_maxIndex=0
integer array Cell_typeId
integer array Cell_elem
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_FoldClosure_test_FoldClosure_apply takes integer this, integer t, integer q returns integer
	local integer test_FoldClosure_apply_result
	local integer t_1
	local integer q_1
	local integer e_z
	local integer a
	local integer i
	local integer tuple_temp
	if FoldClosure_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling FoldClosure.apply")
		else
			call error("Called FoldClosure.apply on invalid object.")
		endif
	endif
	set t_1 = t
	set q_1 = q
	set i = t_1
	set tuple_temp = i
	set e_z = tuple_temp
	set a = q_1
	set test_FoldClosure_apply_result = e_z + a
	return test_FoldClosure_apply_result
endfunction

function new_Cell takes nothing returns integer
	local integer this
	local integer this_1
	if Cell_firstFree == 0 then
		if Cell_maxIndex < 32768 then
			set Cell_maxIndex = Cell_maxIndex + 1
			set this_1 = Cell_maxIndex
			set Cell_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create Cell.")
			set this_1 = 0
		endif
	else
		set Cell_firstFree = Cell_firstFree - 1
		set this_1 = Cell_nextFree[Cell_firstFree]
		set Cell_typeId[this_1] = 1
	endif
	set this = this_1
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_Cell()
	local integer this = c
	local integer tuple_temp = 5
	local integer b_z = tuple_temp
	local integer t = b_z
	local integer x
	local integer clVar
	local integer temp
	local integer this_1
	local integer t_1
	local integer this_2
	local integer this_3
	local integer start
	local integer f
	local integer test_Cell_fold_result
	local integer this_4
	local integer start_1
	local integer f_1
	if Cell_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Cell.set")
		else
			call error("Called Cell.set on invalid object.")
		endif
	endif
	set this_1 = this
	set t_1 = t
	set Cell_elem[this_1] = t_1
	set temp = c
	if FoldClosure_firstFree == 0 then
		if FoldClosure_maxIndex < 32768 then
			set FoldClosure_maxIndex = FoldClosure_maxIndex + 1
			set this_2 = FoldClosure_maxIndex
			set FoldClosure_typeId[this_2] = 3
		else
			call error("Out of memory: Could not create FoldClosure_fold_test.")
			set this_2 = 0
		endif
	else
		set FoldClosure_firstFree = FoldClosure_firstFree - 1
		set this_2 = FoldClosure_nextFree[FoldClosure_firstFree]
		set FoldClosure_typeId[this_2] = 3
	endif
	set clVar = this_2
	set this_3 = temp
	set start = 2
	set f = clVar
	if Cell_typeId[this_3] == 0 then
		if this_3 == 0 then
			call error("Nullpointer exception when calling Cell.fold")
		else
			call error("Called Cell.fold on invalid object.")
		endif
	endif
	set this_4 = this_3
	set start_1 = start
	set f_1 = f
	set test_Cell_fold_result = dispatch_FoldClosure_test_FoldClosure_apply(f_1, Cell_elem[this_4], start_1)
	set x = test_Cell_fold_result
	if x == 7 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

