// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array FoldClosure_nextFree
integer FoldClosure_firstFree=0
integer FoldClosure_maxIndex=0
integer array FoldClosure_typeId
integer array Cell_nextFree
integer Cell_firstFree=0
integer Cell_maxIndex=0
integer array Cell_typeId
integer array Cell_elem
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_Cell_test_Cell_fold takes integer this, integer start, integer f, string w__wurst_stackPos returns integer
	local integer t
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if Cell_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Cell.fold", "when calling error in implicitConversions3, line 11")
		else
			call error("Called Cell.fold on invalid object.", "when calling error in implicitConversions3, line 11")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling fold in implicitConversions3, line 11"
	set wurst_stack_depth = wurst_stack_depth + 1
	set t = Cell_elem[this]
	set wurst_stack[wurst_stack_depth] = "when calling apply in implicitConversions3, line 12"
	set wurst_stack_depth = wurst_stack_depth + 1
	if FoldClosure_typeId[f] == 0 then
		if f == 0 then
			call error("Nullpointer exception when calling FoldClosure.apply", "when calling error in implicitConversions3, line 4")
		else
			call error("Called FoldClosure.apply on invalid object.", "when calling error in implicitConversions3, line 4")
		endif
	endif
	set start = t + start
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
	return start
endfunction

function new_Cell takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_Cell in implicitConversions3, line 5"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Cell_firstFree == 0 then
		if Cell_maxIndex < 32768 then
			set Cell_maxIndex = Cell_maxIndex + 1
			set this = Cell_maxIndex
			set Cell_typeId[this] = 1
		else
			call error("Out of memory: Could not create Cell.", "when calling error in implicitConversions3, line 5")
			set this = 0
		endif
	else
		set Cell_firstFree = Cell_firstFree - 1
		set this = Cell_nextFree[Cell_firstFree]
		set Cell_typeId[this] = 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer c
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set c = new_Cell("when calling new_Cell in implicitConversions3, line 20")
	set wurst_stack[wurst_stack_depth] = "when calling set in implicitConversions3, line 21"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Cell_typeId[c] == 0 then
		if c == 0 then
			call error("Nullpointer exception when calling Cell.set", "when calling error in implicitConversions3, line 7")
		else
			call error("Called Cell.set on invalid object.", "when calling error in implicitConversions3, line 7")
		endif
	endif
	set Cell_elem[c] = 5
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_FoldClosure_fold_test in implicitConversions3, line 22"
	set wurst_stack_depth = wurst_stack_depth + 1
	if FoldClosure_firstFree == 0 then
		if FoldClosure_maxIndex < 32768 then
			set FoldClosure_maxIndex = FoldClosure_maxIndex + 1
			set this = FoldClosure_maxIndex
			set FoldClosure_typeId[this] = 3
		else
			call error("Out of memory: Could not create FoldClosure_fold_test.", "when calling error in implicitConversions3, line 22")
			set this = 0
		endif
	else
		set FoldClosure_firstFree = FoldClosure_firstFree - 1
		set this = FoldClosure_nextFree[FoldClosure_firstFree]
		set FoldClosure_typeId[this] = 3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	if dispatch_Cell_test_Cell_fold(c, 2, this, "when calling fold in implicitConversions3, line 22") == 7 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in implicitConversions3, line 1")
endfunction

function config takes nothing returns nothing
endfunction

