// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer test_x=0
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_I_destroyI takes integer this returns nothing
	local integer this_1
	local integer obj
	local integer this_2
	local integer obj_1
	local integer this_3
	local integer obj_2
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling I.I")
		else
			call error("Called I.I on invalid object.")
		endif
	endif
	if I_typeId[this] <= 2 then
		if I_typeId[this] <= 1 then
			set this_1 = this
			set obj = this_1
			if I_typeId[obj] == 0 then
				call error("Double free: object of type I")
			else
				set I_nextFree[I_firstFree] = obj
				set I_firstFree = I_firstFree + 1
				set I_typeId[obj] = 0
			endif
		else
			set this_2 = this
			set test_x = 1
			set obj_1 = this_2
			if I_typeId[obj_1] == 0 then
				call error("Double free: object of type B")
			else
				set I_nextFree[I_firstFree] = obj_1
				set I_firstFree = I_firstFree + 1
				set I_typeId[obj_1] = 0
			endif
		endif
	else
		set this_3 = this
		set test_x = 2
		set obj_2 = this_3
		if I_typeId[obj_2] == 0 then
			call error("Double free: object of type C")
		else
			set I_nextFree[I_firstFree] = obj_2
			set I_firstFree = I_firstFree + 1
			set I_typeId[obj_2] = 0
		endif
	endif
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this_1 = I_maxIndex
			set I_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this_1 = I_nextFree[I_firstFree]
		set I_typeId[this_1] = 3
	endif
	set this = this_1
	return this
endfunction

function main takes nothing returns nothing
	local integer i
	call initGlobals()
	set i = new_C()
	call dispatch_I_destroyI(i)
	if test_x == 2 then
		call testSuccess()
	endif
endfunction

function config takes nothing returns nothing
endfunction

