// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set I_firstFree = 0
	set I_maxIndex = 0
endfunction

function B_foo takes integer this returns integer
	return 2
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_B_test1_B_foo takes integer this returns integer
	local integer test1_B_foo_result
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.foo")
		else
			call error("Called B.foo on invalid object.")
		endif
	endif
	set test1_B_foo_result = B_foo(this)
	return test1_B_foo_result
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 3
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 3
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function B_init takes integer this returns nothing
endfunction

function construct_B takes integer this returns nothing
	call B_init(this)
endfunction

function construct_C takes integer this returns nothing
	call construct_B(this)
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function alloc_D takes nothing returns integer
	local integer this
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this = I_maxIndex
			set I_typeId[this] = 4
		else
			call error("Out of memory: Could not create D.")
			set this = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this = I_nextFree[I_firstFree]
		set I_typeId[this] = 4
	endif
	return this
endfunction

function D_init takes integer this returns nothing
endfunction

function construct_D takes integer this returns nothing
	call construct_C(this)
	call D_init(this)
endfunction

function new_D takes nothing returns integer
	local integer this = alloc_D()
	call construct_D(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c1 = new_C()
	local integer c2 = new_D()
	if dispatch_B_test1_B_foo(c1) == 2 and dispatch_B_test1_B_foo(c2) == 2 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

