// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this_1 = I_maxIndex
			set I_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this_1 = I_nextFree[I_firstFree]
		set I_typeId[this_1] = 3
	endif
	set this = this_1
	return this
endfunction

function new_D takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this_1 = I_maxIndex
			set I_typeId[this_1] = 4
		else
			call error("Out of memory: Could not create D.")
			set this_1 = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this_1 = I_nextFree[I_firstFree]
		set I_typeId[this_1] = 4
	endif
	set this = this_1
	set this_2 = this
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c1 = new_C()
	local integer c2 = new_D()
	local integer this = c1
	local integer test1_B_foo_result
	local integer this_1
	local integer test1_B_foo_result_1
	local boolean andLeft
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling B.foo")
		else
			call error("Called B.foo on invalid object.")
		endif
	endif
	set test1_B_foo_result = 2
	if test1_B_foo_result == 2 then
		set this_1 = c2
		if I_typeId[this_1] == 0 then
			if this_1 == 0 then
				call error("Nullpointer exception when calling B.foo")
			else
				call error("Called B.foo on invalid object.")
			endif
		endif
		set test1_B_foo_result_1 = 2
		set andLeft = test1_B_foo_result_1 == 2
	else
		set andLeft = false
	endif
	if andLeft then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

