// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Collection_nextFree
integer Collection_firstFree=0
integer Collection_maxIndex=0
integer array Collection_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_Set takes nothing returns integer
	local integer this
	local integer this_1
	if Collection_firstFree == 0 then
		if Collection_maxIndex < 32768 then
			set Collection_maxIndex = Collection_maxIndex + 1
			set this_1 = Collection_maxIndex
			set Collection_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create Set.")
			set this_1 = 0
		endif
	else
		set Collection_firstFree = Collection_firstFree - 1
		set this_1 = Collection_nextFree[Collection_firstFree]
		set Collection_typeId[this_1] = 2
	endif
	set this = this_1
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_Set()
	local integer this = c
	local boolean test_Collection_contains_result
	if Collection_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Collection.contains")
		else
			call error("Called Collection.contains on invalid object.")
		endif
	endif
	set test_Collection_contains_result = false
	if  not test_Collection_contains_result then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

