// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array I_nextFree
integer I_firstFree=0
integer I_maxIndex=0
integer array I_typeId
integer array B_nextFree
integer B_firstFree=0
integer B_maxIndex=0
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array D_nextFree
integer D_firstFree=0
integer D_maxIndex=0
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_A takes nothing returns integer
	local integer this
	local integer this_1
	if I_firstFree == 0 then
		if I_maxIndex < 32768 then
			set I_maxIndex = I_maxIndex + 1
			set this_1 = I_maxIndex
			set I_typeId[this_1] = 5
		else
			call error("Out of memory: Could not create A.")
			set this_1 = 0
		endif
	else
		set I_firstFree = I_firstFree - 1
		set this_1 = I_nextFree[I_firstFree]
		set I_typeId[this_1] = 5
	endif
	set this = this_1
	return this
endfunction

function new_B takes nothing returns integer
	local integer this
	local integer this_1
	if B_firstFree == 0 then
		if B_maxIndex < 32768 then
			set B_maxIndex = B_maxIndex + 1
			set this_1 = B_maxIndex
		else
			call error("Out of memory: Could not create B.")
			set this_1 = 0
		endif
	else
		set B_firstFree = B_firstFree - 1
		set this_1 = B_nextFree[B_firstFree]
	endif
	set this = this_1
	return this
endfunction

function new_C takes nothing returns integer
	local integer this
	local integer this_1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this_1 = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this_1 = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this_1 = C_nextFree[C_firstFree]
	endif
	set this = this_1
	return this
endfunction

function new_D takes nothing returns integer
	local integer this
	local integer this_1
	if D_firstFree == 0 then
		if D_maxIndex < 32768 then
			set D_maxIndex = D_maxIndex + 1
			set this_1 = D_maxIndex
		else
			call error("Out of memory: Could not create D.")
			set this_1 = 0
		endif
	else
		set D_firstFree = D_firstFree - 1
		set this_1 = D_nextFree[D_firstFree]
	endif
	set this = this_1
	return this
endfunction

function init_test takes nothing returns nothing
	local integer i = new_A()
	local integer this
	local boolean test_I_test_result
	call new_B()
	call new_C()
	call new_D()
	set this = i
	if I_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling I.test")
		else
			call error("Called I.test on invalid object.")
		endif
	endif
	set test_I_test_result = true
	if test_I_test_result then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

