// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
endglobals
native takesC takes integer c returns nothing
native takesInt takes integer i returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function testClass takes nothing returns nothing
	local integer cObj = new_C()
	local integer cInt = cObj
	call takesC(cObj)
	call takesInt(cInt)
	call takesC(cInt)
endfunction

function testEnum takes nothing returns nothing
	local integer zeroInt = 0
	call takesInt(0)
	call takesInt(zeroInt)
	call takesInt(zeroInt)
endfunction

function init_Test takes nothing returns nothing
	call testEnum()
	call testClass()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

