// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
// originframetype ORIGIN_FRAME_GAME_UI=null
// integer bj_MAX_PLAYER_SLOTS=0
integer ClosureTimers_x=0
string array Colors_hexs
integer Colors_decs=0
hashtable ErrorHandling_HT=null
framehandle Framehandle_GAME_UI=null
real GameTimer_currentTime=0.
hashtable HashList_ht=null
hashtable HashList_occurences=null
boolean MagicFunctions_compiletime=false
player array Player_players
player Player_localPlayer=null
hashtable Table_ht=null
integer Test_intMap=0
integer Test_realMap=0
integer Test_boolMap=0
integer Test_strMap=0
integer Test_unitMap=0
timer array TimerUtils_freeTimers
integer TimerUtils_freeTimersCount=0
integer TimerUtils_timerData=0
integer TypeCasting_typecastdata=0
hashtable hashtable_compiletime=null
hashtable hashtable_compiletime_41=null
hashtable hashtable_compiletime_42=null
hashtable hashtable_compiletime_43=null
integer array CallbackSingle_nextFree
integer CallbackSingle_firstFree=0
integer CallbackSingle_maxIndex=0
integer array CallbackSingle_typeId
integer Callback_firstFree=0
integer array Callback_typeId
integer array HashList_typeId
integer array Table_nextFree
integer Table_firstFree=0
integer Table_maxIndex=0
integer array Table_typeId
integer array cb
timerdialog array dia
timer array CallbackSingle_t
integer array HashList_size
integer array HashMap_size
integer array IterableMap_keys
integer wurst_stack_depth=0
string array wurst_stack
code ref_function_init_AbilityIds=null
code ref_function_init_Real=null
code ref_function_init_Integer=null
code ref_function_init_Angle=null
code ref_function_init_String=null
code ref_function_init_Vectors=null
code ref_function_init_Destructable=null
code ref_function_init_Player=null
code ref_function_init_Basics=null
code ref_function_init_MagicFunctions=null
code ref_function_init_Table=null
code ref_function_init_Playercolor=null
code ref_function_init_Maths=null
code ref_function_bridge_init_Colors=null
code ref_function_init_Printing=null
code ref_function_init_GameTimer=null
code ref_function_init_ErrorHandling=null
code ref_function_init_HashList=null
code ref_function_init_Matrices=null
code ref_function_init_Quaternion=null
code ref_function_bridge_init_Framehandle=null
code ref_function_init_Group=null
code ref_function_init_Lightning=null
code ref_function_init_WeatherEffects=null
code ref_function_bridge_init_TypeCasting=null
code ref_function_bridge_init_TimerUtils=null
code ref_function_init_ClosureTimers=null
code ref_function_bridge_init_EventHelper=null
code ref_function_bridge_init_Test=null
code ref_function_code__startPeriodic_GameTimer=null
code ref_function_bridge_code__start_CallbackSingle_ClosureTimers=null
endglobals
function Loglevel_getTag takes integer this returns string
	if this == 0 then
		return "|cffADADADtrace|r"
	elseif this == 1 then
		return "|cff2685DCdebug|r"
	elseif this == 2 then
		return "|cffFFCC00info|r"
	elseif this == 3 then
		return "|cffF47E3Ewarning|r"
	else
		return "|cffFB2700error|r"
	endif
endfunction

function compileError takes string msg returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer hash
	local integer stacktraceIndex
	local integer stacktraceLimit
	local player showTo
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if MagicFunctions_compiletime then
		call compileError("ERROR: " + msg)
	else
		set hash = StringHash(msg)
		if HaveSavedInteger(ErrorHandling_HT, -1, hash) then
			if LoadInteger(ErrorHandling_HT, -1, hash) + 60 < GameTimer_currentTime then
				set w__wurst_stackPos = msg
				set msg = ""
				set stacktraceIndex = wurst_stack_depth
				set stacktraceLimit = 0
				loop
					set stacktraceIndex = stacktraceIndex - 1
					set stacktraceLimit = stacktraceLimit + 1
					exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
					set msg = msg + "\n   " + wurst_stack[stacktraceIndex]
				endloop
				set msg = w__wurst_stackPos + msg
				set showTo = Player_localPlayer
				if 2 <= 4 then
					call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + msg)
				endif
				call SaveInteger(ErrorHandling_HT, -1, hash, R2I(GameTimer_currentTime))
				call SaveBoolean(ErrorHandling_HT, -1, hash, false)
			elseif HaveSavedBoolean(ErrorHandling_HT, -1, hash) then
				if  not LoadBoolean(ErrorHandling_HT, -1, hash) then
					set showTo = Player_localPlayer
					if 2 <= 4 then
						call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + "|cffFF3A29Excessive repeating errors are being omitted")
					endif
					call SaveBoolean(ErrorHandling_HT, -1, hash, true)
				endif
			else
				set showTo = Player_localPlayer
				if 2 <= 4 then
					call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + "|cffFF3A29Excessive repeating errors are being omitted")
				endif
				call SaveBoolean(ErrorHandling_HT, -1, hash, true)
			endif
		else
			call SaveInteger(ErrorHandling_HT, -1, hash, R2I(GameTimer_currentTime))
			set msg = "Message: " + msg
			set w__wurst_stackPos = ""
			set stacktraceIndex = wurst_stack_depth
			set hash = 0
			loop
				set stacktraceIndex = stacktraceIndex - 1
				set hash = hash + 1
				exitwhen hash > 20 or stacktraceIndex < 0
				set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
			endloop
			set msg = msg + w__wurst_stackPos
			set showTo = Player_localPlayer
			if 2 <= 4 then
				call DisplayTimedTextToPlayer(showTo, 0., 0., 45., Loglevel_getTag(4) + " - " + msg)
			endif
		endif
		call I2S(1 / 0)
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function initCompiletimeState_0 takes nothing returns nothing
	set hashtable_compiletime_43 = InitHashtable()
	set hashtable_compiletime_42 = InitHashtable()
	set hashtable_compiletime_41 = InitHashtable()
	set hashtable_compiletime = InitHashtable()
	call SaveInteger(hashtable_compiletime_43, 1, -242600650, 0)
	call SaveInteger(hashtable_compiletime_43, 1, 1132341824, 1)
	call SaveInteger(hashtable_compiletime_43, 1, -647782241, 2)
	call SaveInteger(hashtable_compiletime_43, 1, -854572045, 3)
	call SaveInteger(hashtable_compiletime_43, 1, -680649701, 4)
	call SaveInteger(hashtable_compiletime_43, 1, -943650483, 5)
	call SaveInteger(hashtable_compiletime_43, 1, -671760605, 6)
	call SaveInteger(hashtable_compiletime_43, 1, 349230650, 7)
	call SaveInteger(hashtable_compiletime_43, 1, -1894922563, 8)
	call SaveInteger(hashtable_compiletime_43, 1, -1474492777, 9)
	call SaveInteger(hashtable_compiletime_43, 1, -1587459251, 10)
	call SaveInteger(hashtable_compiletime_43, 1, -1676716706, 11)
	call SaveInteger(hashtable_compiletime_43, 1, -1559655710, 12)
	call SaveInteger(hashtable_compiletime_43, 1, -1663695754, 13)
	call SaveInteger(hashtable_compiletime_43, 1, 597637742, 14)
	call SaveInteger(hashtable_compiletime_43, 1, 789744696, 15)
	call SaveStr(hashtable_compiletime_43, 2, 0, "")
	call SaveStr(hashtable_compiletime_43, 2, -1587459251, "a")
	call SaveStr(hashtable_compiletime_43, 2, -848360345, "some string")
	call SaveInteger(hashtable_compiletime_43, 3, -1587459251, -848360345)
	call SaveInteger(hashtable_compiletime_43, 4, 4, 8)
	call SaveInteger(hashtable_compiletime_43, 5, 3775, 591530)
	call SaveInteger(hashtable_compiletime_43, 6, 1, 1)
endfunction

function timer_getData takes timer this, string w__wurst_stackPos returns integer
	local integer this_1
	local integer parentKey
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set this_1 = TimerUtils_timerData
	set parentKey = GetHandleId(this)
	set wurst_stack[wurst_stack_depth] = "when calling loadInt in TimerUtils, line 22"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this_1] == 0 then
		if this_1 == 0 then
			call error("Nullpointer exception when calling Table.loadInt", "when calling error in Table, line 40")
		else
			call error("Called Table.loadInt on invalid object.", "when calling error in Table, line 40")
		endif
	endif
	set this_1 = LoadInteger(Table_ht, this_1, parentKey)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this_1
endfunction

function timer_setData takes timer this, integer data, string w__wurst_stackPos returns nothing
	local integer this_1
	local integer parentKey
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set this_1 = TimerUtils_timerData
	set parentKey = GetHandleId(this)
	set wurst_stack[wurst_stack_depth] = "when calling saveInt in TimerUtils, line 18"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this_1] == 0 then
		if this_1 == 0 then
			call error("Nullpointer exception when calling Table.saveInt", "when calling error in Table, line 43")
		else
			call error("Called Table.saveInt on invalid object.", "when calling error in Table, line 43")
		endif
	endif
	call SaveInteger(Table_ht, this_1, parentKey, data)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
endfunction

function timer_release takes timer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if this == null then
		call error("Trying to release a null timer", "when calling error in TimerUtils, line 38")
		set wurst_stack_depth = wurst_stack_depth - 1
		return
	endif
	if timer_getData(this, "when calling getData in TimerUtils, line 40") == 679645218 then
		call error("ReleaseTimer: Double free!", "when calling error in TimerUtils, line 41")
		set wurst_stack_depth = wurst_stack_depth - 1
		return
	endif
	call timer_setData(this, 679645218, "when calling setData in TimerUtils, line 43")
	call PauseTimer(this)
	set TimerUtils_freeTimers[TimerUtils_freeTimersCount] = this
	set TimerUtils_freeTimersCount = TimerUtils_freeTimersCount + 1
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function destroyCallbackSingle takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling CallbackSingle_onDestroy in ClosureTimers, line 144"
	set wurst_stack_depth = wurst_stack_depth + 1
	call timer_release(CallbackSingle_t[this], "when calling release in ClosureTimers, line 145")
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling dealloc_CallbackSingle in ClosureTimers, line 144"
	set wurst_stack_depth = wurst_stack_depth + 1
	if CallbackSingle_typeId[this] == 0 then
		call error("Double free: object of type CallbackSingle", "when calling error in ClosureTimers, line 128")
	else
		set CallbackSingle_nextFree[CallbackSingle_firstFree] = this
		set CallbackSingle_firstFree = CallbackSingle_firstFree + 1
		set CallbackSingle_typeId[this] = 0
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
endfunction

function dispatch_Callback_destroyCallback takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if Callback_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Callback.Callback", "when calling error in ClosureTimers, line 125")
		else
			call error("Called Callback.Callback on invalid object.", "when calling error in ClosureTimers, line 125")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling destroyCallback in ClosureTimers, line 125"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling dealloc_Callback in ClosureTimers, line 125"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Callback_typeId[this] == 0 then
		call error("Double free: object of type Callback", "when calling error in ClosureTimers, line 125")
	else
		set Callback_firstFree = Callback_firstFree + 1
		set Callback_typeId[this] = 0
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
endfunction

function dispatch_HashMap_HashMap_HashMap_get takes integer this, integer key, string w__wurst_stackPos returns integer
	local integer parentKey
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashMap.get", "when calling error in HashMap, line 23")
		else
			call error("Called HashMap.get on invalid object.", "when calling error in HashMap, line 23")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling get in HashMap, line 23"
	set wurst_stack_depth = wurst_stack_depth + 1
	set parentKey = key
	set wurst_stack[wurst_stack_depth] = "when calling loadInt in HashMap, line 24"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadInt", "when calling error in Table, line 40")
		else
			call error("Called Table.loadInt on invalid object.", "when calling error in Table, line 40")
		endif
	endif
	set this = LoadInteger(Table_ht, this, parentKey)
	set wurst_stack_depth = wurst_stack_depth - 1
	set key = this
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return key
endfunction

function dispatch_HashMap_HashMap_HashMap_has takes integer this, integer key, string w__wurst_stackPos returns boolean
	local integer parentKey
	local boolean Table_Table_hasInt_result
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashMap.has", "when calling error in HashMap, line 13")
		else
			call error("Called HashMap.has on invalid object.", "when calling error in HashMap, line 13")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling has in HashMap, line 13"
	set wurst_stack_depth = wurst_stack_depth + 1
	set parentKey = key
	set wurst_stack[wurst_stack_depth] = "when calling hasInt in HashMap, line 14"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.hasInt", "when calling error in Table, line 10")
		else
			call error("Called Table.hasInt on invalid object.", "when calling error in Table, line 10")
		endif
	endif
	set Table_Table_hasInt_result = HaveSavedInteger(Table_ht, this, parentKey)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
	return Table_Table_hasInt_result
endfunction

function HashMap_put takes integer this, integer key, integer value, string w__wurst_stackPos returns nothing
	local integer parentKey
	local integer value_1
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if  not dispatch_HashMap_HashMap_HashMap_has(this, key, "when calling has in HashMap, line 18") then
		set HashMap_size[this] = HashMap_size[this] + 1
	endif
	set parentKey = key
	set value_1 = value
	set wurst_stack[wurst_stack_depth] = "when calling saveInt in HashMap, line 20"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveInt", "when calling error in Table, line 43")
		else
			call error("Called Table.saveInt on invalid object.", "when calling error in Table, line 43")
		endif
	endif
	call SaveInteger(Table_ht, this, parentKey, value_1)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
endfunction

function HashList_incrOccurences takes integer this, integer elem, string w__wurst_stackPos returns nothing
	local hashtable this_1
	local integer parentKey
	local integer childKey
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set this_1 = HashList_occurences
	set parentKey = this
	set childKey = elem
	set wurst_stack[wurst_stack_depth] = "when calling count in HashList, line 35"
	set wurst_stack_depth = wurst_stack_depth + 1
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.count", "when calling error in HashList, line 28")
		else
			call error("Called HashList.count on invalid object.", "when calling error in HashList, line 28")
		endif
	endif
	set this = LoadInteger(HashList_occurences, this, elem)
	set wurst_stack_depth = wurst_stack_depth - 1
	call SaveInteger(this_1, parentKey, childKey, this + 1)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function HashList_add_1 takes integer this, integer elems_0, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	call SaveInteger(HashList_ht, this, HashList_size[this], elems_0)
	set wurst_stack[wurst_stack_depth] = "when calling incrOccurences in HashList, line 44"
	set wurst_stack_depth = wurst_stack_depth + 1
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.incrOccurences", "when calling error in HashList, line 34")
		else
			call error("Called HashList.incrOccurences on invalid object.", "when calling error in HashList, line 34")
		endif
	endif
	call HashList_incrOccurences(this, elems_0, "when calling incrOccurences in HashList, line 34")
	set wurst_stack_depth = wurst_stack_depth - 1
	set HashList_size[this] = HashList_size[this] + 1
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_HashList_HashList_HashList_has takes integer this, integer elem, string w__wurst_stackPos returns boolean
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.has", "when calling error in HashList, line 108")
		else
			call error("Called HashList.has on invalid object.", "when calling error in HashList, line 108")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling has in HashList, line 108"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling count in HashList, line 109"
	set wurst_stack_depth = wurst_stack_depth + 1
	if HashList_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashList.count", "when calling error in HashList, line 28")
		else
			call error("Called HashList.count on invalid object.", "when calling error in HashList, line 28")
		endif
	endif
	set this = LoadInteger(HashList_occurences, this, elem)
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this > 0
endfunction

function IterableMap_put takes integer this, integer key, integer value, string w__wurst_stackPos returns nothing
	local boolean stackTrace_tempReturn
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	call HashMap_put(this, key, value, "when calling put in HashMap, line 60")
	set wurst_stack[wurst_stack_depth] = "when calling hasKey in HashMap, line 61"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling IterableMap.hasKey", "when calling error in HashMap, line 87")
		else
			call error("Called IterableMap.hasKey on invalid object.", "when calling error in HashMap, line 87")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling hasKey in HashMap, line 87"
	set wurst_stack_depth = wurst_stack_depth + 1
	set stackTrace_tempReturn = dispatch_HashList_HashList_HashList_has(IterableMap_keys[this], key, "when calling has in HashMap, line 88")
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	if  not stackTrace_tempReturn then
		set this = IterableMap_keys[this]
		set wurst_stack[wurst_stack_depth] = "when calling add in HashMap, line 62"
		set wurst_stack_depth = wurst_stack_depth + 1
		if HashList_typeId[this] == 0 then
			if this == 0 then
				call error("Nullpointer exception when calling HashList.add", "when calling error in HashList, line 41")
			else
				call error("Called HashList.add on invalid object.", "when calling error in HashList, line 41")
			endif
		endif
		call HashList_add_1(this, key, "when calling add in HashList, line 41")
		set wurst_stack_depth = wurst_stack_depth - 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_HashMap_HashMap_HashMap_put takes integer this, integer key, integer value, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling HashMap.put", "when calling error in HashMap, line 17")
		else
			call error("Called HashMap.put on invalid object.", "when calling error in HashMap, line 17")
		endif
	endif
	if Table_typeId[this] <= 24 then
		call HashMap_put(this, key, value, "when calling put in HashMap, line 17")
	else
		call IterableMap_put(this, key, value, "when calling put in HashMap, line 17")
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function stringToIndex takes string s, string w__wurst_stackPos returns integer
	local integer hash
	local integer this
	local boolean Table_Table_hasString_result
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set hash = StringHash(s)
	loop
		set this = TypeCasting_typecastdata
		set wurst_stack[wurst_stack_depth] = "when calling hasString in TypeCasting, line 26"
		set wurst_stack_depth = wurst_stack_depth + 1
		if Table_typeId[this] == 0 then
			if this == 0 then
				call error("Nullpointer exception when calling Table.hasString", "when calling error in Table, line 19")
			else
				call error("Called Table.hasString on invalid object.", "when calling error in Table, line 19")
			endif
		endif
		set Table_Table_hasString_result = HaveSavedString(Table_ht, this, hash)
		set wurst_stack_depth = wurst_stack_depth - 1
		set this = TypeCasting_typecastdata
		if Table_Table_hasString_result then
			set wurst_stack[wurst_stack_depth] = "when calling loadString in TypeCasting, line 27"
			set wurst_stack_depth = wurst_stack_depth + 1
			if Table_typeId[this] == 0 then
				if this == 0 then
					call error("Nullpointer exception when calling Table.loadString", "when calling error in Table, line 58")
				else
					call error("Called Table.loadString on invalid object.", "when calling error in Table, line 58")
				endif
			endif
			set w__wurst_stackPos = LoadStr(Table_ht, this, hash)
			set wurst_stack_depth = wurst_stack_depth - 1
			exitwhen w__wurst_stackPos == s
		else
			set wurst_stack[wurst_stack_depth] = "when calling saveString in TypeCasting, line 30"
			set wurst_stack_depth = wurst_stack_depth + 1
			if Table_typeId[this] == 0 then
				if this == 0 then
					call error("Nullpointer exception when calling Table.saveString", "when calling error in Table, line 61")
				else
					call error("Called Table.saveString on invalid object.", "when calling error in Table, line 61")
				endif
			endif
			call SaveStr(Table_ht, this, hash, s)
			set wurst_stack_depth = wurst_stack_depth - 1
			exitwhen true
		endif
		set hash = hash + 1
	endloop
	set wurst_stack_depth = wurst_stack_depth - 1
	return hash
endfunction

function unitFromIndex takes integer index, string w__wurst_stackPos returns unit
	local integer this
	local fogstate value
	local unit Table_Table_loadUnit_result
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set this = TypeCasting_typecastdata
	set value = ConvertFogState(index)
	set wurst_stack[wurst_stack_depth] = "when calling saveFogState in TypeCasting, line 53"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveFogState", "when calling error in Table, line 169")
		else
			call error("Called Table.saveFogState on invalid object.", "when calling error in Table, line 169")
		endif
	endif
	call SaveFogStateHandle(Table_ht, this, 0, value)
	set wurst_stack_depth = wurst_stack_depth - 1
	set index = TypeCasting_typecastdata
	set wurst_stack[wurst_stack_depth] = "when calling loadUnit in TypeCasting, line 54"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[index] == 0 then
		if index == 0 then
			call error("Nullpointer exception when calling Table.loadUnit", "when calling error in Table, line 76")
		else
			call error("Called Table.loadUnit on invalid object.", "when calling error in Table, line 76")
		endif
	endif
	set Table_Table_loadUnit_result = LoadUnitHandle(Table_ht, index, 0)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return Table_Table_loadUnit_result
endfunction

function foo takes string w__wurst_stackPos returns nothing
	local real r
	local boolean b
	local integer this
	local string Table_Table_loadString_result
	local unit object
	local integer temp
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	call dispatch_HashMap_HashMap_HashMap_put(Test_strMap, stringToIndex("a", "when calling stringToIndex in hashMap1, line 21"), stringToIndex("some string", "when calling stringToIndex in hashMap1, line 21"), "when calling put in hashMap1, line 21")
	set temp = dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a", "when calling stringToIndex in hashMap1, line 22"), "when calling get in hashMap1, line 22")
	set wurst_stack[wurst_stack_depth] = "when calling stringFromIndex in hashMap1, line 22"
	set wurst_stack_depth = wurst_stack_depth + 1
	set this = TypeCasting_typecastdata
	set wurst_stack[wurst_stack_depth] = "when calling loadString in TypeCasting, line 36"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadString", "when calling error in Table, line 58")
		else
			call error("Called Table.loadString on invalid object.", "when calling error in Table, line 58")
		endif
	endif
	set w__wurst_stackPos = LoadStr(Table_ht, this, temp)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., w__wurst_stackPos)
	set this = dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a", "when calling stringToIndex in hashMap1, line 23"), "when calling get in hashMap1, line 23")
	set wurst_stack[wurst_stack_depth] = "when calling stringFromIndex in hashMap1, line 23"
	set wurst_stack_depth = wurst_stack_depth + 1
	set temp = TypeCasting_typecastdata
	set wurst_stack[wurst_stack_depth] = "when calling loadString in TypeCasting, line 36"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling Table.loadString", "when calling error in Table, line 58")
		else
			call error("Called Table.loadString on invalid object.", "when calling error in Table, line 58")
		endif
	endif
	set w__wurst_stackPos = LoadStr(Table_ht, temp, this)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	set temp = dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a", "when calling stringToIndex in hashMap1, line 24"), "when calling get in hashMap1, line 24")
	set wurst_stack[wurst_stack_depth] = "when calling stringFromIndex in hashMap1, line 24"
	set wurst_stack_depth = wurst_stack_depth + 1
	set this = TypeCasting_typecastdata
	set wurst_stack[wurst_stack_depth] = "when calling loadString in TypeCasting, line 36"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadString", "when calling error in Table, line 58")
		else
			call error("Called Table.loadString on invalid object.", "when calling error in Table, line 58")
		endif
	endif
	set Table_Table_loadString_result = LoadStr(Table_ht, this, temp)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	set Table_Table_loadString_result = "hjgf" + Table_Table_loadString_result
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., Table_Table_loadString_result)
	set Table_Table_loadString_result = "hjgf" + w__wurst_stackPos
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., Table_Table_loadString_result)
	set this = dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a", "when calling stringToIndex in hashMap1, line 28"), "when calling get in hashMap1, line 28")
	set wurst_stack[wurst_stack_depth] = "when calling stringFromIndex in hashMap1, line 28"
	set wurst_stack_depth = wurst_stack_depth + 1
	set temp = TypeCasting_typecastdata
	set wurst_stack[wurst_stack_depth] = "when calling loadString in TypeCasting, line 36"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[temp] == 0 then
		if temp == 0 then
			call error("Nullpointer exception when calling Table.loadString", "when calling error in Table, line 58")
		else
			call error("Called Table.loadString on invalid object.", "when calling error in Table, line 58")
		endif
	endif
	set Table_Table_loadString_result = LoadStr(Table_ht, temp, this)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	set temp = dispatch_HashMap_HashMap_HashMap_get(Test_strMap, stringToIndex("a", "when calling stringToIndex in hashMap1, line 28"), "when calling get in hashMap1, line 28")
	set wurst_stack[wurst_stack_depth] = "when calling stringFromIndex in hashMap1, line 28"
	set wurst_stack_depth = wurst_stack_depth + 1
	set this = TypeCasting_typecastdata
	set wurst_stack[wurst_stack_depth] = "when calling loadString in TypeCasting, line 36"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.loadString", "when calling error in Table, line 58")
		else
			call error("Called Table.loadString on invalid object.", "when calling error in Table, line 58")
		endif
	endif
	set w__wurst_stackPos = LoadStr(Table_ht, this, temp)
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	set Table_Table_loadString_result = Table_Table_loadString_result + w__wurst_stackPos
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., Table_Table_loadString_result)
	if  not MagicFunctions_compiletime then
		set object = unitFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_unitMap, GetHandleId(null), "when calling get in hashMap1, line 32"), "when calling unitFromIndex in hashMap1, line 32")
		call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., GetUnitName(object))
	endif
	set this = dispatch_HashMap_HashMap_HashMap_get(Test_intMap, 0, "when calling get in hashMap1, line 34")
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., I2S(this))
	set r = dispatch_HashMap_HashMap_HashMap_get(Test_realMap, R2I(0.0), "when calling get in hashMap1, line 36") / 1000.
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., R2S(r))
	set b = dispatch_HashMap_HashMap_HashMap_get(Test_boolMap, 1, "when calling get in hashMap1, line 38") == 1
	set w__wurst_stackPos = "False"
	if b then
		set w__wurst_stackPos = "True"
	endif
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., w__wurst_stackPos)
	if  not MagicFunctions_compiletime then
		set temp = Test_unitMap
		set this = GetHandleId(null)
		set object = CreateUnit(Player_players[0], 1751543663, 0., 0., 0.0)
		call dispatch_HashMap_HashMap_HashMap_put(temp, this, GetHandleId(object), "when calling put in hashMap1, line 42")
		set object = unitFromIndex(dispatch_HashMap_HashMap_HashMap_get(Test_unitMap, GetHandleId(null), "when calling get in hashMap1, line 43"), "when calling unitFromIndex in hashMap1, line 43")
		call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., GetUnitName(object))
	endif
	call dispatch_HashMap_HashMap_HashMap_put(Test_intMap, 4, 8, "when calling put in hashMap1, line 45")
	set this = dispatch_HashMap_HashMap_HashMap_get(Test_intMap, 4, "when calling get in hashMap1, line 46")
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., I2S(this))
	call dispatch_HashMap_HashMap_HashMap_put(Test_realMap, R2I(3775.3999), R2I(591530.0), "when calling put in hashMap1, line 48")
	set r = dispatch_HashMap_HashMap_HashMap_get(Test_realMap, R2I(3775.3999), "when calling get in hashMap1, line 49") / 1000.
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., R2S(r))
	call dispatch_HashMap_HashMap_HashMap_put(Test_boolMap, 1, 1, "when calling put in hashMap1, line 51")
	set b = dispatch_HashMap_HashMap_HashMap_get(Test_boolMap, 1, "when calling get in hashMap1, line 52") == 1
	set w__wurst_stackPos = "False"
	if b then
		set w__wurst_stackPos = "True"
	endif
	call DisplayTimedTextToPlayer(Player_localPlayer, 0., 0., 45., w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function testFail takes string msg returns nothing
endfunction

function dispatch_CallbackSingle_ClosureTimers_CallbackSingle_call takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if CallbackSingle_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling CallbackSingle.call", "when calling error in ClosureTimers, line 130")
		else
			call error("Called CallbackSingle.call on invalid object.", "when calling error in ClosureTimers, line 130")
		endif
	endif
	if CallbackSingle_typeId[this] <= 10 then
		if CallbackSingle_typeId[this] <= 9 then
			if CallbackSingle_typeId[this] <= 8 then
				set wurst_stack[wurst_stack_depth] = "when calling call_doAfter_ClosureTimers in ClosureTimers, line 130"
				set wurst_stack_depth = wurst_stack_depth + 1
				call dispatch_Callback_destroyCallback(cb[this], "when calling dispatch_Callback_destroyCallback in ClosureTimers, line 44")
				call DestroyTimerDialog(dia[this])
				set wurst_stack_depth = wurst_stack_depth - 1
			else
				set ClosureTimers_x = ClosureTimers_x + 50
			endif
		else
			set ClosureTimers_x = ClosureTimers_x * 2
		endif
	elseif CallbackSingle_typeId[this] <= 11 then
		set ClosureTimers_x = ClosureTimers_x / 2
		set this = ClosureTimers_x
		if this != 250 then
			call testFail("Expected <" + I2S(250) + ">, Actual <" + I2S(this) + ">")
		endif
	else
		set wurst_stack[wurst_stack_depth] = "when calling call_doAfter_Test in ClosureTimers, line 130"
		set wurst_stack_depth = wurst_stack_depth + 1
		call foo("when calling foo in hashMap1, line 17")
		set wurst_stack_depth = wurst_stack_depth - 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function CallbackSingle_staticCallback takes string w__wurst_stackPos returns nothing
	local integer cb_1
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set cb_1 = timer_getData(GetExpiredTimer(), "when calling getData in ClosureTimers, line 140")
	call dispatch_CallbackSingle_ClosureTimers_CallbackSingle_call(cb_1, "when calling call in ClosureTimers, line 141")
	set wurst_stack[wurst_stack_depth] = "when calling dispatch_CallbackSingle_destroyCallbackSingle in ClosureTimers, line 142"
	set wurst_stack_depth = wurst_stack_depth + 1
	if CallbackSingle_typeId[cb_1] == 0 then
		if cb_1 == 0 then
			call error("Nullpointer exception when calling CallbackSingle.CallbackSingle", "when calling error in ClosureTimers, line 128")
		else
			call error("Called CallbackSingle.CallbackSingle on invalid object.", "when calling error in ClosureTimers, line 128")
		endif
	endif
	call destroyCallbackSingle(cb_1, "when calling destroyCallbackSingle in ClosureTimers, line 128")
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
endfunction

function bridge_code__start_CallbackSingle_ClosureTimers takes nothing returns nothing
	set wurst_stack_depth = 0
	set wurst_stack[wurst_stack_depth] = "via function reference ClosureTimers, line 135"
	set wurst_stack_depth = wurst_stack_depth + 1
	call CallbackSingle_staticCallback("when calling staticCallback in ClosureTimers, line 135")
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function initializeTable takes string w__wurst_stackPos returns nothing
	local integer i
	local integer this
	local integer parentKey
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set i = 0
	loop
		exitwhen i > 15
		set this = Colors_decs
		set parentKey = StringHash(Colors_hexs[i])
		set wurst_stack[wurst_stack_depth] = "when calling saveInt in Colors, line 299"
		set wurst_stack_depth = wurst_stack_depth + 1
		if Table_typeId[this] == 0 then
			if this == 0 then
				call error("Nullpointer exception when calling Table.saveInt", "when calling error in Table, line 43")
			else
				call error("Called Table.saveInt on invalid object.", "when calling error in Table, line 43")
			endif
		endif
		call SaveInteger(Table_ht, this, parentKey, i)
		set wurst_stack_depth = wurst_stack_depth - 1
		set i = i + 1
	endloop
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function new_Table takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_Table in Table, line 6"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_firstFree == 0 then
		if Table_maxIndex < 32768 then
			set Table_maxIndex = Table_maxIndex + 1
			set this = Table_maxIndex
			set Table_typeId[this] = 23
		else
			call error("Out of memory: Could not create Table.", "when calling error in Table, line 7")
			set this = 0
		endif
	else
		set Table_firstFree = Table_firstFree - 1
		set this = Table_nextFree[Table_firstFree]
		set Table_typeId[this] = 23
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_Colors takes string w__wurst_stackPos returns boolean
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set Colors_hexs[0] = "0"
	set Colors_hexs[1] = "1"
	set Colors_hexs[2] = "2"
	set Colors_hexs[3] = "3"
	set Colors_hexs[4] = "4"
	set Colors_hexs[5] = "5"
	set Colors_hexs[6] = "6"
	set Colors_hexs[7] = "7"
	set Colors_hexs[8] = "8"
	set Colors_hexs[9] = "9"
	set Colors_hexs[10] = "A"
	set Colors_hexs[11] = "B"
	set Colors_hexs[12] = "C"
	set Colors_hexs[13] = "D"
	set Colors_hexs[14] = "E"
	set Colors_hexs[15] = "F"
	set Colors_decs = new_Table("when calling new_Table in Colors, line 15")
	call initializeTable("when calling initializeTable in Colors, line 302")
	set wurst_stack_depth = wurst_stack_depth - 1
	return true
endfunction

function bridge_init_Colors takes nothing returns boolean
	set wurst_stack_depth = 0
	return init_Colors("via function reference Colors, line 1")
endfunction

function new_HashMap takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_HashMap in HashMap, line 7"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_firstFree == 0 then
		if Table_maxIndex < 32768 then
			set Table_maxIndex = Table_maxIndex + 1
			set this = Table_maxIndex
			set Table_typeId[this] = 24
		else
			call error("Out of memory: Could not create HashMap.", "when calling error in HashMap, line 8")
			set this = 0
		endif
	else
		set Table_firstFree = Table_firstFree - 1
		set this = Table_nextFree[Table_firstFree]
		set Table_typeId[this] = 24
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	set HashMap_size[this] = 0
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function bridge_init_EventHelper takes nothing returns boolean
	set wurst_stack_depth = 0
	set wurst_stack[wurst_stack_depth] = "via function reference EventHelper, line 1"
	set wurst_stack_depth = wurst_stack_depth + 1
	call new_HashMap("when calling new_HashMap in EventHelper, line 7")
	call new_HashMap("when calling new_HashMap in EventHelper, line 8")
	call new_Table("when calling new_Table in EventHelper, line 9")
	set wurst_stack_depth = wurst_stack_depth - 1
	return true
endfunction

function verifyFrameNameLength takes string name, string w__wurst_stackPos returns boolean
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if StringLength(name) > 560 then
		call error("Trying to address frame with exceeding maximum frame name length (" + I2S(560) + ") for: " + name, "when calling error in Framehandle, line 78")
		set wurst_stack_depth = wurst_stack_depth - 1
		return false
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	return true
endfunction

function init_Framehandle takes string w__wurst_stackPos returns boolean
	local framehandle owner
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set Framehandle_GAME_UI = BlzGetOriginFrame(ORIGIN_FRAME_GAME_UI, 0)
	set owner = Framehandle_GAME_UI
	set wurst_stack[wurst_stack_depth] = "when calling createFrame in Framehandle, line 491"
	set wurst_stack_depth = wurst_stack_depth + 1
	call verifyFrameNameLength("SetMousePositionCage", "when calling verifyFrameNameLength in Framehandle, line 144")
	set owner = BlzCreateFrameByType("FRAME", "SetMousePositionCage", owner, null, 0)
	set wurst_stack_depth = wurst_stack_depth - 1
	call BlzFrameSetSize(owner, 0.0001, 0.0001)
	set wurst_stack_depth = wurst_stack_depth - 1
	return true
endfunction

function bridge_init_Framehandle takes nothing returns boolean
	set wurst_stack_depth = 0
	return init_Framehandle("via function reference Framehandle, line 1")
endfunction

function CallbackSingle_start takes integer this, timer whichTimer, real time, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	call timer_setData(whichTimer, this, "when calling setData in ClosureTimers, line 134")
	call TimerStart(whichTimer, time, false, ref_function_bridge_code__start_CallbackSingle_ClosureTimers)
	set CallbackSingle_t[this] = whichTimer
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function getTimer takes string w__wurst_stackPos returns timer
	local timer receiver
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if TimerUtils_freeTimersCount > 0 then
		set TimerUtils_freeTimersCount = TimerUtils_freeTimersCount - 1
		call timer_setData(TimerUtils_freeTimers[TimerUtils_freeTimersCount], 0, "when calling setData in TimerUtils, line 30")
		set wurst_stack_depth = wurst_stack_depth - 1
		return TimerUtils_freeTimers[TimerUtils_freeTimersCount]
	else
		set receiver = CreateTimer()
		call timer_setData(receiver, 0, "when calling setData in TimerUtils, line 33")
		set wurst_stack_depth = wurst_stack_depth - 1
		return receiver
	endif
endfunction

function doAfter takes real timeToWait, integer cb_1, string w__wurst_stackPos returns integer
	local timer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set this = getTimer("when calling getTimer in ClosureTimers, line 28")
	set wurst_stack[wurst_stack_depth] = "when calling doAfter in ClosureTimers, line 28"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling start in ClosureTimers, line 17"
	set wurst_stack_depth = wurst_stack_depth + 1
	if CallbackSingle_typeId[cb_1] == 0 then
		if cb_1 == 0 then
			call error("Nullpointer exception when calling CallbackSingle.start", "when calling error in ClosureTimers, line 132")
		else
			call error("Called CallbackSingle.start on invalid object.", "when calling error in ClosureTimers, line 132")
		endif
	endif
	call CallbackSingle_start(cb_1, this, timeToWait, "when calling start in ClosureTimers, line 132")
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
	return cb_1
endfunction

function init_Test takes string w__wurst_stackPos returns boolean
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set Test_intMap = new_HashMap("when calling new_HashMap in hashMap1, line 8")
	set Test_realMap = new_HashMap("when calling new_HashMap in hashMap1, line 9")
	set Test_boolMap = new_HashMap("when calling new_HashMap in hashMap1, line 10")
	set Test_strMap = new_HashMap("when calling new_HashMap in hashMap1, line 11")
	set Test_unitMap = new_HashMap("when calling new_HashMap in hashMap1, line 12")
	call new_HashMap("when calling new_HashMap in hashMap1, line 13")
	set wurst_stack[wurst_stack_depth] = "when calling alloc_CallbackSingle_doAfter_Test in hashMap1, line 16"
	set wurst_stack_depth = wurst_stack_depth + 1
	if CallbackSingle_firstFree == 0 then
		if CallbackSingle_maxIndex < 32768 then
			set CallbackSingle_maxIndex = CallbackSingle_maxIndex + 1
			set this = CallbackSingle_maxIndex
			set CallbackSingle_typeId[this] = 12
		else
			call error("Out of memory: Could not create CallbackSingle_doAfter_Test.", "when calling error in hashMap1, line 16")
			set this = 0
		endif
	else
		set CallbackSingle_firstFree = CallbackSingle_firstFree - 1
		set this = CallbackSingle_nextFree[CallbackSingle_firstFree]
		set CallbackSingle_typeId[this] = 12
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	call doAfter(0.0, this, "when calling doAfter in hashMap1, line 16")
	set wurst_stack_depth = wurst_stack_depth - 1
	return true
endfunction

function bridge_init_Test takes nothing returns boolean
	set wurst_stack_depth = 0
	return init_Test("via function reference hashMap1, line 1")
endfunction

function bridge_init_TimerUtils takes nothing returns boolean
	set wurst_stack_depth = 0
	set wurst_stack[wurst_stack_depth] = "via function reference TimerUtils, line 1"
	set wurst_stack_depth = wurst_stack_depth + 1
	set TimerUtils_timerData = new_Table("when calling new_Table in TimerUtils, line 13")
	call new_HashMap("when calling new_HashMap in TimerUtils, line 59")
	set wurst_stack_depth = wurst_stack_depth - 1
	return true
endfunction

function init_TypeCasting takes string w__wurst_stackPos returns boolean
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set TypeCasting_typecastdata = new_Table("when calling new_Table in TypeCasting, line 7")
	set wurst_stack[wurst_stack_depth] = "when calling initTypecastData in TypeCasting, line 15"
	set wurst_stack_depth = wurst_stack_depth + 1
	set this = TypeCasting_typecastdata
	set wurst_stack[wurst_stack_depth] = "when calling saveString in TypeCasting, line 12"
	set wurst_stack_depth = wurst_stack_depth + 1
	if Table_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Table.saveString", "when calling error in Table, line 61")
		else
			call error("Called Table.saveString on invalid object.", "when calling error in Table, line 61")
		endif
	endif
	call SaveStr(Table_ht, this, 0, "")
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
	return true
endfunction

function bridge_init_TypeCasting takes nothing returns boolean
	set wurst_stack_depth = 0
	return init_TypeCasting("via function reference TypeCasting, line 1")
endfunction

function code__startPeriodic_GameTimer takes nothing returns nothing
	set GameTimer_currentTime = GameTimer_currentTime + 0.030
endfunction

function init_AbilityIds takes nothing returns boolean
	return true
endfunction

function init_Angle takes nothing returns boolean
	return true
endfunction

function init_Basics takes nothing returns boolean
	return true
endfunction

function init_ClosureTimers takes nothing returns boolean
	set ClosureTimers_x = 200
	return true
endfunction

function init_Destructable takes nothing returns boolean
	return true
endfunction

function init_ErrorHandling takes nothing returns boolean
	set ErrorHandling_HT = hashtable_compiletime_42
	return true
endfunction

function init_GameTimer takes nothing returns boolean
	call TimerStart(CreateTimer(), 100000., false, null)
	call TimerStart(CreateTimer(), 0.030, true, ref_function_code__startPeriodic_GameTimer)
	return true
endfunction

function init_Group takes nothing returns boolean
	call CreateGroup()
	return true
endfunction

function init_HashList takes nothing returns boolean
	set HashList_ht = hashtable_compiletime
	set HashList_occurences = hashtable_compiletime_41
	return true
endfunction

function init_Integer takes nothing returns boolean
	return true
endfunction

function init_Lightning takes nothing returns boolean
	return true
endfunction

function init_MagicFunctions takes nothing returns boolean
	set MagicFunctions_compiletime = false
	return true
endfunction

function init_Maths takes nothing returns boolean
	return true
endfunction

function init_Matrices takes nothing returns boolean
	return true
endfunction

function init_Player takes nothing returns boolean
	local integer i
	local integer temp
	set Player_localPlayer = GetLocalPlayer()
	set i = 0
	set temp = bj_MAX_PLAYER_SLOTS - 1
	loop
		exitwhen i > temp
		set Player_players[i] = Player(i)
		set i = i + 1
	endloop
	return true
endfunction

function init_Playercolor takes nothing returns boolean
	return true
endfunction

function init_Printing takes nothing returns boolean
	return true
endfunction

function init_Quaternion takes nothing returns boolean
	return true
endfunction

function init_Real takes nothing returns boolean
	return true
endfunction

function init_String takes nothing returns boolean
	return true
endfunction

function init_Table takes nothing returns boolean
	set Table_ht = hashtable_compiletime_43
	return true
endfunction

function init_Vectors takes nothing returns boolean
	call Location(0., 0.)
	return true
endfunction

function init_WeatherEffects takes nothing returns boolean
	return true
endfunction

function initGlobals takes nothing returns nothing
	set ref_function_init_AbilityIds = function init_AbilityIds
	set ref_function_init_Real = function init_Real
	set ref_function_init_Integer = function init_Integer
	set ref_function_init_Angle = function init_Angle
	set ref_function_init_String = function init_String
	set ref_function_init_Vectors = function init_Vectors
	set ref_function_init_Destructable = function init_Destructable
	set ref_function_init_Player = function init_Player
	set ref_function_init_Basics = function init_Basics
	set ref_function_init_MagicFunctions = function init_MagicFunctions
	set ref_function_init_Table = function init_Table
	set ref_function_init_Playercolor = function init_Playercolor
	set ref_function_init_Maths = function init_Maths
	set ref_function_bridge_init_Colors = function bridge_init_Colors
	set ref_function_init_Printing = function init_Printing
	set ref_function_init_GameTimer = function init_GameTimer
	set ref_function_init_ErrorHandling = function init_ErrorHandling
	set ref_function_init_HashList = function init_HashList
	set ref_function_init_Matrices = function init_Matrices
	set ref_function_init_Quaternion = function init_Quaternion
	set ref_function_bridge_init_Framehandle = function bridge_init_Framehandle
	set ref_function_init_Group = function init_Group
	set ref_function_init_Lightning = function init_Lightning
	set ref_function_init_WeatherEffects = function init_WeatherEffects
	set ref_function_bridge_init_TypeCasting = function bridge_init_TypeCasting
	set ref_function_bridge_init_TimerUtils = function bridge_init_TimerUtils
	set ref_function_init_ClosureTimers = function init_ClosureTimers
	set ref_function_bridge_init_EventHelper = function bridge_init_EventHelper
	set ref_function_bridge_init_Test = function bridge_init_Test
	set ref_function_code__startPeriodic_GameTimer = function code__startPeriodic_GameTimer
	set ref_function_bridge_code__start_CallbackSingle_ClosureTimers = function bridge_code__start_CallbackSingle_ClosureTimers
endfunction

function main takes nothing returns nothing
	local trigger initTrig
	call initGlobals()
	call ExecuteFunc("initCompiletimeState_0")
	set initTrig = CreateTrigger()
	call TriggerAddCondition(initTrig, Condition(ref_function_init_AbilityIds))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package AbilityIds.", "when calling error in AbilityIds, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Real))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Real.", "when calling error in Real, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Integer))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Integer.", "when calling error in Integer, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Angle))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Angle.", "when calling error in Angle, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_String))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package String.", "when calling error in String, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Vectors))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Vectors.", "when calling error in Vectors, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Destructable))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Destructable.", "when calling error in Destructable, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Player))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Player.", "when calling error in Player, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Basics))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Basics.", "when calling error in Basics, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_MagicFunctions))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package MagicFunctions.", "when calling error in MagicFunctions, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Table))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Table.", "when calling error in Table, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Playercolor))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Playercolor.", "when calling error in Playercolor, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Maths))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Maths.", "when calling error in Maths, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_bridge_init_Colors))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Colors.", "when calling error in Colors, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Printing))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Printing.", "when calling error in Printing, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_GameTimer))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package GameTimer.", "when calling error in GameTimer, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ErrorHandling))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ErrorHandling.", "when calling error in ErrorHandling, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_HashList))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package HashList.", "when calling error in HashList, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Matrices))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Matrices.", "when calling error in Matrices, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Quaternion))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Quaternion.", "when calling error in Quaternion, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_bridge_init_Framehandle))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Framehandle.", "when calling error in Framehandle, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Group))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Group.", "when calling error in Group, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_Lightning))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Lightning.", "when calling error in Lightning, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_WeatherEffects))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package WeatherEffects.", "when calling error in WeatherEffects, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_bridge_init_TypeCasting))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TypeCasting.", "when calling error in TypeCasting, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_bridge_init_TimerUtils))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package TimerUtils.", "when calling error in TimerUtils, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_init_ClosureTimers))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package ClosureTimers.", "when calling error in ClosureTimers, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_bridge_init_EventHelper))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package EventHelper.", "when calling error in EventHelper, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call TriggerAddCondition(initTrig, Condition(ref_function_bridge_init_Test))
	if  not TriggerEvaluate(initTrig) then
		call error("Could not initialize package Test.", "when calling error in hashMap1, line 1")
	endif
	call TriggerClearConditions(initTrig)
	call DestroyTrigger(initTrig)
endfunction

function config takes nothing returns nothing
endfunction

