// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array D_nextFree
integer D_firstFree=0
integer D_maxIndex=0
integer array D_typeId
integer array D_B_A_x
integer array D_C_A_x
endglobals
native println takes string s returns nothing
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function D_setX takes integer this, integer x returns nothing
	local integer x_1 = x / 2
	call println("set x " + I2S(x_1))
	set D_B_A_x[this] = x_1
	call println("get x " + I2S(D_B_A_x[this]))
	set x = x - D_B_A_x[this]
	call println("set x " + I2S(x))
	set D_C_A_x[this] = x
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_D_test_D_getX takes integer this returns integer
	local integer temp
	if D_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling D.getX")
		else
			call error("Called D.getX on invalid object.")
		endif
	endif
	call println("get x " + I2S(D_B_A_x[this]))
	set temp = D_B_A_x[this]
	call println("get x " + I2S(D_C_A_x[this]))
	return temp + D_C_A_x[this]
endfunction

function new_D takes nothing returns integer
	local integer this
	if D_firstFree == 0 then
		if D_maxIndex < 32768 then
			set D_maxIndex = D_maxIndex + 1
			set this = D_maxIndex
			set D_typeId[this] = 1
		else
			call error("Out of memory: Could not create D.")
			set this = 0
		endif
	else
		set D_firstFree = D_firstFree - 1
		set this = D_nextFree[D_firstFree]
		set D_typeId[this] = 1
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	local integer d = new_D()
	if D_typeId[d] == 0 then
		if d == 0 then
			call error("Nullpointer exception when calling D.setX")
		else
			call error("Called D.setX on invalid object.")
		endif
	endif
	call D_setX(d, 5)
	if dispatch_D_test_D_getX(d) != 5 then
		call testFail("foo fail" + I2S(dispatch_D_test_D_getX(d)))
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

