// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array D_nextFree
integer D_firstFree=0
integer D_maxIndex=0
integer array D_typeId
integer array D_B_A_x
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_D takes nothing returns integer
	local integer this
	local integer this_1
	local integer this_2
	if D_firstFree == 0 then
		if D_maxIndex < 32768 then
			set D_maxIndex = D_maxIndex + 1
			set this_1 = D_maxIndex
			set D_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create D.")
			set this_1 = 0
		endif
	else
		set D_firstFree = D_firstFree - 1
		set this_1 = D_nextFree[D_firstFree]
		set D_typeId[this_1] = 1
	endif
	set this = this_1
	set this_2 = this
	return this
endfunction

function init_test takes nothing returns nothing
	local integer d = new_D()
	local integer this = d
	local integer x = 4
	local integer this_1
	local integer x_1
	local integer this_2
	local integer x_2
	local integer this_3
	local integer test_D_getX_result
	local integer this_4
	local integer this_5
	if D_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling D.setX")
		else
			call error("Called D.setX on invalid object.")
		endif
	endif
	set this_1 = this
	set x_1 = x
	set this_2 = this_1
	set x_2 = x_1
	set D_B_A_x[this_2] = x_2
	set this_3 = d
	if D_typeId[this_3] == 0 then
		if this_3 == 0 then
			call error("Nullpointer exception when calling D.getX")
		else
			call error("Called D.getX on invalid object.")
		endif
	endif
	set this_4 = this_3
	set this_5 = this_4
	set test_D_getX_result = D_B_A_x[this_5]
	if test_D_getX_result != 4 then
		call testFail("foo fail")
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

