// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array E_nextFree
integer E_firstFree=0
integer E_maxIndex=0
integer array E_typeId
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set E_firstFree = 0
	set E_maxIndex = 0
endfunction

function E_D_C_A_bar takes integer this returns integer
	return 2
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_E_test_E_D_C_A_bar takes integer this returns integer
	local integer test_E_D_C_A_bar_result
	if E_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling E.bar")
		else
			call error("Called E.bar on invalid object.")
		endif
	endif
	set test_E_D_C_A_bar_result = E_D_C_A_bar(this)
	return test_E_D_C_A_bar_result
endfunction

function E_D_C_B_foo takes integer this returns integer
	return 3
endfunction

function dispatch_E_test_E_D_C_B_foo takes integer this returns integer
	local integer test_E_D_C_B_foo_result
	if E_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling E.foo")
		else
			call error("Called E.foo on invalid object.")
		endif
	endif
	set test_E_D_C_B_foo_result = E_D_C_B_foo(this)
	return test_E_D_C_B_foo_result
endfunction

function alloc_E takes nothing returns integer
	local integer this
	if E_firstFree == 0 then
		if E_maxIndex < 32768 then
			set E_maxIndex = E_maxIndex + 1
			set this = E_maxIndex
			set E_typeId[this] = 1
		else
			call error("Out of memory: Could not create E.")
			set this = 0
		endif
	else
		set E_firstFree = E_firstFree - 1
		set this = E_nextFree[E_firstFree]
		set E_typeId[this] = 1
	endif
	return this
endfunction

function construct_E_D_C_A takes integer this returns nothing
endfunction

function construct_E_D_C_B takes integer this returns nothing
endfunction

function construct_E_D_C takes integer this returns nothing
	call construct_E_D_C_A(this)
	call construct_E_D_C_B(this)
endfunction

function construct_E_D takes integer this returns nothing
	call construct_E_D_C(this)
endfunction

function E_init takes integer this returns nothing
	call construct_E_D(this)
endfunction

function construct_E takes integer this returns nothing
	call E_init(this)
endfunction

function new_E takes nothing returns integer
	local integer this = alloc_E()
	call construct_E(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer e = new_E()
	if dispatch_E_test_E_D_C_B_foo(e) != 3 then
		call testFail("foo fail")
	endif
	if dispatch_E_test_E_D_C_A_bar(e) != 2 then
		call testFail("bar fail")
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

