// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array E_nextFree
integer E_firstFree=0
integer E_maxIndex=0
integer array E_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function new_E takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_E in multi2.wurst, line 28"
	set wurst_stack_depth = wurst_stack_depth + 1
	if E_firstFree == 0 then
		if E_maxIndex < 32768 then
			set E_maxIndex = E_maxIndex + 1
			set this = E_maxIndex
			set E_typeId[this] = 1
		else
			call error("Out of memory: Could not create E.", "when calling error in multi2.wurst, line 28")
			set this = 0
		endif
	else
		set E_firstFree = E_firstFree - 1
		set this = E_nextFree[E_firstFree]
		set E_typeId[this] = 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer e
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set e = new_E("when calling new_E in multi2.wurst, line 34")
	set wurst_stack[wurst_stack_depth] = "when calling foo in multi2.wurst, line 38"
	set wurst_stack_depth = wurst_stack_depth + 1
	if E_typeId[e] == 0 then
		if e == 0 then
			call error("Nullpointer exception when calling E.foo", "when calling error in multi2.wurst, line 14")
		else
			call error("Called E.foo on invalid object.", "when calling error in multi2.wurst, line 14")
		endif
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	set wurst_stack[wurst_stack_depth] = "when calling bar in multi2.wurst, line 42"
	set wurst_stack_depth = wurst_stack_depth + 1
	if E_typeId[e] == 0 then
		if e == 0 then
			call error("Nullpointer exception when calling E.bar", "when calling error in multi2.wurst, line 8")
		else
			call error("Called E.bar on invalid object.", "when calling error in multi2.wurst, line 8")
		endif
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	call testSuccess()
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in multi2.wurst, line 1")
endfunction

function config takes nothing returns nothing
endfunction

