// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Iterator_nextFree
integer Iterator_firstFree=0
integer Iterator_maxIndex=0
integer array Iterator_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_Iterator takes nothing returns integer
	local integer this
	local integer this_1
	if Iterator_firstFree == 0 then
		if Iterator_maxIndex < 32768 then
			set Iterator_maxIndex = Iterator_maxIndex + 1
			set this_1 = Iterator_maxIndex
			set Iterator_typeId[this_1] = 1
		else
			call error("Out of memory: Could not create Iterator.")
			set this_1 = 0
		endif
	else
		set Iterator_firstFree = Iterator_firstFree - 1
		set this_1 = Iterator_nextFree[Iterator_firstFree]
		set Iterator_typeId[this_1] = 1
	endif
	set this = this_1
	return this
endfunction

function init_Test takes nothing returns nothing
	local integer this = new_Iterator()
	if Iterator_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Iterator.hasNext")
		else
			call error("Called Iterator.hasNext on invalid object.")
		endif
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

