// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array Iterator_nextFree
integer Iterator_firstFree=0
integer Iterator_maxIndex=0
integer array Iterator_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function alloc_Iterator takes nothing returns integer
	local integer this
	if Iterator_firstFree == 0 then
		if Iterator_maxIndex < 32768 then
			set Iterator_maxIndex = Iterator_maxIndex + 1
			set this = Iterator_maxIndex
			set Iterator_typeId[this] = 1
		else
			call error("Out of memory: Could not create Iterator.")
			set this = 0
		endif
	else
		set Iterator_firstFree = Iterator_firstFree - 1
		set this = Iterator_nextFree[Iterator_firstFree]
		set Iterator_typeId[this] = 1
	endif
	return this
endfunction

function Iterator_init takes integer this returns nothing
endfunction

function construct_Iterator takes integer this returns nothing
	call Iterator_init(this)
endfunction

function new_Iterator takes nothing returns integer
	local integer this = alloc_Iterator()
	call construct_Iterator(this)
	return this
endfunction

function MyClass_MyModule_LinkedListModule_iterator takes nothing returns integer
	return new_Iterator()
endfunction

function Iterator_hasNext takes integer this returns boolean
	return false
endfunction

function dispatch_Iterator_Test_MyClass_MyModule_LinkedListModule_Iterator_hasNext takes integer this returns boolean
	if Iterator_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling Iterator.hasNext")
		else
			call error("Called Iterator.hasNext on invalid object.")
		endif
	endif
	return Iterator_hasNext(this)
endfunction

function init_Test takes nothing returns nothing
	call dispatch_Iterator_Test_MyClass_MyModule_LinkedListModule_Iterator_hasNext(MyClass_MyModule_LinkedListModule_iterator())
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test()
endfunction

function config takes nothing returns nothing
endfunction

