// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
integer array E_nextFree
integer E_firstFree=0
integer E_maxIndex=0
integer array E_typeId
endglobals
native testSuccess takes nothing returns nothing
function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function new_D takes nothing returns integer
	local integer this
	local integer this_1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this_1 = C_maxIndex
			set C_typeId[this_1] = 2
		else
			call error("Out of memory: Could not create D.")
			set this_1 = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this_1 = C_nextFree[C_firstFree]
		set C_typeId[this_1] = 2
	endif
	set this = this_1
	return this
endfunction

function dispatch_E_Test_E_A_test takes integer this returns nothing
	local integer this_1
	if E_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling E.test")
		else
			call error("Called E.test on invalid object.")
		endif
	endif
	set this_1 = new_D()
	if C_typeId[this_1] == 0 then
		if this_1 == 0 then
			call error("Nullpointer exception when calling D.foo")
		else
			call error("Called D.foo on invalid object.")
		endif
	endif
	call testSuccess()
endfunction

function initGlobals takes nothing returns nothing
endfunction

function new_E takes nothing returns integer
	local integer this
	local integer this_1
	if E_firstFree == 0 then
		if E_maxIndex < 32768 then
			set E_maxIndex = E_maxIndex + 1
			set this_1 = E_maxIndex
			set E_typeId[this_1] = 3
		else
			call error("Out of memory: Could not create E.")
			set this_1 = 0
		endif
	else
		set E_firstFree = E_firstFree - 1
		set this_1 = E_nextFree[E_firstFree]
		set E_typeId[this_1] = 3
	endif
	set this = this_1
	return this
endfunction

function main takes nothing returns nothing
	local integer e
	call initGlobals()
	set e = new_E()
	call dispatch_E_Test_E_A_test(e)
endfunction

function config takes nothing returns nothing
endfunction

