// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
endglobals
native testFail takes string msg returns nothing
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_C_test_C_A_getBar takes integer this returns integer
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.getBar")
		else
			call error("Called C.getBar on invalid object.")
		endif
	endif
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.getFoo")
		else
			call error("Called C.getFoo on invalid object.")
		endif
	endif
	return 3
endfunction

function new_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 1
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 1
	endif
	return this
endfunction

function init_test takes nothing returns nothing
	if dispatch_C_test_C_A_getBar(new_C()) != 3 then
		call testFail("fail")
	endif
	call testSuccess()
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

