// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array A_nextFree
integer A_firstFree=0
integer A_maxIndex=0
integer array A_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_A_destroyA takes integer this, string w__wurst_stackPos returns nothing
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if A_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling A.A", "when calling error in instanceMaxCount, line 4")
		else
			call error("Called A.A on invalid object.", "when calling error in instanceMaxCount, line 4")
		endif
	endif
	set wurst_stack[wurst_stack_depth] = "when calling destroyA in instanceMaxCount, line 4"
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling dealloc_A in instanceMaxCount, line 4"
	set wurst_stack_depth = wurst_stack_depth + 1
	if A_typeId[this] == 0 then
		call error("Double free: object of type A", "when calling error in instanceMaxCount, line 4")
	else
		set A_nextFree[A_firstFree] = this
		set A_firstFree = A_firstFree + 1
		set A_typeId[this] = 0
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1 - 1
endfunction

function maxInstanceCount takes integer typeId returns integer
	return A_maxIndex
endfunction

function new_A takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_A in instanceMaxCount, line 4"
	set wurst_stack_depth = wurst_stack_depth + 1
	if A_firstFree == 0 then
		if A_maxIndex < 32768 then
			set A_maxIndex = A_maxIndex + 1
			set this = A_maxIndex
			set A_typeId[this] = 1
		else
			call error("Out of memory: Could not create A.", "when calling error in instanceMaxCount, line 4")
			set this = 0
		endif
	else
		set A_firstFree = A_firstFree - 1
		set this = A_nextFree[A_firstFree]
		set A_typeId[this] = 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_Test takes string w__wurst_stackPos returns nothing
	local integer a
	local integer e
	local integer count1
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set a = new_A("when calling new_A in instanceMaxCount, line 6")
	call new_A("when calling new_A in instanceMaxCount, line 7")
	call new_A("when calling new_A in instanceMaxCount, line 8")
	call new_A("when calling new_A in instanceMaxCount, line 9")
	set e = new_A("when calling new_A in instanceMaxCount, line 10")
	set count1 = maxInstanceCount(1)
	call dispatch_A_destroyA(a, "when calling dispatch_A_destroyA in instanceMaxCount, line 12")
	call dispatch_A_destroyA(e, "when calling dispatch_A_destroyA in instanceMaxCount, line 13")
	set e = maxInstanceCount(1)
	if count1 == 5 and e == 5 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_Test("when calling init_Test in instanceMaxCount, line 1")
endfunction

function config takes nothing returns nothing
endfunction

