// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
integer array C_x
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
	set C_firstFree = 0
	set C_maxIndex = 0
endfunction

function C_getX takes integer this returns integer
	return C_x[this]
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_C_test_C_getX takes integer this returns integer
	local integer test_C_getX_result
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.getX")
		else
			call error("Called C.getX on invalid object.")
		endif
	endif
	set test_C_getX_result = C_getX(this)
	return test_C_getX_result
endfunction

function C_setX_1 takes integer this, integer xs_0 returns nothing
	set C_x[this] = xs_0
endfunction

function dispatch_C_test_C_setX_1 takes integer this, integer xs_0 returns nothing
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.setX")
		else
			call error("Called C.setX on invalid object.")
		endif
	endif
	call C_setX_1(this, xs_0)
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 1
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 1
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function stringFromIndex takes integer i returns string
	return "42"
endfunction

function stringToIndex takes string s returns integer
	return 42
endfunction

function init_test takes nothing returns nothing
	local integer c = new_C()
	local string s
	call dispatch_C_test_C_setX_1(c, stringToIndex("42"))
	set s = stringFromIndex(dispatch_C_test_C_getX(c))
	if s == "42" then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

