// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function C_foo_2 takes integer this, integer xs_0, integer xs_1 returns integer
	return 0 + xs_0 + xs_1
endfunction

function D_foo_2 takes integer this, integer xs_0, integer xs_1 returns integer
	return 1 * xs_0 * xs_1
endfunction

function error takes string msg returns nothing
	call BJDebugMsg(msg + "\n" + "")
endfunction

function dispatch_C_test_C_foo_2 takes integer this, integer xs_0, integer xs_1 returns integer
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.foo")
		else
			call error("Called C.foo on invalid object.")
		endif
	endif
	if C_typeId[this] <= 1 then
		set this = C_foo_2(this, xs_0, xs_1)
	else
		set this = D_foo_2(this, xs_0, xs_1)
	endif
	return this
endfunction

function C_foo_4 takes integer this, integer xs_0, integer xs_1, integer xs_2, integer xs_3 returns integer
	return 0 + xs_0 + xs_1 + xs_2 + xs_3
endfunction

function D_foo_4 takes integer this, integer xs_0, integer xs_1, integer xs_2, integer xs_3 returns integer
	return 1 * xs_0 * xs_1 * xs_2 * xs_3
endfunction

function dispatch_C_test_C_foo_4 takes integer this, integer xs_0, integer xs_1, integer xs_2, integer xs_3 returns integer
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.foo")
		else
			call error("Called C.foo on invalid object.")
		endif
	endif
	if C_typeId[this] <= 1 then
		set this = C_foo_4(this, xs_0, xs_1, xs_2, xs_3)
	else
		set this = D_foo_4(this, xs_0, xs_1, xs_2, xs_3)
	endif
	return this
endfunction

function alloc_C takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 1
		else
			call error("Out of memory: Could not create C.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 1
	endif
	return this
endfunction

function C_init takes integer this returns nothing
endfunction

function construct_C takes integer this returns nothing
	call C_init(this)
endfunction

function new_C takes nothing returns integer
	local integer this = alloc_C()
	call construct_C(this)
	return this
endfunction

function alloc_D takes nothing returns integer
	local integer this
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 2
		else
			call error("Out of memory: Could not create D.")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 2
	endif
	return this
endfunction

function D_init takes integer this returns nothing
endfunction

function construct_D takes integer this returns nothing
	call construct_C(this)
	call D_init(this)
endfunction

function new_D takes nothing returns integer
	local integer this = alloc_D()
	call construct_D(this)
	return this
endfunction

function init_test takes nothing returns nothing
	local integer c = new_C()
	local integer d = new_D()
	if dispatch_C_test_C_foo_2(c, 1, 2) == 3 and dispatch_C_test_C_foo_2(d, 1, 2) == 2 and dispatch_C_test_C_foo_4(d, 1, 2, 3, 4) == 24 then
		call testSuccess()
	endif
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test()
endfunction

function config takes nothing returns nothing
endfunction

