// this script was compiled with wurst 1.8.1.0-jenkins-Wurst-1366
globals
integer array C_nextFree
integer C_firstFree=0
integer C_maxIndex=0
integer array C_typeId
integer wurst_stack_depth=0
string array wurst_stack
endglobals
native testSuccess takes nothing returns nothing
function initGlobals takes nothing returns nothing
endfunction

function error takes string msg, string w__wurst_stackPos returns nothing
	local integer stacktraceIndex
	local integer stacktraceLimit
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set w__wurst_stackPos = ""
	set stacktraceIndex = wurst_stack_depth
	set stacktraceLimit = 0
	loop
		set stacktraceIndex = stacktraceIndex - 1
		set stacktraceLimit = stacktraceLimit + 1
		exitwhen stacktraceLimit > 20 or stacktraceIndex < 0
		set w__wurst_stackPos = w__wurst_stackPos + "\n   " + wurst_stack[stacktraceIndex]
	endloop
	call BJDebugMsg(msg + "\n" + w__wurst_stackPos)
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function dispatch_C_test_C_foo_2 takes integer this, integer xs_0, integer xs_1, string w__wurst_stackPos returns integer
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.foo", "when calling error in varargOverride, line 4")
		else
			call error("Called C.foo on invalid object.", "when calling error in varargOverride, line 4")
		endif
	endif
	if C_typeId[this] <= 1 then
		set this = 0 + xs_0 + xs_1
	else
		set this = 1 * xs_0 * xs_1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function dispatch_C_test_C_foo_4 takes integer this, integer xs_0, integer xs_1, integer xs_2, integer xs_3, string w__wurst_stackPos returns integer
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_typeId[this] == 0 then
		if this == 0 then
			call error("Nullpointer exception when calling C.foo", "when calling error in varargOverride, line 4")
		else
			call error("Called C.foo on invalid object.", "when calling error in varargOverride, line 4")
		endif
	endif
	if C_typeId[this] <= 1 then
		set this = 0 + xs_0 + xs_1 + xs_2 + xs_3
	else
		set this = 1 * xs_0 * xs_1 * xs_2 * xs_3
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
	return this
endfunction

function new_C takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_C in varargOverride, line 3"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 1
		else
			call error("Out of memory: Could not create C.", "when calling error in varargOverride, line 3")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 1
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function new_D takes string w__wurst_stackPos returns integer
	local integer this
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set wurst_stack[wurst_stack_depth] = "when calling alloc_D in varargOverride, line 9"
	set wurst_stack_depth = wurst_stack_depth + 1
	if C_firstFree == 0 then
		if C_maxIndex < 32768 then
			set C_maxIndex = C_maxIndex + 1
			set this = C_maxIndex
			set C_typeId[this] = 2
		else
			call error("Out of memory: Could not create D.", "when calling error in varargOverride, line 9")
			set this = 0
		endif
	else
		set C_firstFree = C_firstFree - 1
		set this = C_nextFree[C_firstFree]
		set C_typeId[this] = 2
	endif
	set wurst_stack_depth = wurst_stack_depth - 1 - 1
	return this
endfunction

function init_test takes string w__wurst_stackPos returns nothing
	local integer c
	local integer d
	set wurst_stack[wurst_stack_depth] = w__wurst_stackPos
	set wurst_stack_depth = wurst_stack_depth + 1
	set c = new_C("when calling new_C in varargOverride, line 16")
	set d = new_D("when calling new_D in varargOverride, line 17")
	if dispatch_C_test_C_foo_2(c, 1, 2, "when calling foo in varargOverride, line 18") == 3 and dispatch_C_test_C_foo_2(d, 1, 2, "when calling foo in varargOverride, line 18") == 2 and dispatch_C_test_C_foo_4(d, 1, 2, 3, 4, "when calling foo in varargOverride, line 18") == 24 then
		call testSuccess()
	endif
	set wurst_stack_depth = wurst_stack_depth - 1
endfunction

function main takes nothing returns nothing
	call initGlobals()
	call init_test("when calling init_test in varargOverride, line 1")
endfunction

function config takes nothing returns nothing
endfunction

